;GrafX 2 low level memory routines
;(c) 1998-1999 by Stefan Goehler
;detailed copyright notices in grafx2.txt

;!! = procedures or parts which are untested yet or/and have bugs or aren't
;finished yet

.model tpascal
.386
.DATA

extrn  randseed :dword

dx1 dd ?
dy1 dd ?

.CODE
LOCALS

factor dd 8088405h

public move2_386
public move2_mmx
public backmove2_386
public backmove2_mmx
public move2screen_386
public move2screen_mmx
public movemul2screen_386
public movemul2screen_mmx

public movefromscreen_386
public movefromscreen_mmx

public fillbyte_386
public fillword_386
public fillword_mmx
public fill24_386
public filldword_386
public filldword_mmx

public fillpatt_8
public fillpatt_1516
public fillpatt_24
public fillpatt_32

public fillxor_1516_386
public fillxor_1516_mmx
public fillxor_32_386
public fillxor_24_386
public fillxor_32_mmx
public pattxor_1516
public pattxor_24_386
public pattxor_32_386
public pattxor_32_mmx

public pattadd_15
public pattadd_16
public pattadd_24_386
public pattadd_32_386
public pattadd_32_mmx
public pattsub_15
public pattsub_16
public pattsub_24_386
public pattsub_32_386
public pattsub_32_mmx

public addfill_15
public addfill_16
public addfill_24_386
public addfill_32_386
public addfill_32_mmx
public subfill_15
public subfill_16
public subfill_24_386
public subfill_32_386
public subfill_32_mmx

public calc_circle
public calc_ellipse

public getcpuid
public TestMMX
public Test3Dnow

;Array randommers - extremely fast and similar to TP7 rand
public randarray_byte
public randarray_word

public bmp8_8
public bmp8_1516
public bmp8_24
public bmp8_32

public xor2screen_386
public xor2screen_mmx
public and2screen_386
public and2screen_mmx
public or2screen_386
public or2screen_mmx

include ctmmxn.inc

move2_386 proc
arg source:pword,dest:pword,count:dword
        cld
        mov   dx,ds
        mov   ecx,count
        lds   esi,source
        les   edi,dest
        mov   eax,ecx
        shr   ecx,2
        db    67h
        rep   movsd
        mov   ecx,eax
        and   ecx,11b
        db    67h
        rep   movsb
        mov   ds,dx
        ret
move2_386 endp

move2_mmx proc
arg source:pword,dest:pword,count:dword
        cld
        les   edi,dest
        mov   dx,ds
        lds   esi,source
        mov   ecx,count
        mov   ax,cx
        shr   ecx,3
        jz    @bel8
          @move2_mmx_lp:
;          movq  mm0,ds:[esi]
  db 3Eh,67h,0Fh,6Fh,06h  ;movq mm0,ds:[esi]
          add   esi,8
  db 26h,67h,0Fh,7Fh,07h  ;movq es:[edi],mm0
;          movq  es:[edi],mm0
          add   edi,8
          dec   ecx
          jnz   @move2_mmx_lp
          emms                          ;reset to FPU mode
        @bel8:
        mov   cx,ax
        and   cx,111b
        db    67h
        rep   movsb
        mov   ds,dx
        ret
move2_mmx endp

backmove2_386 proc
arg source:pword,dest:pword,count:dword
        std
        mov   dx,ds
        mov   ecx,count
        lds   esi,source
        les   edi,dest
        add   esi,ecx                   ; calc right address fro start
        add   edi,ecx
        sub   esi,4
        sub   edi,4
        mov   ax,cx
        shr   ecx,2
        db    67h
        rep   movsd
        mov   cx,ax
        and   cx,11b
        add   esi,3
        add   edi,3
        db    67h
        rep   movsb
        mov   ds,dx
        ret
backmove2_386 endp

backmove2_mmx proc
arg source:pword,dest:pword,count:dword
        std
        mov   dx,ds
        mov   ecx,count
        les   edi,dest
        lds   esi,source
        add   edi,ecx
        add   esi,ecx
        sub   edi,8
        sub   esi,8
        mov   ax,cx
        shr   ecx,3
        jz    @backbel8
          @backmove2_mmx_lp:
;          movq  mm0,ds:[esi]
  db 3Eh,67h,0Fh,6Fh,06h  ;movq mm0,ds:[esi]
          sub   esi,8
  db 26h,67h,0Fh,7Fh,07h  ;movq es:[edi],mm0
;          movq  es:[edi],mm0
          sub   edi,8
          dec   ecx
          jnz   @backmove2_mmx_lp
          emms                          ;reset to FPU mode
        @backbel8:
        mov   cx,ax
        and   cx,111b
        add   edi,7
        add   esi,7
        db    67h
        rep   movsb
        mov   ds,dx
        ret
backmove2_mmx endp


move2screen_386 proc      ;optimized for 32-Bit address output
arg source:pword,dest:pword,count:dword
        cld
        mov   dx,ds
        lds   esi,source
        les   edi,dest
        mov   ecx,count
        mov   eax,ecx
        cmp   ecx,8
        jb    @start_m2s
        mov   ecx,edi
        and   ecx,11b
        jz    @iszero_m2s
        xor   ecx,11b
        inc   ecx
        sub   eax,ecx
        db    67h
        rep   movsb
        @iszero_m2s:
          mov   ecx,eax
        @start_m2s:
        shr   ecx,2
        db    67h
        rep   movsd
        and   eax,11b
        jz    @end_m2s
        mov   ecx,eax
        db    67h
        rep   movsb
        @end_m2s:
        mov   ds,dx
        ret
move2screen_386 endp

move2screen_mmx proc      ;optimized for 64-Bit address output and MMX
arg source:pword,dest:pword,count:dword
        cld
        mov   dx,ds
        lds   esi,source
        les   edi,dest
        mov   ecx,count
        mov   eax,ecx
        cmp   ecx,8
        jb    @start_m2smmx
        mov   ecx,edi
        and   ecx,111b
        jz    @iszero_m2smmx
        xor   ecx,111b
        inc   ecx
        sub   eax,ecx
        db    67h
        rep   movsb
        @iszero_m2smmx:
          mov   ecx,eax
        @start_m2smmx:
        shr   ecx,3
        jz    @bel8_m2smmx
          @lp_m2smmx:
          db 3Eh,67h,0Fh,6Fh,06h  ;movq mm0,ds:[esi],2 - doesn't work else
          add   esi,8
          movq  es:[edi],mm0,2
          add   edi,8
          dec   ecx
          jnz   @lp_m2smmx
        emms               ;reset
        @bel8_m2smmx:
        and   eax,111b
        jz    @end_m2smmx
        mov   ecx,eax
        db    67h
        rep   movsb
        @end_m2smmx:
        mov   ds,dx
        ret
move2screen_mmx endp

movemul2screen_386 proc      ;optimized for 32-Bit address output
arg source:pword,dest:pword,count:dword,sbpl:dword,dbpl:dword,ylines:dword
        cld
        push  ds
        lds   esi,source
        les   edi,dest
        mov   ecx,count
        mov   edx,ylines
        sub   sbpl,ecx
        sub   dbpl,ecx
        @ylp_mm2s:
          mov   ecx,count
          mov   eax,ecx
          cmp   ecx,8
          jb    @start_mm2s
          mov   ecx,edi
          and   ecx,11b
          jz    @iszero_mm2s
          xor   ecx,11b
          inc   ecx
          sub   eax,ecx
          db    67h
          rep   movsb
          @iszero_mm2s:
            mov   ecx,eax
          @start_mm2s:
          shr   ecx,2
          db    67h
          rep   movsd
          and   eax,11b
          jz    @stop_mm2s
          mov   ecx,eax
          db    67h
          rep   movsb
          @stop_mm2s:
          add   esi,sbpl
          add   edi,dbpl
          dec   edx
          jnz   @ylp_mm2s
        @end_mm2s:
        pop   ds
        ret
movemul2screen_386 endp

movemul2screen_mmx proc      ;optimized for 64-Bit address output and MMX
arg source:pword,dest:pword,count:dword,sbpl:dword,dbpl:dword,ylines:dword
        cld
        push  ds
        lds   esi,source
        les   edi,dest
        mov   ecx,count
        mov   edx,ylines
        sub   sbpl,ecx
        sub   dbpl,ecx
        @ylp_mm2smx:

          mov   ecx,count
          mov   eax,ecx
          cmp   ecx,8
          jb    @start_mm2smx
          mov   ecx,edi
          and   ecx,111b
          jz    @iszero_mm2smx
          xor   ecx,111b
          inc   ecx
          sub   eax,ecx
          db    67h
          rep   movsb
          @iszero_mm2smx:
            mov   ecx,eax
          @start_mm2smx:
          shr   ecx,3
          jz    @bel8_mm2smx
            @lp_mm2smx:
            db 3Eh,67h,0Fh,6Fh,06h  ;movq mm0,ds:[esi],2 - doesn't work else
            add   esi,8
            movq  es:[edi],mm0,2
            add   edi,8
            dec   ecx
            jnz   @lp_mm2smx
          @bel8_mm2smx:
          and   eax,111b
          jz    @stop_mm2smx
          mov   ecx,eax
          db    67h
          rep   movsb
          @stop_mm2smx:
          add   esi,sbpl
          add   edi,dbpl
          dec   edx
          jnz   @ylp_mm2smx

        @end_mm2smx:
        emms
        pop   ds
        ret
movemul2screen_mmx endp

movefromscreen_386 proc
arg source:pword,dest:pword,count:dword
        cld
        mov   dx,ds
        lds   esi,source
        les   edi,dest
        mov   ecx,count
        mov   eax,ecx
        cmp   ecx,8
        jb    @start_mfs
        mov   ecx,esi
        and   ecx,11b
        jz    @iszero_mfs
        xor   ecx,11b
        inc   ecx
        sub   eax,ecx
        db    67h
        rep   movsb
        @iszero_mfs:
          mov   ecx,eax
        @start_mfs:
        shr   ecx,2
        db    67h
        rep   movsd
        and   eax,11b
        jz    @end_mfs
        mov   ecx,eax
        db    67h
        rep   movsb
        @end_mfs:
        mov   ds,dx
        ret
movefromscreen_386 endp

movefromscreen_mmx proc      ;optimized for 64-Bit address input and MMX
arg source:pword,dest:pword,count:dword
        cld
        mov   dx,ds
        lds   esi,source
        les   edi,dest
        mov   ecx,count
        mov   eax,ecx
        cmp   ecx,8
        jb    @start_mfsmmx
        mov   ecx,esi
        and   ecx,111b
        jz    @iszero_mfsmmx
        xor   ecx,111b
        inc   ecx
        sub   eax,ecx
        db    67h
        rep   movsb
        @iszero_mfsmmx:
          mov   ecx,eax
        @start_mfsmmx:
        shr   ecx,3
        jz    @bel8_mfsmmx
        @lp_mfsmmx:
          db 3Eh,67h,0Fh,6Fh,06h  ;movq mm0,ds:[esi],2
          add   esi,8
          movq  es:[edi],mm0,2
          add   edi,8
          dec   ecx
          jnz   @lp_mfsmmx
        emms               ;reset
        @bel8_mfsmmx:
        and   eax,111b
        jz    @end_mfsmmx
        mov   ecx,eax
        db    67h
        rep   movsb

;        test  eax,100b
;        jz    @startlpb2
;        db 67h
;        movsd
;        and   eax,11b
;        jz    @end_mfsmmx
;        @startlpb2:
;        mov   ebx,ds:[esi]
;        @lpb2_mfsmmx:
;        mov   es:[edi],bl
;        inc   edi
;        shr   ebx,8
;        dec   eax
;        jnz   @lpb2_mfsmmx


@end_mfsmmx:
        mov   ds,dx
        ret
movefromscreen_mmx endp

;!! possibly probs if <= 3 bytes to fill
fillbyte_386 proc
arg dest:pword,count:dword,value:dword
        cld
        mov   eax,value
        les   edi,dest
        mov   ah,al
        mov   edx,count
        cmp   edx,8
        jb    @start_fb
          mov   ecx,edi
          and   ecx,11b
          jz    @start_fb
          xor   ecx,11b
          inc   ecx
          sub   edx,ecx
          db 67h
          rep   stosb
        @start_fb:
        mov   bx,ax
        shl   eax,16
        mov   ecx,edx
        mov   ax,bx
        shr   ecx,2
        db 67h
        rep stosd
        and   edx,11b
        jz    @end_fb
        mov   ecx,edx
        db 67h
        rep   stosb
@end_fb:ret
fillbyte_386 endp

fillword_386 proc
arg dest:pword,count:dword,value:dword
        cld
        les   edi,pword ptr dest
        mov   edx,count
        shr   edx,1
        jz    @end_fw
        mov   eax,value
        mov   bx,ax
        shl   eax,16
        mov   ax,bx
        test  edi,10b
        jz    @iszero_fw
          mov   es:[edi],ax
          add   edi,2
          dec   edx
        @iszero_fw:
        mov   ecx,edx
        shr   ecx,1
        jz    @small_fw
        db 67h
        rep   stosd
        mov   cx,dx
        and   cx,1b
@small_fw:
        and   edx,1b
        jz    @end_fw
        mov   es:[edi],ax
@end_fw:
        ret
fillword_386 endp

;word-filling, 64 bit address aligned
fillword_mmx proc
arg dest:pword,count:dword,value:dword
        cld
        mov   ecx,count
        les   edi,dest
        shr   ecx,1
        jz    @left_fwmx
        mov   eax,value
        mov   edx,ecx
        shr   ecx,2
        jz    @left_fwmx
        movd  mm0,eax
        mov   ebx,edi
        punpcklwd mm0,mm0
        and   ebx,110b
        jz    @start_fwmx
        xor   ebx,111b
        inc   ebx
        shr   ebx,1
        mov   ecx,ebx
        sub   edx,ebx
        db    67h
        rep   stosw
        mov   ecx,edx
        shr   ecx,2
        jz    @left_fwmx
@start_fwmx:
        punpckldq mm0,mm0
@lp_fwmx:
        movq  es:[edi],mm0,2
        add   edi,8
        dec   ecx
        jnz   @lp_fwmx
@left_fwmx:
        and   edx,11b
        jz    @end_fwmx
        mov   ecx,edx
        db    67h
        rep   stosw
@end_fwmx:
        emms
        ret
fillword_mmx endp

;!! Not optimized yet
;fill24_386 proc
;arg dest:pword,count:dword,value:dword
;        mov   ecx,3
;        mov   eax,count
;        cdq
;        div   ecx
;        or    eax,eax
;        jz    @end_f24
;        les   edi,dest
;        mov   cx,word ptr value
;        mov   bl,byte ptr value[2]
;@lp_f24:
;        mov   es:[edi],cx
;        mov   es:[edi+2],bl
;        add   edi,3
;        dec   eax
;        jnz   @lp_f24
;@end_f24:
;        ret
;fill24_386 endp

fill24_386 proc
arg dest:pword,count:dword,value:dword
        mov   ecx,3
        mov   eax,count
        cdq
        div   ecx
        or    eax,eax
        jz    @end_f24
        les   edi,dest
        mov   esi,value
        and   esi,0FFFFFFh
        mov   ebx,esi
        mov   ecx,esi
        shl   ecx,24
        or    ebx,ecx
        mov   ecx,esi
        mov   edx,esi
        shr   ecx,8
        shl   edx,16
        or    ecx,edx
        mov   edx,esi
        shr   edx,16
        shl   esi,8
        or    edx,esi

        mov   esi,eax

        and   eax,0FFFFFFFCh
        jz    @b12_f24
        and   esi,3

@lp_f24:
        mov   es:[edi],ebx
        mov   es:[edi+4],ecx
        mov   es:[edi+8],edx
        add   edi,12
        sub   eax,4
        jnz   @lp_f24

@b12_f24:
        or    esi,esi
        jz    @end_f24

@lp2_f24:
        mov   es:[edi],bx
        mov   es:[edi+2],ch
        add   edi,3
        dec   esi
        jnz   @lp2_f24
@end_f24:
        ret
fill24_386 endp


filldword_386 proc
arg dest:pword,count:dword,value:dword
        cld
        les   edi,dest
        mov   ecx,count
        shr   ecx,2
        jz    @end_fd
        mov   eax,value
        db    67h
        rep   stosd
@end_fd:ret
filldword_386 endp

;dword-filling, 64 bit address aligned
filldword_mmx proc
arg dest:pword,count:dword,value:dword
        les   edi,dest
        mov   ecx,count
        movd  mm0,value
        mov   edx,ecx
        shr   ecx,3
        jz    @once_fdmx
        punpckldq mm0,mm0
        test  edi,4
        jz    @lp_fdmx
        movd  es:[edi],mm0,2
        sub   edx,4
        add   edi,4
        mov   ecx,edx
        shr   ecx,3
        jz    @once_fdmx
@lp_fdmx:
        movq  es:[edi],mm0,2
        add   edi,8
        dec   ecx
        jnz   @lp_fdmx
@once_fdmx:
        test  edx,4
        jz    @end_fdmx
        movd  es:[edi],mm0,2
@end_fdmx:
        emms
        ret
filldword_mmx endp

fillxor_1516_386 proc
arg dest:pword,count:dword,value:dword
        les   edi,dest
        mov   edx,count
        shr   edx,1
        mov   eax,value
        mov   bx,ax
        shl   eax,16
        mov   ax,bx
        test  edi,10b
        jz    @iszero_fx16
          xor   es:[edi],ax
          add   edi,2
          dec   edx
        @iszero_fx16:
        mov   ecx,edx
        shr   ecx,1
        jz    @small_fx16
        @lp_fx16:
          xor   es:[edi],eax
          add   edi,4
          dec   ecx
        jnz   @lp_fx16
        mov   cx,dx
        and   cx,1b
@small_fx16:
        and   edx,1b
        jz    @end_fx16
        xor   es:[edi],ax
@end_fx16:
        ret
fillxor_1516_386 endp

fillxor_1516_mmx proc
arg dest:pword,count:dword,value:dword
        les   edi,dest
        mov   ecx,count
        mov   eax,value
        mov   edx,ecx
        shr   ecx,3
        jz    @once_fx16mx
        movd  mm1,eax
        punpcklwd mm1,mm1
        punpckldq mm1,mm1
@rep_fx16mx:
        movq  mm0,mm1
        pxor  mm0,es:[edi],2
        movq  es:[edi],mm0,2

        add   edi,8
        dec   ecx
        jnz   @rep_fx16mx
@once_fx16mx:
        and   edx,110b
        jz    @end_fx16mx
        xor   es:[edi],ax
        sub   edx,2
        jz    @end_fx16mx
        xor   es:[edi+2],ax
        sub   edx,2
        jz    @end_fx16mx
        xor   es:[edi+4],ax
@end_fx16mx:
        emms
        ret
fillxor_1516_mmx endp

fillxor_24_386 proc
arg dest:pword,count:dword,value:dword
        les   edi,pword ptr dest
        mov   ecx,3
        mov   eax,count
        cdq
        div   ecx
        or    eax,eax
        jz    @end_fx24
        mov   bx,word ptr value
        mov   cl,byte ptr value[2]
        @lp_fx24:
          xor   es:[edi],bx
          xor   es:[edi+2],cl
          add   edi,3
          dec   eax
        jnz   @lp_fx24
@end_fx24:
        ret
fillxor_24_386 endp

fillxor_32_386 proc
arg dest:pword,count:dword,value:dword
        les   edi,pword ptr dest
        mov   ecx,count
        shr   ecx,2
        jz    @end_fx32
        mov   eax,value
        @lp_fx32:
          xor   es:[edi],eax
          add   edi,4
          dec   ecx
        jnz   @lp_fx32
@end_fx32:
        ret
fillxor_32_386 endp

fillxor_32_mmx proc
arg dest:pword,count:dword,value:dword
        les   edi,pword ptr dest
        mov   ecx,count
        movd  mm1,value
        mov   edx,ecx
        shr   ecx,3
        jz    @once_fx32mx
        punpckldq mm1,mm1
@rep_fx32mx:
        movq  mm0,mm1
        pxor  mm0,es:[edi],2
        movq  es:[edi],mm0,2

        add   edi,8
        dec   ecx
        jnz   @rep_fx32mx
@once_fx32mx:
        test  edx,4
        jz    @end_fx32mx
        movd  mm0,es:[edi],2
        pxor  mm0,mm1
        movd  es:[edi],mm0,2

@end_fx32mx:
        emms
        ret
fillxor_32_mmx endp

pattxor_1516 proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   cl,xpos
        and   cl,7
        mov   al,pattern
        rol   al,cl
        les   edi,dest
        mov   ecx,count
        shr   ecx,1
        jz    @end_px1516
        mov   bx,word ptr value
        @lp_px1516:
          test  al,1
          jz    @bk_px1516
            xor   es:[edi],bx
          @bk_px1516:
          add   edi,2
          rol   al,1
          dec   ecx
        jnz   @lp_px1516
@end_px1516:
        ret
pattxor_1516 endp

pattxor_24_386 proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   cl,xpos
        and   cl,7
        mov   bl,pattern
        rol   bl,cl
        les   edi,dest
        mov   ecx,3
        mov   eax,count
        cdq
        div   ecx
        or    eax,eax
        jz    @end_px24
        mov   dx,word ptr value
        mov   cl,byte ptr value
        @lp_px24:
          test  bl,1
          jz    @bk_px24
            xor   es:[edi],dx
            xor   es:[edi+2],cl
          @bk_px24:
          add   edi,3
          rol   bl,1
          dec   eax
        jnz   @lp_px24
@end_px24:
        ret
pattxor_24_386 endp

pattxor_32_386 proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   cl,xpos
        and   cl,7
        mov   al,pattern
        rol   al,cl
        les   edi,dest
        mov   ecx,count
        shr   ecx,2
        jz    @end_px32
        mov   ebx,value
        @lp_px32:
          test  al,1
          jz    @bk_px32
            xor   es:[edi],ebx
          @bk_px32:
          add   edi,4
          rol   al,1
          dec   ecx
        jnz   @lp_px32
@end_px32:
        ret
pattxor_32_386 endp

pattxor_32_mmx proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   cl,xpos
        and   cl,7
        mov   al,pattern
        rol   al,cl
        les   edi,pword ptr dest
        movd  mm1,value
        mov   ecx,count
        mov   edx,ecx
        shr   ecx,3
        jz    @once_px32mx
        punpckldq mm1,mm1
@lp_px32mx:
          test  al,1
          jz    @ad1_px32mx
          test  al,2
          jz    @ad2_px32mx
          movq  mm0,es:[edi],2
          pxor  mm0,mm1
          movq  es:[edi],mm0,2
          jmp   @bk_px32mx
@ad2_px32mx:
          movd  mm0,es:[edi+4],2
          pxor  mm0,mm1
          movd  es:[edi+4],mm0,2
          jmp   @bk_px32mx
@ad1_px32mx:
          test  al,2
          jz    @bk_px32mx
          movd  mm0,es:[edi],2
          pxor  mm0,mm1
          movd  es:[edi],mm0,2
@bk_px32mx:
        add   edi,8
        rol   al,2
        dec   ecx
        jnz   @lp_px32mx
@once_px32mx:
        test  edx,4
        jz    @end_px32mx
        test  al,2
        jz    @end_px32mx
        movd  mm0,es:[edi],2
        pxor  mm0,mm1
        movd  es:[edi],mm0,2

@end_px32mx:
        emms
        ret
pattxor_32_mmx endp

fillpatt_8 proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   cl,xpos
        and   cl,7
        mov   al,pattern
        rol   al,cl
        les   edi,dest
        mov   esi,count
        or    esi,esi
        jz    @end_fp8
        mov   dl,byte ptr value
        @lp_fp8:
          test  al,1
          jz    @bk_fp8
            mov   es:[edi],dl
          @bk_fp8:
          rol   al,1
          inc   edi
          dec   esi
        jnz   @lp_fp8
@end_fp8:
        ret
fillpatt_8 endp

fillpatt_1516 proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   cl,xpos
        and   cl,7
        mov   al,pattern
        rol   al,cl
        les   edi,dest
        mov   ecx,count
        shr   ecx,1
        jz    @end_fp16
        mov   bx,word ptr value
        @lp_fp16:
          test  al,1
          jz    @bk_fp16
            mov   es:[edi],bx
          @bk_fp16:
          add   edi,2
          rol   al,1
          dec   ecx
        jnz   @lp_fp16
@end_fp16:
        ret
fillpatt_1516 endp

fillpatt_24 proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   cl,xpos
        and   cl,7
        mov   al,pattern
        rol   al,cl
        les   edi,dest
        push  ax
        mov   ecx,3
        mov   eax,count
        cdq
        div   ecx
        mov   ecx,eax
        or    eax,eax
        jz    @end_fp24
        pop   ax
        mov   bx,word ptr value
        mov   dl,byte ptr value[2]
        @lp_fp24:
          test  al,1
          jz    @bk_fp24
            mov   es:[edi],bx
            mov   es:[edi+2],dl
          @bk_fp24:
          add   edi,3
          rol   al,1
          dec   ecx
        jnz   @lp_fp24
@end_fp24:
        ret
fillpatt_24 endp

fillpatt_32 proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   cl,xpos
        and   cl,7
        mov   al,pattern
        rol   al,cl
        les   edi,dest
        mov   ecx,count
        shr   ecx,2
        jz    @end_fp32
        mov   ebx,value
        @lp_fp32:
          test  al,1
          jz    @bk_fp32
            mov   es:[edi],ebx
          @bk_fp32:
          add   edi,4
          rol   al,1
          dec   ecx
        jnz   @lp_fp32
@end_fp32:
        ret
fillpatt_32 endp

pattadd_15 proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   cl,xpos
        and   cl,7
        mov   al,pattern
        rol   al,cl
        les   edi,dest
        shr   count,1
        jz    @end_pa15
        mov   bx,word ptr value
        mov   si,bx
        and   bx,111110000011111b
        and   si,1111100000b
        @lp_pa15:
          test  al,1
          jz    @bk_pa15
            mov   dx,es:[edi]
            mov   cx,dx
            and   dx,111110000011111b
            and   cx,1111100000b
            add   dl,bl
            cmp   dl,11111b
            jna   @nob_pa15
              mov   dl,11111b
            @nob_pa15:
            add   dh,bh
            cmp   dh,1111100b
            jna   @nor_pa15
              mov   dh,1111100b
            @nor_pa15:
            add   cx,si
            cmp   cx,1111100000b
            jna   @nog_pa15
              mov   cx,1111100000b
            @nog_pa15:
            or    dx,cx
            mov   es:[edi],dx
          @bk_pa15:
          add   edi,2
          rol   al,1
          dec   count
        jnz   @lp_pa15
@end_pa15:
        ret
pattadd_15 endp

pattadd_16 proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   cl,xpos
        and   cl,7
        mov   al,pattern
        rol   al,cl
        les   edi,dest
        shr   count,1
        jz    @end_pa16
        mov   bx,word ptr value
        mov   si,bx
        and   bx,1111100000011111b
        and   si,11111100000b
        @lp_pa16:
          test  al,1
          jz    @bk_pa16
            mov   dx,es:[edi]
            mov   cx,dx
            and   dx,1111100000011111b
            and   cx,11111100000b
            add   dl,bl
            cmp   dl,11111b
            jna   @nob_pa16
              mov   dl,11111b
            @nob_pa16:
            add   dh,bh
            jnc   @nor_pa16
              mov   dh,11111000b
            @nor_pa16:
            add   cx,si
            cmp   cx,11111100000b
            jna   @nog_pa16
              mov   cx,11111100000b
            @nog_pa16:
            or    dx,cx
            mov   es:[edi],dx
          @bk_pa16:
          add   edi,2
          rol   al,1
          dec   count
        jnz   @lp_pa16
@end_pa16:
        ret
pattadd_16 endp

pattadd_24_386 proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   ecx,3
        mov   eax,count
        cdq
        div   ecx
        or    eax,eax
        jz    @end_pa24
        mov   esi,eax
        mov   cl,xpos
        and   cl,7
        mov   al,pattern
        rol   al,cl
        les   edi,dest
        mov   bx,word ptr value
        mov   ah,byte ptr value[2]
        @lp_pa24:
          test  al,1
          jz    @bk_pa24
            mov   ecx,es:[edi]
            mov   edx,ecx
            shr   ecx,16
            add   dl,bl
            jnc   @nob_pa24
              mov   dl,0FFh
            @nob_pa24:
            add   dh,bh
            jnc   @nor_pa24
              mov   dh,0FFh
            @nor_pa24:
            add   cl,ah
            jnc   @nog_pa24
              mov   cl,0FFh
            @nog_pa24:
            mov   es:[edi],dx
            mov   es:[edi+2],cl
          @bk_pa24:
          add   edi,3
          rol   al,1
          dec   esi
        jnz   @lp_pa24
@end_pa24:
        ret
pattadd_24_386 endp

pattadd_32_386 proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   cl,xpos
        and   cl,7
        mov   al,pattern
        rol   al,cl
        les   edi,dest
        mov   esi,count
        shr   esi,2
        jz    @end_pa32
        mov   bx,word ptr value
        mov   ah,byte ptr value[2]
        @lp_pa32:
          test  al,1
          jz    @bk_pa32
            mov   ecx,es:[edi]
            mov   edx,ecx
            shr   ecx,16
            add   dl,bl
            jnc   @nob_pa32
              mov   dl,0FFh
            @nob_pa32:
            add   dh,bh
            jnc   @nor_pa32
              mov   dh,0FFh
            @nor_pa32:
            add   cl,ah
            jnc   @nog_pa32
              mov   cl,0FFh
            @nog_pa32:
            shl   ecx,16
            mov   cx,dx
            mov   es:[edi],ecx
          @bk_pa32:
          add   edi,4
          rol   al,1
          dec   esi
        jnz   @lp_pa32
@end_pa32:
        ret
pattadd_32_386 endp


pattadd_32_mmx proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   cl,xpos
        and   cl,7
        mov   al,pattern
        rol   al,cl
        les   edi,pword ptr dest
        mov   ecx,count
        movd  mm1,value
        mov   edx,ecx
        shr   ecx,3
        jz    @once_pa32mx
        punpckldq mm1,mm1
@lp_pa32mx:
          test    al,1
          jz      @ad1_pa32mx
          test    al,2
          jz      @ad2_pa32mx
          movq    mm0,es:[edi],2
          paddusb mm0,mm1
          movq    es:[edi],mm0,2
          jmp     @bk_pa32mx
@ad2_pa32mx:
          movd    mm0,es:[edi+4],2
          paddusb mm0,mm1
          movd    es:[edi+4],mm0,2
          jmp     @bk_pa32mx
@ad1_pa32mx:
          test    al,2
          jz      @bk_pa32mx
          movd    mm0,es:[edi],2
          paddusb mm0,mm1
          movd    es:[edi],mm0,2
@bk_pa32mx:
        add     edi,8
        rol     al,2
        dec     ecx
        jnz     @lp_pa32mx
@once_pa32mx:
        test    edx,4
        jz      @end_pa32mx
        test    al,2
        jz      @end_pa32mx
        movd    mm0,es:[edi],2
        paddusb mm0,mm1
        movd    es:[edi],mm0,2

@end_pa32mx:
        emms
        ret
pattadd_32_mmx endp

pattsub_15 proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   cl,xpos
        and   cl,7
        mov   al,pattern
        rol   al,cl
        les   edi,dest
        shr   count,1
        jz    @end_ps15
        mov   bx,word ptr value
        mov   si,bx
        and   bx,111110000011111b
        and   si,1111100000b
        @lp_ps15:
          test  al,1
          jz    @bk_ps15
            mov   dx,es:[edi]
            mov   cx,dx
            and   dx,111110000011111b
            and   cx,1111100000b
            sub   dl,bl
            jnc   @nob_ps15
              xor   dl,dl
            @nob_ps15:
            sub   dh,bh
            jnc   @nor_ps15
              xor   dh,dh
            @nor_ps15:
            sub   cx,si
            jc   @nog_ps15
              or   dx,cx
            @nog_ps15:
            mov   es:[edi],dx
          @bk_ps15:
          add   edi,2
          rol   al,1
          dec   count
        jnz   @lp_ps15
@end_ps15:
        ret
pattsub_15 endp

pattsub_16 proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   cl,xpos
        and   cl,7
        mov   al,pattern
        rol   al,cl
        les   edi,dest
        shr   count,1
        jz    @end_ps16
        mov   bx,word ptr value
        mov   si,bx
        and   bx,1111100000011111b
        and   si,11111100000b
        @lp_ps16:
          test  al,1
          jz    @bk_ps16
            mov   dx,es:[edi]
            mov   cx,dx
            and   dx,1111100000011111b
            and   cx,11111100000b
            sub   dl,bl
            jnc   @nob_ps16
              xor   dl,dl
            @nob_ps16:
            sub   dh,bh
            jnc   @nor_ps16
              xor   dh,dh
            @nor_ps16:
            sub   cx,si
            jc   @nog_ps16
              or   dx,cx
            @nog_ps16:
            mov   es:[edi],dx
          @bk_ps16:
          add   edi,2
          rol   al,1
          dec   count
        jnz   @lp_ps16
@end_ps16:
        ret
pattsub_16 endp


pattsub_24_386 proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   ecx,3
        mov   eax,count
        cdq
        div   ecx
        or    eax,eax
        jz    @end_ps24
        mov   esi,eax
        mov   cl,xpos
        and   cl,7
        mov   al,pattern
        rol   al,cl
        les   edi,dest
        mov   bx,word ptr value

        mov   ah,byte ptr value[2]
        @lp_ps24:
          test  al,1
          jz    @bk_ps24
            mov   ecx,es:[edi]
            mov   edx,ecx
            shr   ecx,16
            sub   dl,bl
            jnc   @nob_ps24
              xor   dl,dl
            @nob_ps24:
            sub   dh,bh
            jnc   @nor_ps24
              xor   dh,dh
            @nor_ps24:
            sub   cl,ah
            jnc   @nog_ps24
              xor   cl,cl
            @nog_ps24:
            mov   es:[edi],dx
            mov   es:[edi+2],cl
          @bk_ps24:
          add   edi,3
          rol   al,1
          dec   esi
        jnz   @lp_ps24
@end_ps24:
        ret
pattsub_24_386 endp

pattsub_32_386 proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   cl,xpos
        and   cl,7
        mov   al,pattern
        rol   al,cl
        les   edi,dest
        mov   esi,count
        shr   esi,2
        jz    @end_ps32
        mov   bx,word ptr value
        mov   ah,byte ptr value[2]
        @lp_ps32:
          test  al,1
          jz    @bk_ps32
            mov   ecx,es:[edi]
            mov   edx,ecx
            shr   ecx,16
            sub   dl,bl
            jnc   @nob_ps32
              xor   dl,dl
            @nob_ps32:
            sub   dh,bh
            jnc   @nor_ps32
              xor   dh,dh
            @nor_ps32:
            sub   cl,ah
            jnc   @nog_ps32
              xor   cl,cl
            @nog_ps32:
            shl   ecx,16
            mov   cx,dx
            mov   es:[edi],ecx
          @bk_ps32:
          add   edi,4
          rol   al,1
          dec   esi
        jnz   @lp_ps32
@end_ps32:
        ret
pattsub_32_386 endp

pattsub_32_mmx proc
arg dest:pword,count:dword,value:dword,xpos:byte,pattern:byte
        mov   cl,xpos
        and   cl,7
        mov   al,pattern
        rol   al,cl
        les   edi,pword ptr dest
        mov   ecx,count
        movd  mm1,value
        mov   edx,ecx
        shr   ecx,3
        jz    @once_ps32mx
        punpckldq mm1,mm1
@lp_ps32mx:
          test    al,1
          jz      @ad1_ps32mx
          test    al,2
          jz      @ad2_ps32mx
          movq    mm0,es:[edi],2
          psubusb mm0,mm1
          movq    es:[edi],mm0,2
          jmp     @bk_ps32mx
@ad2_ps32mx:
          movd    mm0,es:[edi+4],2
          psubusb mm0,mm1
          movd    es:[edi+4],mm0,2
          jmp     @bk_ps32mx
@ad1_ps32mx:
          test    al,2
          jz      @bk_ps32mx
          movd    mm0,es:[edi],2
          psubusb mm0,mm1
          movd    es:[edi],mm0,2
@bk_ps32mx:
        add     edi,8
        rol     al,2
        dec     ecx
        jnz     @lp_ps32mx
@once_ps32mx:
        test    edx,4
        jz      @end_ps32mx
        test    al,2
        jz      @end_ps32mx
        movd    mm0,es:[edi],2
        psubusb mm0,mm1
        movd    es:[edi],mm0,2

@end_ps32mx:
        emms
        ret
pattsub_32_mmx endp

addfill_15 proc
arg dest:pword,count:dword,value:dword
        les   edi,pword ptr dest
        mov   edx,count
        shr   edx,1
        jz    @end_af15
        mov   ebx,value
        mov   si,bx
        and   bx,111110000011111b
        and   si,1111100000b
        mov   ecx,edi
        and   ecx,10b
        jz    @iszero_af15
          mov   ax,es:[edi]
          mov   cx,ax
          and   ax,111110000011111b
          and   cx,1111100000b
          add   al,bl
          cmp   al,11111b
          jna   @nob_af15_3
            mov   al,11111b
          @nob_af15_3:
          add   ah,bh
          cmp   ah,1111100b
          jna   @nor_af15_3
            mov   ah,1111100b
          @nor_af15_3:
          add   cx,si
          cmp   cx,1111100000b
          jna   @nog_af15_3
            mov   cx,1111100000b
          @nog_af15_3:
          or    ax,cx
          mov   es:[edi],ax
          add   edi,2
          dec   edx
        @iszero_af15:
        or    edx,edx
        jz    @end_af15
@rep_af15:
        mov   eax,es:[edi]
        mov   cx,ax
        and   ax,111110000011111b
        and   cx,1111100000b
        add   al,bl
        cmp   al,11111b
        jna   @nob_af15_1
          mov   al,11111b
        @nob_af15_1:
        add   ah,bh
        cmp   ah,1111100b
        jna   @nor_af15_1
          mov   ah,1111100b
        @nor_af15_1:
        add   cx,si
        cmp   cx,1111100000b
        jna   @nog_af15_1
          mov   cx,1111100000b
        @nog_af15_1:
        or    ax,cx

        dec   edx
        jz    @once_af15
        ror   eax,16
        mov   cx,ax
        and   ax,111110000011111b
        and   cx,1111100000b
        add   al,bl
        cmp   al,11111b
        jna   @nob_af15_2
          mov   al,11111b
        @nob_af15_2:
        add   ah,bh
        cmp   ah,1111100b
        jna   @nor_af15_2
          mov   ah,1111100b
        @nor_af15_2:
        add   cx,si
        cmp   cx,1111100000b
        jna   @nog_af15_2
          mov   cx,1111100000b
        @nog_af15_2:
        or    ax,cx
        rol   eax,16
        mov   es:[edi],eax

        add   edi,4
        dec   edx
        jnz   @rep_af15
        jmp   @end_af15
@once_af15:
        mov   es:[edi],ax
@end_af15:
        ret
addfill_15 endp

addfill_16 proc
arg dest:pword,count:dword,value:dword
        les   edi,pword ptr dest
        mov   edx,count
        shr   edx,1
        jz    @end_af16
        mov   ebx,value
        mov   si,bx
        and   bx,1111100000011111b
        and   si,11111100000b
        mov   ecx,edi
        and   ecx,10b
        jz    @iszero_af16
          mov   ax,es:[edi]
          mov   cx,ax
          and   ax,1111100000011111b
          and   cx,11111100000b
          add   al,bl
          cmp   al,11111b
          jna   @nob_af16_3
            mov   al,11111b
          @nob_af16_3:
          add   ah,bh
          jnc   @nor_af16_3
            mov   ah,11111000b
          @nor_af16_3:
          add   cx,si
          cmp   cx,11111100000b
          jna   @nog_af16_3
            mov   cx,11111100000b
          @nog_af16_3:
          or    ax,cx
          mov   es:[edi],ax
          add   edi,2
          dec   edx
        @iszero_af16:
        or    edx,edx
        jz    @end_af16
@rep_af16:
        mov   eax,es:[edi]
        mov   cx,ax
        and   ax,1111100000011111b
        and   cx,11111100000b
        add   al,bl
        cmp   al,11111b
        jna   @nob_af16_1
          mov   al,11111b
        @nob_af16_1:
        add   ah,bh
        jnc   @nor_af16_1
          mov   ah,11111000b
        @nor_af16_1:
        add   cx,si
        cmp   cx,11111100000b
        jna   @nog_af16_1
          mov   cx,11111100000b
        @nog_af16_1:
        or    ax,cx

        dec   edx
        jz    @once_af16
        ror   eax,16
        mov   cx,ax
        and   ax,1111100000011111b
        and   cx,11111100000b
        add   al,bl
        cmp   al,11111b
        jna   @nob_af16_2
          mov   al,11111b
        @nob_af16_2:
        add   ah,bh
        jnc   @nor_af16_2
          mov   ah,11111000b
        @nor_af16_2:
        add   cx,si
        cmp   cx,11111100000b
        jna   @nog_af16_2
          mov   cx,11111100000b
        @nog_af16_2:
        or    ax,cx
        rol   eax,16
        mov   es:[edi],eax

        add   edi,4
        dec   edx
        jnz   @rep_af16
        jmp   @end_af16
@once_af16:
        mov   es:[edi],ax
@end_af16:
        ret
addfill_16 endp

addfill_24_386 proc
arg dest:pword,count:dword,value:dword
        les   edi,pword ptr dest
        mov   ecx,3
        mov   eax,count
        cdq
        div   ecx
        or    eax,eax
        jz    @end_af24
        mov   esi,eax
        mov   bx,word ptr value
        mov   ah,byte ptr value[2]
@rep_af24:
        mov   ecx,es:[edi]
        mov   edx,ecx
        shr   ecx,16
        add   dl,bl
        jnc   @nob_af24
          mov   dl,0FFh
        @nob_af24:
        add   dh,bh
        jnc   @nor_af24
          mov   dh,0FFh
        @nor_af24:
        add   cl,ah
        jnc   @nog_af24
          mov   cl,0FFh
        @nog_af24:
        mov   es:[edi],dx
        mov   es:[edi+2],cl
        add   edi,3
        dec   esi
        jnz   @rep_af24
@end_af24:
        ret
addfill_24_386 endp

addfill_32_386 proc
arg dest:pword,count:dword,value:dword
        les   edi,pword ptr dest
        mov   esi,count
        shr   esi,2
        jz    @end_af32
        mov   bx,word ptr value
        mov   ah,byte ptr value[2]
@rep_af32:
        mov   ecx,es:[edi]
        mov   edx,ecx
        shr   ecx,16
        add   dl,bl
        jnc   @nob_af32
          mov   dl,0FFh
        @nob_af32:
        add   dh,bh
        jnc   @nor_af32
          mov   dh,0FFh
        @nor_af32:
        add   cl,ah
        jnc   @nog_af32
          mov   cl,0FFh
        @nog_af32:
        shl   ecx,16
        mov   cx,dx
        mov   es:[edi],ecx

        add   edi,4
        dec   esi
        jnz   @rep_af32
@end_af32:
        ret
addfill_32_386 endp

addfill_32_mmx proc
arg dest:pword,count:dword,value:dword
        les   edi,pword ptr dest
        mov   ecx,count
        movd  mm1,value
        mov   edx,ecx
        shr   ecx,3
        jz    @once_ad32mx
        punpckldq mm1,mm1
@lp_ad32mx:
        movq    mm0,es:[edi],2
        paddusb mm0,mm1
        movq    es:[edi],mm0,2

        add     edi,8
        dec     ecx
        jnz     @lp_ad32mx
@once_ad32mx:
        test    edx,4
        jz      @end_ad32mx
        movd    mm0,es:[edi],2
        paddusb mm0,mm1
        movd    es:[edi],mm0,2

@end_ad32mx:
        emms
        ret
addfill_32_mmx endp

subfill_15 proc
arg dest:pword,count:dword,value:dword
        les   edi,pword ptr dest
        mov   edx,count
        shr   edx,1
        jz    @end_sf15
        mov   ebx,value
        mov   si,bx
        and   bx,111110000011111b
        and   si,1111100000b
        mov   ecx,edi
        and   ecx,10b
        jz    @iszero_sf15
          mov   ax,es:[edi]
          mov   cx,ax
          and   ax,111110000011111b
          and   cx,1111100000b
          sub   al,bl
          jnc   @nob_sf15_3
            xor   al,al
          @nob_sf15_3:
          sub   ah,bh
          jnc   @nor_sf15_3
            xor   ah,ah
          @nor_sf15_3:
          sub   cx,si
          jc   @nog_sf15_3
            or   ax,cx
          @nog_sf15_3:
          mov   es:[edi],ax
          add   edi,2
          dec   edx
        @iszero_sf15:
        or    edx,edx
        jz    @end_sf15
@rep_sf15:
        mov   eax,es:[edi]
        mov   cx,ax
        and   ax,111110000011111b
        and   cx,1111100000b
        sub   al,bl
        jnc   @nob_sf15_1
          xor   al,al
        @nob_sf15_1:
        sub   ah,bh
        jnc   @nor_sf15_1
          xor   ah,ah
        @nor_sf15_1:
        sub   cx,si
        jc   @nog_sf15_1
          or   ax,cx
        @nog_sf15_1:

        dec   edx
        jz    @once_sf15
        ror   eax,16
        mov   cx,ax
        and   ax,111110000011111b
        and   cx,1111100000b
        sub   al,bl
        jnc   @nob_sf15_2
          xor   al,al
        @nob_sf15_2:
        sub   ah,bh
        jnc   @nor_sf15_2
          xor   ah,ah
        @nor_sf15_2:
        sub   cx,si
        jc   @nog_sf15_2
          or   ax,cx
        @nog_sf15_2:
        rol   eax,16
        mov   es:[edi],eax

        add   edi,4
        dec   edx
        jnz   @rep_sf15
        jmp   @end_sf15
@once_sf15:
        mov   es:[edi],ax
@end_sf15:
        ret
subfill_15 endp

subfill_16 proc
arg dest:pword,count:dword,value:dword
        les   edi,pword ptr dest
        mov   edx,count
        shr   edx,1
        jz    @end_sf16
        mov   ebx,value
        mov   si,bx
        and   bx,1111100000011111b
        and   si,11111100000b
        mov   ecx,edi
        and   ecx,10b
        jz    @iszero_sf16
          mov   ax,es:[edi]
          mov   cx,ax
          and   ax,1111100000011111b
          and   cx,11111100000b
          sub   al,bl
          jnc   @nob_sf16_3
            xor   al,al
          @nob_sf16_3:
          sub   ah,bh
          jnc   @nor_sf16_3
            xor   ah,ah
          @nor_sf16_3:
          sub   cx,si
          jc   @nog_sf16_3
            or   ax,cx
          @nog_sf16_3:
          mov   es:[edi],ax
          add   edi,2
          dec   edx
        @iszero_sf16:
        or    edx,edx
        jz    @end_sf16
@rep_sf16:
        mov   eax,es:[edi]
        mov   cx,ax
        and   ax,1111100000011111b
        and   cx,11111100000b
        sub   al,bl
        jnc   @nob_sf16_1
          xor   al,al
        @nob_sf16_1:
        sub   ah,bh
        jnc   @nor_sf16_1
          xor   ah,ah
        @nor_sf16_1:
        sub   cx,si
        jc   @nog_sf16_1
          or   ax,cx
        @nog_sf16_1:

        dec   edx
        jz    @once_sf16
        ror   eax,16
        mov   cx,ax
        and   ax,1111100000011111b
        and   cx,11111100000b
        sub   al,bl
        jnc   @nob_sf16_2
          xor   al,al
        @nob_sf16_2:
        sub   ah,bh
        jnc   @nor_sf16_2
          xor   ah,ah
        @nor_sf16_2:
        sub   cx,si
        jc   @nog_sf16_2
          or   ax,cx
        @nog_sf16_2:
        rol   eax,16
        mov   es:[edi],eax

        add   edi,4
        dec   edx
        jnz   @rep_sf16
        jmp   @end_sf16
@once_sf16:
        mov   es:[edi],ax
@end_sf16:
        ret
subfill_16 endp

subfill_24_386 proc
arg dest:pword,count:dword,value:dword
        les   edi,pword ptr dest
        mov   ecx,3
        mov   eax,count
        cdq
        div   ecx
        or    eax,eax
        jz    @end_sf24
        mov   esi,eax
        jz    @end_sf24
        mov   bx,word ptr value
        mov   ah,byte ptr value[2]
@rep_sf24:
        mov   ecx,es:[edi]
        mov   edx,ecx
        shr   ecx,16
        sub   dl,bl
        jnc   @nob_sf24
          xor   dl,dl
        @nob_sf24:
        sub   dh,bh
        jnc   @nor_sf24
          xor   dh,dh
        @nor_sf24:
        sub   cl,ah
        jnc   @nog_sf24
          xor   cl,cl
        @nog_sf24:
        mov   es:[edi],dx
        mov   es:[edi+2],cl

        add   edi,3
        dec   esi
        jnz   @rep_sf24
@end_sf24:
        ret
subfill_24_386 endp

subfill_32_386 proc
arg dest:pword,count:dword,value:dword
        les   edi,pword ptr dest
        mov   esi,count
        shr   esi,2
        jz    @end_sf32
        mov   bx,word ptr value
        mov   ah,byte ptr value[2]
@rep_sf32:
        mov   ecx,es:[edi]
        mov   edx,ecx
        shr   ecx,16
        sub   dl,bl
        jnc   @nob_sf32
          xor   dl,dl
        @nob_sf32:
        sub   dh,bh
        jnc   @nor_sf32
          xor   dh,dh
        @nor_sf32:
        sub   cl,ah
        jnc   @nog_sf32
          xor   cl,cl
        @nog_sf32:
        shl   ecx,16
        mov   cx,dx
        mov   es:[edi],ecx

        add   edi,4
        dec   esi
        jnz   @rep_sf32
@end_sf32:
        ret
subfill_32_386 endp

subfill_32_mmx proc
arg dest:pword,count:dword,value:dword
        les   edi,pword ptr dest
        mov   ecx,count
        mov   edx,ecx
        movd  mm1,value
        shr   ecx,3
        jz    @once_sf32mx
        punpckldq mm1,mm1
@lp_sf32mx:
        movq      mm0,es:[edi],2
        psubusb   mm0,mm1
        movq      es:[edi],mm0,2

        add     edi,8
        dec     ecx
        jnz     @lp_sf32mx
@once_sf32mx:
        test    edx,4
        jz      @end_sf32mx
        movd    mm0,es:[edi],2
        psubusb mm0,mm1
        movd    es:[edi],mm0,2

@end_sf32mx:
        emms
        ret
subfill_32_mmx endp

calc_circle proc
arg pointarray:pword,r:word

  les   edi,pointarray
  mov   bx,r

  mov   di,bx
  add   di,di
  mov   word ptr es:[0],0
  mov   es:[di],bx
  mov   si,1
  sub   si,bx
  xor   cx,cx
  mov   ax,bx
  or    ax,ax
  jbe   @end_cc

  xor   di,di
  add   bx,bx

@start_cc:
  or    si,si
  jns   @next_cc
    mov   dx,cx
    add   dx,dx
    add   dx,3
    add   si,dx
    inc   cx
    sub   bx,2
  mov   es:[di],cx
  mov   es:[bx],ax
  cmp   ax,cx
  jg    @start_cc
  @next_cc:
    mov   dx,cx
    sub   dx,ax
    add   dx,dx
    add   dx,3
    add   si,dx
    inc   cx
    sub   bx,2
    dec   ax
    add   di,2
  mov   es:[di],cx
  mov   es:[bx],ax
  cmp   ax,cx
  jg    @start_cc
@end_cc:
        ret
calc_circle endp

;doesn't work - GPF when accessing dx1,dy1!!
;have no clue why

calc_ellipse proc
arg pointarray:pword,rx:dword,ry:dword
         les   edi,pointarray
         mov   eax,rx
         mov   esi,eax
         xor   edi,edi
         mov   eax,rx
         mul   eax
         add   eax,eax
         mov   dx1,eax
         mov   eax,ry
         mul   eax
         mov   ecx,eax
         add   eax,eax
         mov   dy1,eax
         mov   eax,rx
         mul   ecx
         mov   ecx,eax
         add   eax,eax
         mov   edx,eax
         mov   ebx,ry
         add   ebx,ebx
         mov   eax,esi
         neg   eax
@lx:
         cmp   ecx,0
         jle   @l1
         add   edi,dx1
         sub   ecx,edi
         sub   ebx,2
         mov   es:[ebx],ax
         jmp   @lx
@l1:
         sub   edx,dy1
         add   ecx,edx
         inc   eax
         mov   es:[ebx],ax
         dec   esi
         jnz   @lx

         ret
calc_ellipse endp

CPUID     macro
          db 0fh, 0A2h
          endm

getcpuid proc
; Returns CPUID return as longint, returns zero if error
   pushfd               ; save EFLAGS
   pop   eax            ; EFLAGS into EAX-Register
   mov   ebx,eax        ; remember in EBX
   xor   eax,00200000h  ; toggle Bit 21
   push  eax            ; and via stack
   popfd                ; into EFLAGS-Register
   pushfd               ; from there back into the stack
   pop   eax            ; back to EAX
   cmp   eax, ebx       ; Bit 21 changed?
   jz    err_exit_id  ; no => no CPUID
   mov   eax,1          ; Normal CPUID
   CPUID
   jmp   idok
err_exit_id:
   mov   ax,0
   stc
   ret
idok:
   mov   eax,edx
   shr   edx,16
   clc
   ret
getcpuid endp

TestMMX proc
   pushfd               ; save EFLAGS
   pop   eax            ; EFLAGS into EAX-Register
   mov   ebx,eax        ; save in EBX
   xor   eax,00200000h  ; toggle Bit 21
   push  eax            ; and via stack
   popfd                ; into EFLAGS-Register
   pushfd               ; from there back to the stack
   pop   eax            ; back to EAX
   cmp   eax, ebx       ; Bit 21 changed?
   jz    @err_exit_mmx  ; no => no CPUID
   mov   eax,1          ; Normal CPUID
   CPUID
   test  edx,800000h    ; Bit 23 set?
   jnz   @MMXok         ; Yes => MMX present
@err_exit_mmx:
   mov   al,0
   stc
   ret
@MMXok:
   mov   al,1
   clc
   ret
TestMMX endp

Test3Dnow proc
   pushfd              ; save EFLAGS
   pop   eax           ; EFLAGS into EAX-Register
   mov   ebx,eax       ; save in EBX
   xor   eax,00200000h ; toggle Bit 21
   push  eax           ; and via stack
   popfd               ; into EFLAGS-Register
   pushfd              ; from there back to the stack
   pop   eax           ; back to EAX
   cmp   eax,ebx       ; Bit 21 changed?
   jz    @err_exit     ; no => no CPUID
   mov   eax,80000001h ; Setup Extended function 1
   CPUID
   test  edx,80000000h ; Bit 31 set?
   jnz   @3DNowok      ; Yes => 3DNow! present
@err_exit:
   mov   al,0
   stc
   ret
@3Dnowok:
   mov   al,1
   clc
   ret
Test3Dnow endp


randarray_byte proc
arg dataarray:pword,count:dword,range:dword
        les   edi,dataarray
        mov   ecx,count
        or    ecx,ecx
        jz    @stop_rb
        mov   ebx,randseed
@lp_rb:
        mov  eax,ebx
        mul  dword ptr factor
        inc  eax
        mov  ebx,eax
        shr  eax,16
        mul  dword ptr range
        shr  eax,16
        db 67h
        stosb
        dec  ecx
        jnz  @lp_rb
        mov  randseed,ebx
@stop_rb:
        ret
randarray_byte endp

randarray_word proc
arg dataarray:pword,count:dword,range:dword
        les   edi,dataarray
        mov   ecx,count
        or    ecx,ecx
        jz    @stop_rw
        mov   ebx,randseed
@lp_rw:
        mov   eax,ebx
        mul   dword ptr factor
        inc   eax
        mov   ebx,eax
        shr   eax,16
        mul   dword ptr range
        shr   eax,16
        db 67h
        stosw
        dec   ecx
        jnz   @lp_rw
        mov   randseed,ebx
@stop_rw:
        ret
randarray_word endp

bmp8_8 proc
arg source:pword,coltable:pword,dest:pword,pixels:dword
        mov   ecx,pixels
        or    ecx,ecx
        jz    @end_bm8
        les   edi,dest
        lfs   edx,coltable
        push  ds
        lds   esi,source
        xor   eax,eax
@lp_bm8:
        lodsb
        test  al,80h
        jnz   @trans_bm8
          mov   bx,fs:[edx+eax*4]
          mov   es:[edi],bl
        @trans_bm8:
        inc   edi
        dec   ecx
        jnz   @lp_bm8
        pop   ds
@end_bm8:
        ret
bmp8_8 endp

bmp8_1516 proc
arg source:pword,coltable:pword,dest:pword,pixels:dword
        mov   ecx,pixels
        or    ecx,ecx
        jz    @end_bm16
        les   edi,dest
        lfs   edx,coltable
        push  ds
        lds   esi,source
        xor   eax,eax
@lp_bm16:
        lodsb
        test  al,80h
        jnz   @trans_bm16
          mov   bx,fs:[edx+eax*4]
          mov   es:[edi],bx
        @trans_bm16:
        add   edi,2
        dec   ecx
        jnz   @lp_bm16
        pop   ds
@end_bm16:
        ret
bmp8_1516 endp

bmp8_24 proc
arg source:pword,coltable:pword,dest:pword,pixels:dword
        mov   ecx,pixels
        or    ecx,ecx
        jz    @end_bm24
        les   edi,dest
        lfs   edx,coltable
        push  ds
        lds   esi,source
        xor   eax,eax
@lp_bm24:
        lodsb
        test  al,80h
        jnz   @trans_bm24
          mov   ebx,fs:[edx+eax*4]
          mov   es:[edi],bx
          shr   ebx,16
          mov   es:[edi+2],bl
        @trans_bm24:
        add   edi,3
        dec   ecx
        jnz   @lp_bm24
        pop   ds
@end_bm24:
        ret
bmp8_24 endp

bmp8_32 proc
arg source:pword,coltable:pword,dest:pword,pixels:dword
        mov   ecx,pixels
        or    ecx,ecx
        jz    @end_bm32
        les   edi,dest
        lfs   edx,coltable
        push  ds
        lds   esi,source
        xor   eax,eax
@lp_bm32:
        lodsb
        test  al,80h
        jnz   @trans_bm32
          mov   ebx,fs:[edx+eax*4]
          mov   es:[edi],ebx
        @trans_bm32:
        add   edi,4
        dec   ecx
        jnz   @lp_bm32
        pop   ds
@end_bm32:
        ret
bmp8_32 endp

xor2screen_386 proc      ;optimized for 32-Bit address output
arg source:pword,dest:pword,count:dword
        push  ds
        lds   esi,source
        les   edi,dest
        mov   ecx,count
        mov   edx,ecx
        cmp   ecx,8
        jb    @start_x2s
        mov   ecx,edi
        and   ecx,11b
        jz    @iszero_x2s
        xor   ecx,11b
        inc   ecx
        sub   edx,ecx
        @lpb1_x2s:
          db 67h
          lodsb
          xor  es:[edi],al
          add  edi,1
          dec  ecx
        jnz @lpb1_x2s
        @iszero_x2s:
          mov   ecx,edx
        @start_x2s:
        shr   ecx,2
        @lpd_x2s:
          db 67h
          lodsd
          xor  es:[edi],eax
          add  edi,4
          dec  ecx
        jnz @lpd_x2s

        and   edx,11b
        jz    @end_x2s
        @lpb2_x2s:
          db 67h
          lodsb
          xor   es:[edi],al
          add   edi,1
          dec   edx
        jnz @lpb2_x2s
        @end_x2s:
        pop   ds
        ret
xor2screen_386 endp

xor2screen_mmx proc      ;optimized for 64-Bit address output and MMX
arg source:pword,dest:pword,count:dword
        lfs   esi,source
        les   edi,dest
        mov   ecx,count
        mov   edx,ecx
        cmp   ecx,8
        jb    @start_x2smx
        mov   ecx,edi
        and   ecx,111b
        jz    @iszero_x2smx
        xor   ecx,111b
        inc   ecx
        sub   edx,ecx
        @lpb1_x2smx:
          mov  al,fs:[esi]
          xor  es:[edi],al
          add  edi,1
          add  esi,1
          dec  ecx
        jnz @lpb1_x2smx
        @iszero_x2smx:
          mov   ecx,edx
        @start_x2smx:
        shr   ecx,3
        jz    @bel8_x2smx
          @lp_x2smx:
          movq  mm0,es:[edi],2
          pxor  mm0,fs:[esi],2
          movq  es:[edi],mm0,2
          add   esi,8
          add   edi,8
          dec   ecx
          jnz   @lp_x2smx
        emms               ;reset
        @bel8_x2smx:
        and   edx,111b
        jz    @end_x2smx
        @lpb2_x2smx:
          mov  al,fs:[esi]
          xor  es:[edi],al
          add  edi,1
          add  esi,1
          dec  edx
        jnz @lpb2_x2smx
        @end_x2smx:
        ret
xor2screen_mmx endp

and2screen_386 proc      ;optimized for 32-Bit address output
arg source:pword,dest:pword,count:dword
        push  ds
        lds   esi,source
        les   edi,dest
        mov   ecx,count
        mov   edx,ecx
        cmp   ecx,8
        jb    @start_a2s
        mov   ecx,edi
        and   ecx,11b
        jz    @iszero_a2s
        xor   ecx,11b
        inc   ecx
        sub   edx,ecx
        @lpb1_a2s:
          db 67h
          lodsb
          and  es:[edi],al
          add  edi,1
          dec  ecx
        jnz @lpb1_a2s
        @iszero_a2s:
          mov   ecx,edx
        @start_a2s:
        shr   ecx,2
        @lpd_a2s:
          db 67h
          lodsd
          and  es:[edi],eax
          add  edi,4
          dec  ecx
        jnz @lpd_a2s

        and   edx,11b
        jz    @end_a2s
        @lpb2_a2s:
          db 67h
          lodsb
          and   es:[edi],al
          add   edi,1
          dec   edx
        jnz @lpb2_a2s
        @end_a2s:
        pop   ds
        ret
and2screen_386 endp

and2screen_mmx proc      ;optimized for 64-Bit address output and MMX
arg source:pword,dest:pword,count:dword
        lfs   esi,source
        les   edi,dest
        mov   ecx,count
        mov   edx,ecx
        cmp   ecx,8
        jb    @start_a2smx
        mov   ecx,edi
        and   ecx,111b
        jz    @iszero_a2smx
        xor   ecx,111b
        inc   ecx
        sub   edx,ecx
        @lpb1_a2smx:
          mov  al,fs:[esi]
          and  es:[edi],al
          add  edi,1
          add  esi,1
          dec  ecx
        jnz @lpb1_a2smx
        @iszero_a2smx:
          mov   ecx,edx
        @start_a2smx:
        shr   ecx,3
        jz    @bel8_a2smx
          @lp_a2smx:
          movq  mm0,es:[edi],2
          pand  mm0,fs:[esi],2
          movq  es:[edi],mm0,2
          add   esi,8
          add   edi,8
          dec   ecx
          jnz   @lp_a2smx
        emms               ;reset
        @bel8_a2smx:
        and   edx,111b
        jz    @end_a2smx
        @lpb2_a2smx:
          mov  al,fs:[esi]
          and  es:[edi],al
          add  edi,1
          add  esi,1
          dec  edx
        jnz @lpb2_a2smx
        @end_a2smx:
        ret
and2screen_mmx endp

or2screen_386 proc      ;optimized for 32-Bit address output
arg source:pword,dest:pword,count:dword
        push  ds
        lds   esi,source
        les   edi,dest
        mov   ecx,count
        mov   edx,ecx
        cmp   ecx,8
        jb    @start_o2s
        mov   ecx,edi
        and   ecx,11b
        jz    @iszero_o2s
        xor   ecx,11b
        inc   ecx
        sub   edx,ecx
        @lpb1_o2s:
          db 67h
          lodsb
          or   es:[edi],al
          add  edi,1
          dec  ecx
        jnz @lpb1_o2s
        @iszero_o2s:
          mov   ecx,edx
        @start_o2s:
        shr   ecx,2
        @lpd_o2s:
          db 67h
          lodsd
          or   es:[edi],eax
          add  edi,4
          dec  ecx
        jnz @lpd_o2s

        and   edx,11b
        jz    @end_o2s
        @lpb2_o2s:
          db 67h
          lodsb
          or    es:[edi],al
          add   edi,1
          dec   edx
        jnz @lpb2_o2s
        @end_o2s:
        pop   ds
        ret
or2screen_386 endp

or2screen_mmx proc      ;optimized for 64-Bit address output and MMX
arg source:pword,dest:pword,count:dword
        lfs   esi,source
        les   edi,dest
        mov   ecx,count
        mov   edx,ecx
        cmp   ecx,8
        jb    @start_o2smx
        mov   ecx,edi
        and   ecx,111b
        jz    @iszero_o2smx
        xor   ecx,111b
        inc   ecx
        sub   edx,ecx
        @lpb1_o2smx:
          mov  al,fs:[esi]
          or   es:[edi],al
          add  edi,1
          add  esi,1
          dec  ecx
        jnz @lpb1_o2smx
        @iszero_o2smx:
          mov   ecx,edx
        @start_o2smx:
        shr   ecx,3
        jz    @bel8_o2smx
          @lp_o2smx:
          movq  mm0,es:[edi],2
          por   mm0,fs:[esi],2
          movq  es:[edi],mm0,2
          add   esi,8
          add   edi,8
          dec   ecx
          jnz   @lp_o2smx
        emms               ;reset
        @bel8_o2smx:
        and   edx,111b
        jz    @end_o2smx
        @lpb2_o2smx:
          mov  al,fs:[esi]
          or   es:[edi],al
          add  edi,1
          add  esi,1
          dec  edx
        jnz @lpb2_o2smx
        @end_o2smx:
        ret
or2screen_mmx endp

CODE ENDS
     END

