{$A+,B-,F+,G+,N+,P+,Q-,R-,T-,V+,X+}
{****************************************************************************
 * Color unit for GX2 - copyright (c) 1998-2000 by Stefan Goehler           *
 * Don't use these procedures directly without reason or knowledge about    *
 * them! Every tgrafx-object contains rgb and dergb, which also respect the *
 * current color resolution                                                 *
 *                                                                          *
 * License agreement in gx2.txt - illegal copy without this file!           *
 * Complete package and new version always available here:                  *
 * http://sourcenet.home.pages.de                                           *
 ****************************************************************************}
{ Color space conversion routines }
{$IFNDEF DPMI}
  !Real mode not supported!
  This unit is fully 32 bit oriented, so forget about real mode.
  You need BP7 to use protected mode. If you have it, please
  switch at compiler/platform to PM (start bp.exe!)
{$ENDIF}
unit gx_col;
interface
uses gx_glob,newfrontier;

  function getcnvproc(sourcebpp,destbpp,flags : longint) : pcnvproc;

  function   rgb_15(r,g,b : byte) : longint;
  function   rgb_16(r,g,b : byte) : longint;
  function   rgb_2432(r,g,b : byte) : longint;
  procedure  dergb_15(col : longint;var rgb : trgb);
  procedure  dergb_16(col : longint;var rgb : trgb);
  procedure  dergb_2432(l : longint;var rgb : trgb);

  { Linked procedures - don't touch them if you have no clue about them! }
  procedure   pal_24to32(source,dest : pointer48;count : longint);
  procedure   pal_32to15(source,dest : pointer48;count : longint);
  procedure   pal_32to16(source,dest : pointer48;count : longint);
  procedure   pal_32to24(source,dest : pointer48;count : longint);
  procedure   pal_32to24_swap(source,dest : pointer48;count : longint);
  procedure   conv_1to1516(source,dest : pointer48;count : longint);
  procedure   conv_1to32(source,dest : pointer48;count : longint);
  procedure   conv_4to1516(source,dest : pointer48;count : longint);
  procedure   conv_4to32(source,dest : pointer48;count : longint);
  procedure   conv_8to1516(source,dest : pointer48;count : longint);
  procedure   conv_8to24(source,dest : pointer48;count : longint);
  procedure   conv_8to32(source,dest : pointer48;count : longint);
  procedure   conv_15to16(source,dest : pointer48;count : longint);
  procedure   conv_15to16_swap(source,dest : pointer48;count : longint);
  procedure   conv_15to24(source,dest : pointer48;count : longint);
  procedure   conv_15to24_swap(source,dest : pointer48;count : longint);
  procedure   conv_15to32(source,dest : pointer48;count : longint);
  procedure   conv_15to32_swap(source,dest : pointer48;count : longint);
  procedure   conv_16to15(source,dest : pointer48;count : longint);
  procedure   conv_16to15_swap(source,dest : pointer48;count : longint);
  procedure   conv_16to24(source,dest : pointer48;count : longint);
  procedure   conv_16to24_swap(source,dest : pointer48;count : longint);
  procedure   conv_16to32(source,dest : pointer48;count : longint);
  procedure   conv_16to32_swap(source,dest : pointer48;count : longint);
  procedure   conv_24to15_386(source,dest : pointer48;count : longint);
  procedure   conv_24to15_386_swap(source,dest : pointer48;count : longint);
  procedure   conv_24to16_386(source,dest : pointer48;count : longint);
  procedure   conv_24to16_386_swap(source,dest : pointer48;count : longint);
  procedure   conv_24to32(source,dest : pointer48;count : longint);
  procedure   conv_24to32_swap(source,dest : pointer48;count : longint);
  procedure   conv_32to15_386(source,dest : pointer48;count : longint);
  procedure   conv_32to15_386_swap(source,dest : pointer48;count : longint);
  procedure   conv_32to16_386(source,dest : pointer48;count : longint);
  procedure   conv_32to15_mmx(source,dest : pointer48;count : longint);
  procedure   conv_32to15_mmx_swap(source,dest : pointer48;count : longint);
  procedure   conv_32to16_mmx(source,dest : pointer48;count : longint);
  procedure   conv_32to16_mmx_swap(source,dest : pointer48;count : longint);
  procedure   conv_32to16_386_swap(source,dest : pointer48;count : longint);
  procedure   conv_32to24(source,dest : pointer48;count : longint);
  procedure   conv_32to24_swap(source,dest : pointer48;count : longint);
  procedure   dith4x4_32to16(source,dest : pointer48;count : longint);
  procedure   dith4x4_32to16_swap(source,dest : pointer48;count : longint);
  procedure   dith4x4_32to15(source,dest : pointer48;count : longint);
  procedure   dith4x4_32to15_swap(source,dest : pointer48;count : longint);
  procedure   dith4x4_24to16(source,dest : pointer48;count : longint);
  procedure   dith4x4_24to16_swap(source,dest : pointer48;count : longint);
  procedure   dith4x4_24to15(source,dest : pointer48;count : longint);
  procedure   dith4x4_24to15_swap(source,dest : pointer48;count : longint);
  procedure   swap_24(source,dest : pointer48;count : longint);
  procedure   swap_32(source,dest : pointer48;count : longint);

const
  conv_24to15      : procedure(source,dest : pointer48;count : longint) = conv_24to15_386;
  conv_24to16      : procedure(source,dest : pointer48;count : longint) = conv_24to16_386;
  conv_32to15      : procedure(source,dest : pointer48;count : longint) = conv_32to15_386;
  conv_32to15_swap : procedure(source,dest : pointer48;count : longint) = conv_32to15_386_swap;
  conv_32to16      : procedure(source,dest : pointer48;count : longint) = conv_32to16_386;
  conv_32to16_swap : procedure(source,dest : pointer48;count : longint) = conv_32to16_386_swap;

implementation

function getcnvproc(sourcebpp,destbpp,flags : longint) : pcnvproc;
{!! no swapping if bpp the same in 15/16 bpp}
begin
  getcnvproc  := nil;
  case sourcebpp of
    15 : case destbpp of
           16 : if (flags and cnvswap = 0) then getcnvproc := @conv_15to16 else getcnvproc := @conv_15to16_swap;
           24 : if (flags and cnvswap = 0) then getcnvproc := @conv_15to24 else getcnvproc := @conv_15to24_swap;
           32 : if (flags and cnvswap = 0) then getcnvproc := @conv_15to32 else getcnvproc := @conv_15to32_swap;
           15 : getcnvproc := @move2screen;
           else exit;
         end;
    16 : case destbpp of
           15 : if (flags and cnvswap = 0) then getcnvproc := @conv_16to15 else getcnvproc := @conv_16to15_swap;
           24 : if (flags and cnvswap = 0) then getcnvproc := @conv_16to24 else getcnvproc := @conv_16to24_swap;
           32 : if (flags and cnvswap = 0) then getcnvproc := @conv_16to32 else getcnvproc := @conv_16to32_swap;
           16 : getcnvproc := @move2screen;
           else exit;
         end;
    24 : case destbpp of
           15 : if (flags and cnvdither <> 0) then
                begin
                  if (flags and cnvswap = 0) then
                   getcnvproc := @dith4x4_24to15 else getcnvproc := @dith4x4_24to15_swap;
                end else begin
                  if (flags and cnvswap = 0) then
                   getcnvproc := @conv_24to15 else getcnvproc := @conv_24to15_386_swap;
                end;
           16 : if (flags and cnvdither <> 0) then
                begin
                  if (flags and cnvswap = 0) then
                   getcnvproc := @dith4x4_24to16 else getcnvproc := @dith4x4_24to16_swap;
                end else begin
                  if (flags and cnvswap = 0) then
                   getcnvproc := @conv_24to16 else getcnvproc := @conv_24to16_386_swap;
                end;
           32 : if (flags and cnvswap = 0) then getcnvproc := @conv_24to32 else getcnvproc := @conv_24to32_swap;
           24 : if (flags and cnvswap = 0) then getcnvproc := @move2screen else getcnvproc := @swap_24;
           else exit;
         end;
    32 : case destbpp of
           15 : if (flags and cnvdither <> 0) then
                begin
                  if (flags and cnvswap = 0) then
                   getcnvproc := @dith4x4_32to15 else getcnvproc := @dith4x4_32to15_swap;
                end else begin
                  if (flags and cnvswap = 0) then
                   getcnvproc := @conv_32to15 else getcnvproc := @conv_32to15_swap;
                end;
           16 : if (flags and cnvdither <> 0) then
                begin
                  if (flags and cnvswap = 0) then
                   getcnvproc := @dith4x4_32to16 else getcnvproc := @dith4x4_32to16_swap;
                end else begin
                  if (flags and cnvswap = 0) then
                   getcnvproc := @conv_32to16 else getcnvproc := @conv_32to16_swap;
                end;
           24 : if (flags and cnvswap = 0) then getcnvproc := @conv_32to24 else getcnvproc := @conv_32to24_swap;
           32 : if (flags and cnvswap = 0) then getcnvproc := @move2screen else getcnvproc := @swap_32;
           else exit;
         end;
    8  : case destbpp of
           15,16 : getcnvproc := @conv_8to1516;
           24    : getcnvproc := @conv_8to24;
           32    : getcnvproc := @conv_8to32;
           8     : getcnvproc := @move2screen;
           else exit;
         end;
    4  : case destbpp of
           15,16 : getcnvproc := @conv_4to1516;
           32    : getcnvproc := @conv_4to32;
           4     : getcnvproc := @move2screen;
           else exit;
         end;
    1  : case destbpp of
           15,16 : getcnvproc := @conv_1to1516;
           32    : getcnvproc := @conv_1to32;
           1     : getcnvproc := @move2screen;
           else exit;
         end;
    else exit;
  end;
end;


{$L GX_CNV}
procedure pal_24to32;external;
procedure pal_32to16;external;
procedure pal_32to15;external;
procedure pal_32to24;external;
procedure pal_32to24_swap;external;
procedure conv_1to1516;external;
procedure conv_1to32;external;
procedure conv_4to1516;external;
procedure conv_4to32;external;
procedure conv_8to1516;external;
procedure conv_8to24;external;
procedure conv_8to32;external;
procedure conv_15to16;external;
procedure conv_15to16_swap;external;
procedure conv_15to24;external;
procedure conv_15to24_swap;external;
procedure conv_15to32;external;
procedure conv_15to32_swap;external;
procedure conv_16to15;external;
procedure conv_16to15_swap;external;
procedure conv_16to24;external;
procedure conv_16to24_swap;external;
procedure conv_16to32;external;
procedure conv_16to32_swap;external;
procedure conv_24to15_386;external;
procedure conv_24to15_386_swap;external;
procedure conv_24to16_386;external;
procedure conv_24to16_386_swap;external;
procedure conv_24to32;external;
procedure conv_24to32_swap;external;
procedure conv_32to15_386;external;
procedure conv_32to15_386_swap;external;
procedure conv_32to16_386;external;
procedure conv_32to15_mmx;external;
procedure conv_32to15_mmx_swap;external;
procedure conv_32to16_mmx;external;
procedure conv_32to16_mmx_swap;external;
procedure conv_32to16_386_swap;external;
procedure conv_32to24;external;
procedure conv_32to24_swap;external;
procedure dith4x4_24to15;external;
procedure dith4x4_24to15_swap;external;
procedure dith4x4_24to16;external;
procedure dith4x4_24to16_swap;external;
procedure dith4x4_32to15;external;
procedure dith4x4_32to15_swap;external;
procedure dith4x4_32to16;external;
procedure dith4x4_32to16_swap;external;
procedure swap_24;external;
procedure swap_32;external;

function rgb_8(r,g,b : byte;var mode : tmode) : longint;assembler;
{!!}
var
  cr,cg,cb : integer;
asm
  les   di,mode
  cmp   es:[di].tmode.palchanged,true
  je    @fastrgb
  xor   ah,ah
  mov   al,r
  mov   cr,ax
  mov   al,g
  mov   cg,ax
  mov   al,b
  mov   cb,ax
  mov   es,es:[di].tmode.virtpal
  xor   si,si
  db    66h;mov cx,0FFFFh;dw 0FFFFh
  mov   ah,255
  sub   cr,256
  sub   cg,256
  sub   cb,256
@lp:
  mov   bx,es:[si]
  mov   dh,es:[si+2]
  mov   dl,bh
  xor   bh,bh
  sub   bx,cr
  shl   bx,2
{  db    66h;mov di,word ptr square[bx]}
  xor   bh,bh
  mov   bl,dl
  sub   bx,cg
  shl   bx,2
{  db    66h;add di,word ptr square[bx]}
  xor   bh,bh
  mov   bl,dh
  sub   bx,cb
  shl   bx,2
{  db    66h;add di,word ptr square[bx]}
  add   si,3
  db    66h;cmp di,cx
  jnb   @1
    db    66h;mov cx,di
    mov   al,ah
@1:
  dec   ah
  jnz   @lp
  not   al
  jmp   @end
@fastrgb:
  mov   bl,r
  shr   bl,4
  xor   bh,bh
  mov   al,g
  mov   cl,b
  and   ax,11110000b
  shl   cx,4
  and   cx,111100000000b
  or    bx,ax
  or    bx,cx
  mov   al,es:[di].tmode.rgbdata[bx].byte
@end:
  xor   dx,dx
  xor   ah,ah
end;

procedure dergb_8(l : longint;var r,g,b : byte;var mode : tmode);assembler;
asm
  les   di,mode
  xor   bh,bh
  mov   bl,byte ptr l
  shl   bx,2
  mov   es,es:[di].tmode.virtpal
  mov   ax,es:[bx]
  mov   cl,es:[bx+2]
  les   di,r
  mov   byte ptr es:[di],al
  les   di,g
  mov   byte ptr es:[di],ah
  les   di,b
  mov   byte ptr es:[di],cl
end;

function rgb_15(r,g,b : byte) : longint;assembler;
asm
  mov   al,b
  mov   ah,g
  mov   bl,r
  shr   ah,3
  and   bl,11111000b
  shr   ax,3
  shr   bl,1
  or    ah,bl
  xor   dx,dx
end;

function rgb_16(r,g,b : byte) : longint;assembler;
asm
  mov   al,b
  mov   ah,g
  shr   ah,2
  mov   bl,r
  shr   ax,3
  and   bl,11111000b
  or    ah,bl
  xor   dx,dx
end;

function rgb_2432(r,g,b : byte) : longint;assembler;
asm
  mov   al,b
  mov   ah,g
  mov   dl,r
  xor   dh,dh
end;

procedure dergb_15(col : longint;var rgb : trgb);assembler;
asm
  mov   ax,col.word
  mov   bx,ax
  shl   al,3
  les   di,rgb
  mov   es:[di],al
  mov   ax,bx
  and   bh,1111100b
  and   ax,1111100000b
  shr   ax,2
  add   bh,bh
  mov   es:[di+1],al
  mov   es:[di+2],bh
end;

procedure dergb_16(col : longint;var rgb : trgb);assembler;
asm
  mov   ax,col.word
  mov   bx,ax
  and   ax,1111100000011111b
  shl   al,3
  les   di,rgb
  and   bx,11111100000b
  shl   bx,5
  mov   bl,al
  mov   es:[di+2],ah
  mov   es:[di],bx
end;

procedure dergb_2432(l : longint;var rgb : trgb);assembler;
asm
  les   di,rgb
  mov   al,byte ptr l
  mov   es:[di],al
  mov   ax,l.word[1]
  mov   es:[di+1],ax
end;

procedure getrgb_gen(col : word;var rgb : trgb;var mode : tmode);assembler;
asm
         les   di,mode
         mov   bx,col
         shl   bx,2
         push  ds
         mov   ds,es:[di].tmode.virtpal
         les   di,rgb
  db 66h;mov   ax,ds:[bx].word
  db 66h;mov   es:[di].word,ax
         pop   ds
end;

procedure setrgb_gen(col,r,g,b : word;var mode : tmode);assembler;
asm
  les   di,mode
  mov   es:[di].tmode.palchanged,true
  mov   bx,col
  mov   es,es:[di].tmode.virtpal
  shl   bx,2
  mov   al,r.byte
  mov   ch,g.byte
  mov   es:[bx],cx
  mov   al,b.byte
  mov   es:[bx+2],al
end;

procedure setrgb_8_6(col,r,g,b : word;var mode : tmode);assembler;
asm
  les   di,mode
  mov   es:[di].tmode.palchanged,true
  mov   ax,col
  mov   es,es:[di].tmode.virtpal
  mov   bx,ax
  shl   bx,2
  mov   dx,03C8h
  out   dx,al
  inc   dx
  mov   al,r.byte
  mov   cl,al
  shr   al,2
  out   dx,al
  mov   al,g.byte
  mov   ch,al
  mov   es:[bx],cx
  shr   al,2
  out   dx,al
  mov   al,b.byte
  mov   es:[bx+2],al
  shr   al,2
  out   dx,al
end;

procedure setrgb_8_8(col,r,g,b : word;var mode : tmode);assembler;
asm
  les   di,mode
  mov   es:[di].tmode.palchanged,true
  mov   ax,col
  mov   es,es:[di].tmode.virtpal
  mov   bx,ax
  shl   bx,2
  mov   dx,03C8h
  out   dx,al
  inc   dx
  mov   al,r.byte
  mov   cl,al
  out   dx,al
  mov   al,g.byte
  mov   ch,al
  mov   es:[bx],cx
  out   dx,al
  mov   al,b.byte
  mov   es:[bx],al
  out   dx,al
end;

procedure cmyk2rgb(c,y,m,k : byte;var rgb : trgb);
var
  tk : single;
begin
  tk := (255 - k) / 255;
  rgb.r := round(c * tk + k);
  rgb.g := round(y * tk + k);
  rgb.b := round(m * tk + k);
end;

procedure rgb2hsv(rgb : trgb;hsv : thsv);
var
  min,max,v : word;
  s         : double;
begin
  min := 255;
  if rgb.r < min then min := rgb.r;
  if rgb.g < min then min := rgb.g;
  if rgb.b < min then min := rgb.b;

  max := 0;
  if rgb.r > max then max := rgb.r;
  if rgb.g > max then max := rgb.g;
  if rgb.b > max then max := rgb.b;
  v := max;
  if max <> 0 then
   s := (max-min)/max else s := 0;

end;

procedure hsi2rgb(H,S,I : double;var c : trgb);
var
  t        : double;
  rv,gv,bv : double;
begin
  t   := h;
  rv  := 1+s*sin(t-2*pi/3);
  gv  := 1+s*sin(t);
  bv  := 1+s*sin(t+2*pi/3);
  t   := 255.999*i/2;
  c.l := trunc(bv*t)+trunc(gv*t) shl 8+trunc(rv*t) shl 16;
end;

procedure rgb2yuv(rgb : trgb;var yuv : tyuv);
begin
  yuv.y := trunc(0.3*rgb.r+0.59*rgb.g+0.11*rgb.g);
  yuv.u := trunc((rgb.b-yuv.y)*0.493);
  yuv.v := trunc((rgb.r-yuv.y)*0.877);
end;

procedure rgb2cmy(rgb : trgb;var cmy : tcmy);
begin
  cmy.c := 1-rgb.r;
  cmy.m := 1-rgb.g;
  cmy.y := 1-rgb.b;
end;

procedure cmy2rgb(cmy : tcmy;var rgb : trgb);
begin
  rgb.r := 1-cmy.c;
  rgb.g := 1-cmy.m;
  rgb.b := 1-cmy.y;
end;

procedure cmy2cmyk(cmy : tcmy;var cmyk : tcmyk);
begin
  cmyk.k := cmy.c;
  if cmyk.k < cmy.m then cmyk.k := cmy.m;
  if cmyk.k < cmy.y then cmyk.k := cmy.y;
  cmyk.c := (cmy.c-cmyk.k) div (1-cmyk.k);
  cmyk.m := (cmy.m-cmyk.k) div (1-cmyk.k);
  cmyk.y := (cmy.y-cmyk.k) div (1-cmyk.k);
end;
{ cmyk to cmy
Cyan    = minimum(1,Cyan*(1-Black)+Black)
Magenta = minimum(1,Magenta*(1-Black)+Black)
Yellow  = minimum(1,Yellow*(1-Black)+Black)
}

procedure switchcpuext(flags : longint);far;
begin
  if flags and cpummx <> 0 then begin
    conv_32to15      := conv_32to15_mmx;
    conv_32to15_swap := conv_32to15_mmx_swap;
    conv_32to16      := conv_32to16_mmx;
    conv_32to16_swap := conv_32to16_mmx_swap;
  end else begin
    conv_32to15      := conv_32to15_386;
    conv_32to15_swap := conv_32to15_386_swap;
    conv_32to16      := conv_32to16_386;
    conv_32to16_swap := conv_32to16_386_swap;
  end;
end;

begin
  cnvpal := gfxbufptr; { For safety }
  registercpuswitch(@switchcpuext);
  switchcpuext(cpuext);
end.