{$A+,B-,F+,G+,N+,P+,Q-,R-,T-,V+,X+}
{****************************************************************************
 * GX2 FX library - copyright (c) 1998-2000 by Stefan Goehler               *
 * License agreement in gx2.txt - illegal copy without this file!           *
 * Complete package and new version always available here:                  *
 * http://sourcenet.home.pages.de                                           *
 ****************************************************************************}
unit gx_fx;

interface
uses gx_glob,newfrontier,gx_image,grafx2,gx_col;

const
  fadedefault  = 0;
  fadedown     = 1;
  faderight    = 2;

  procedure   fadeshade(screen : tgrafx;direction,col : longint);
  procedure   fadecircle(screen : tgrafx;percent,direction,col,flags : longint);

  function    rotate_image(source : timage;var dest : timage;angle : double;transcol : longint) : word;
  function    blockout(source : timage;var dest : timage;xblock,yblock : word) : word;
  function    fadeout_image(image : timage;strength : longint) : word;
  function    fadewhite_image(image : timage;strength : longint) : word;
  function    brightness_image(source,dest : timage;bright : byte) : word;
  function    brightness_alpha(image : timage;bright : byte) : word;
  function    contrast_image(source,dest : timage;contrast : integer) : word;
  function    blend(source1,source2 : timage;var dest : timage;coverage : byte) : word;
  function    blur_image(image : timage) : word;
  function    doublesize_image(source : timage;var dest : timage) : word;
  function    halfsize_image(source : timage;var dest : timage) : word;
  function    scale_image(source : timage;var dest : timage;sx,sy,destbpp,flags : longint) : word;
  function    rgb2bw(source : timage;var dest : timage) : word;
  function    scaleup_image(source : timage;var dest : timage;xfact,yfact : word) : word;
  function    dithermix_image(source1,source2 : timage;var dest : timage) : word;
  function    mirror_image(image : timage) : word;

  {Warning! Experimental!}
  function    fadered_image(source,dest : timage;val : byte) : word;

  { Linked procedures - access them only if you really need and know how }
  procedure   rotate_8(source,dest,tables : pointer48;sizex,ysin,ycos,transcol : longint);
  procedure   rotate_1516(source,dest,tables : pointer48;sizex,ysin,ycos,transcol : longint);
  procedure   rotate_24(source,dest,tables : pointer48;sizex,ysin,ycos,transcol : longint);
  procedure   rotate_32(source,dest,tables : pointer48;sizex,ysin,ycos,transcol : longint);
  procedure   rotate_8_trans(source,dest,tables : pointer48;sizex,ysin,ycos,transcol : longint);
  procedure   rotate_1516_trans(source,dest,tables : pointer48;sizex,ysin,ycos,transcol : longint);
  procedure   rotate_24_trans(source,dest,tables : pointer48;sizex,ysin,ycos,transcol : longint);
  procedure   rotate_32_trans(source,dest,tables : pointer48;sizex,ysin,ycos,transcol : longint);
  procedure   block_8(source,dest : pointer48;count : longint;blocking : word);
  procedure   block_1516(source,dest : pointer48;count : longint;blocking : word);
  procedure   block_24(source,dest : pointer48;count : longint;blocking : word);
  procedure   block_32(source,dest : pointer48;count : longint;blocking : word);
  procedure   fadeout_15(data : pointer48;count,strength : longint);
  procedure   fadeout_16(data : pointer48;count,strength : longint);
  procedure   fadeout_24_386(data : pointer48;count,strength : longint);
  procedure   fadeout_32_386(data : pointer48;count,strength : longint);
  procedure   fadeout_32_mmx(data : pointer48;count,strength : longint);
  procedure   fadewhite_15(data : pointer48;count,strength : longint);
  procedure   fadewhite_16(data : pointer48;count,strength : longint);
  procedure   fadewhite_24_386(data : pointer48;count,strength : longint);
  procedure   fadewhite_32_386(data : pointer48;count,strength : longint);
  procedure   fadewhite_32_mmx(data : pointer48;count,strength : longint);
  procedure   brightness_15_386(source,dest : pointer48;count : longint;bright : byte);
  procedure   brightness_16_386(source,dest : pointer48;count : longint;bright : byte);
  procedure   brightness_24_386(source,dest : pointer48;count : longint;bright : byte);
  procedure   brightness_32_386(source,dest : pointer48;count : longint;bright : byte);
  procedure   brightness_24_mmx(source,dest : pointer48;count : longint;bright : byte);
  procedure   brightness_32_mmx(source,dest : pointer48;count : longint;bright : byte);
  procedure   contrastdown_15_386(source,dest : pointer48;count : longint;bright : byte);
  procedure   contrastdown_16_386(source,dest : pointer48;count : longint;bright : byte);
  procedure   contrastdown_24_386(source,dest : pointer48;count : longint;bright : byte);
  procedure   contrastdown_32_386(source,dest : pointer48;count : longint;bright : byte);
  procedure   contrastup_15_386(source,dest : pointer48;count : longint;bright : byte);
  procedure   contrastup_16_386(source,dest : pointer48;count : longint;bright : byte);
  procedure   contrastup_24_386(source,dest : pointer48;count : longint;bright : byte);
  procedure   contrastup_32_386(source,dest : pointer48;count : longint;bright : byte);
  procedure   contrast_32_mmx(source,dest : pointer48;count : longint;bright : byte);
  procedure   brightness_chn(data : pointer48;count : longint;bright : byte);
  procedure   rgb2bw_24(source,dest : pointer48;count : longint);
  procedure   rgb2bw_32(source,dest : pointer48;count : longint);
  procedure   blur_32_386(data : pointer48;bpl : longint);
  procedure   blur_24_386(data : pointer48;bpl : longint);
  procedure   blur_32_mmx(data : pointer48;bpl : longint);
  procedure   fadered_32(source,dest : pointer48;count : longint;cover : byte);
  procedure   scaleup_8(source,dest,table : pointer48;count,yval : longint);
  procedure   scaleup_1516(source,dest,table : pointer48;count,yval : longint);
  procedure   scaleup_24(source,dest,table : pointer48;count,yval : longint);
  procedure   scaleup_32(source,dest,table : pointer48;count,yval : longint);
  procedure   dithmix_8(source1,source2,dest : pointer48;sizex,ypos : longint);
  procedure   dithmix_1516(source1,source2,dest : pointer48;sizex,ypos : longint);
  procedure   dithmix_32(source1,source2,dest : pointer48;sizex,ypos : longint);
  procedure   mirror_8(data : pointer48;sizex : longint);
  procedure   mirror_16(data : pointer48;sizex : longint);
  procedure   mirror_24(data : pointer48;sizex : longint);
  procedure   mirror_32(data : pointer48;sizex : longint);

const
  fadewhite_24  : procedure(data : pointer48;count,strength : longint) = fadewhite_24_386;
  fadeout_24    : procedure(data : pointer48;count,strength : longint) = fadeout_24_386;
  brightness_24 : procedure(source,dest : pointer48;count : longint;bright : byte) = brightness_24_386;
  fadewhite_32  : procedure(data : pointer48;count,strength : longint) = fadewhite_32_386;
  fadeout_32    : procedure(data : pointer48;count,strength : longint) = fadeout_32_386;
  brightness_32 : procedure(source,dest : pointer48;count : longint;bright : byte) = brightness_32_386;
  blur_24       : procedure(data : pointer48;bpl : longint) = blur_24_386;
  blur_32       : procedure(data : pointer48;bpl : longint) = blur_32_386;


implementation
{$L GX_FX}
procedure rotate_8;external;
procedure rotate_1516;external;
procedure rotate_24;external;
procedure rotate_32;external;
procedure rotate_8_trans;external;
procedure rotate_1516_trans;external;
procedure rotate_24_trans;external;
procedure rotate_32_trans;external;
procedure block_8;external;
procedure block_1516;external;
procedure block_24;external;
procedure block_32;external;
procedure fadeout_15;external;
procedure fadeout_16;external;
procedure fadeout_24_386;external;
procedure fadeout_32_386;external;
procedure fadeout_32_mmx;external;
procedure fadewhite_15;external;
procedure fadewhite_16;external;
procedure fadewhite_24_386;external;
procedure fadewhite_32_386;external;
procedure fadewhite_32_mmx;external;
procedure brightness_15_386;external;
procedure brightness_16_386;external;
procedure brightness_24_386;external;
procedure brightness_32_386;external;
procedure brightness_24_mmx;external;
procedure brightness_32_mmx;external;
procedure brightness_chn;external;
procedure contrastdown_15_386;external;
procedure contrastdown_16_386;external;
procedure contrastdown_24_386;external;
procedure contrastdown_32_386;external;
procedure contrastup_15_386;external;
procedure contrastup_16_386;external;
procedure contrastup_24_386;external;
procedure contrastup_32_386;external;
procedure contrast_32_mmx;external;
procedure rgb2bw_24;external;
procedure rgb2bw_32;external;
procedure blur_24_386;external;
procedure blur_32_386;external;
procedure blur_32_mmx;external;
procedure fadered_32;external;
procedure scaleup_8;external;
procedure scaleup_1516;external;
procedure scaleup_24;external;
procedure scaleup_32;external;
procedure dithmix_8;external;
procedure dithmix_1516;external;
procedure dithmix_32;external;
procedure mirror_8;external;
procedure mirror_16;external;
procedure mirror_24;external;
procedure mirror_32;external;

procedure fadeshade(screen : tgrafx;direction,col : longint);
var
  i,i2 : integer;
begin
  case direction of
    fadedown,fadedefault:
    for i := 0 to 19 do begin
      waitretrace;
      for i2 := 0 to screen.maxy div 10 do screen.hline(0,i2*20+i,screen.maxx+1,col);
    end;
    faderight:
    for i := 0 to 19 do begin
      waitretrace;
      for i2 := 0 to screen.maxx div 10 do screen.vline(i2*20+i,0,screen.maxy+1,col);
    end;
    fadedown+faderight:
    for i := 0 to 19 do begin
      waitretrace;
      for i2 := 0 to screen.maxx div 10 do begin
        screen.vline(i2*20+i,0,screen.maxy+1,col);

        if i2*10 < screen.maxy then screen.hline(0,i2*20+i,screen.maxx+1,col);
      end;
    end;
  end;
end;

procedure fadecircle(screen : tgrafx;percent,direction,col,flags : longint);
var
  x,y : longint;
  i   : integer;
begin
  case direction of
    fadedefault:
    begin
      for y := 0 to screen.maxy div 40 do
      for x := 0 to screen.maxx div 40 do begin

        screen.fillcircle(x*40+20,y*40+20,round(280/(101-percent)),col,flags);
      end;
    end;
    fadedown:
    for i := -screen.maxy div 40 to 28 do begin
      for y := 0 to screen.maxy div 40 do
      for x := 0 to screen.maxx div 40 do
      if screen.maxy div 40-y+i < 29 then screen.fillcircle(x*40+20,y*40+20,screen.maxy div 40-y+i,col,flags);
    end;
    faderight:
    for i := -screen.maxx div 40 to 28 do begin
      for y := 0 to screen.maxy div 40 do
      for x := 0 to screen.maxx div 40 do
      if screen.maxx div 40-x+i < 29 then screen.fillcircle(x*40+20,y*40+20,screen.maxx div 40-x+i,col,flags);
    end;
    faderight+fadedown:
    for i := -screen.maxx div 40 to 60 do begin
      for y := 0 to screen.maxy div 40 do
      for x := 0 to screen.maxx div 40 do
      if screen.maxx div 40-x-y+i < 29 then screen.fillcircle(x*40+20,y*40+20,screen.maxx div 40-x-y+i,col,flags);
    end;
  end;
end;

function rotate_image(source : timage;var dest : timage;angle : double;transcol : longint) : word;
{ Source is the image to rotate, Dest is the image where it should be
  rotated. Source and Dest must not be equal, but need to have the same
  color depth. Dest is automatically opened at the conditions of Source
  if it's not open with function call.
  Angle is the rotation angle. Minimal value is 0, maximum val is 3599
  (0.1 degree resolution)
  Transcol is the color which is being used if the image doesn't
  cover the area. Set it to $FFFFFFFF if nothing should be drawn to
  these areas.
  }
var
  imgptr,srcptr  : pointer48;
  xaxis,yaxis    : longint;
  l              : longint;
  costheta       : double;
  x,y            : integer;
  xprime         : integer;
  yprime         : integer;
  sintheta       : double;
  theta          : double;
  rotate         : procedure(source,dest,tables : pointer48;sizex,ysin,ycos,transcol : longint);
  xsin,xcos      : double;
  ysin,ycos      : double;
  err            : word;
const
  pxsincos = 0;
  pimgp    = 87386;
  pdsx     = 131064;
  pdsy     = 131068;

begin
  rotate_image := errfalsebpp;
  if transcol <> $FFFFFFFF then
  case source.bpp of
    8     : rotate := rotate_8;
    15,16 : rotate := rotate_1516;
    24    : rotate := rotate_24;
    32    : rotate := rotate_32;
    else exit;
  end else
  case source.bpp of
    8     : rotate := rotate_8_trans;
    15,16 : rotate := rotate_1516_trans;
    24    : rotate := rotate_24_trans;
    32    : rotate := rotate_32_trans;
    else exit;
  end;
  rotate_image := errnotopen;
  if (source.id <> idimage)or(source.data = 0) then exit;
  if (dest.id <> idimage)or(dest.data = 0) then begin
    err := openimage(dest,source.sizex,source.sizey,source.bpp,1,source.flags);
    rotate_image := err;
    if err <> errnoerror then exit;
  end;
  rotate_image := errtoolarge;
  if (dest.sizex > pimgp shr 3)or(dest.sizey > pimgp shr 3) then exit;
  rotate_image := errfalsebpp;
  if source.bpp <> dest.bpp then exit;

  xaxis := dest.sizex shr 1;
  yaxis := dest.sizey shr 1;
  theta := ((180-angle))*pi/180;
  sintheta := sin(theta);
  costheta := cos(theta);
  writemem32l(ptr48(gfxbufsel,pdsx),source.sizex);
  writemem32l(ptr48(gfxbufsel,pdsy),source.sizey);
  xprime := 2*(-xaxis){+1};
  xsin := xprime*sintheta-1;
  xcos := xprime*costheta-1+source.sizex;
  sintheta := sintheta*2;
  costheta := costheta*2;
  for x := 0 to dest.sizex-1 do begin
    writemem32l(ptr48(gfxbufsel,x shl 3),round(xsin));
    writemem32l(ptr48(gfxbufsel,x shl 3+4),round(xcos));
    xsin := xsin+sintheta;
    xcos := xcos+costheta;
  end;
  sintheta := sintheta/2;
  costheta := costheta/2;
  l := source.imagestart;
  for y := 0 to dest.sizey-1 do begin
    writemem32l(ptr48(gfxbufsel,y shl 2+pimgp),l);
    inc(l,source.bpl);
  end;
  imgptr := ptr48(dest.data,dest.imagestart);

  yprime := 2*(pred(dest.sizey)-yaxis)+1;
  ysin   := yprime*sintheta;
  ycos   := yprime*costheta+source.sizey;
  sintheta := sintheta*2;
  costheta := costheta*2;
  srcptr := ptr48(source.data,source.imagestart);

  for y := dest.sizey-1 downto 0 do
  begin
    rotate(srcptr,imgptr,gfxbufptr,
           dest.sizex,round(ysin),round(ycos),transcol);
    inc(tselofs32(imgptr).offset32,dest.bpl);
    ysin := ysin-sintheta;
    ycos := ycos-costheta;
  end;
  rotate_image := errnoerror;
end;

function blockout(source : timage;var dest : timage;xblock,yblock : word) : word;
{ Mosaic outfading. The larger x/yblock are, the more blocky the image looks }
var
  block : procedure(source,dest : pointer48;count : longint;blocking : word);
  y     : longint;
  img1ptr,img2ptr : pointer48;
begin
  if (dest.id <> idimage)or(dest.data = 0)or(dest.bpp <> source.bpp)or
     (source.flags <> dest.flags)
     then openimage(dest,source.sizex,source.sizey,source.bpp,1,imdefault);
  blockout := errfalsebpp;
  case source.bpp of
     8     : block := block_8;
     15,16 : block := block_1516;
     24    : block := block_24;
     32    : block := block_32;
     else exit;
  end;
  img1ptr := ptr48(source.data,source.imagestart);
  img2ptr := ptr48(dest.data,dest.imagestart);
  if xblock = 0 then xblock := 1;
  if yblock = 0 then yblock := 1;
  if (xblock = 1)and(yblock = 1) then
  for y := 0 to source.sizey-1 do begin
    move2(img1ptr,img2ptr,source.bpl);
    inc(tselofs32(img1ptr).offset32,source.bpl);
    inc(tselofs32(img2ptr).offset32,dest.bpl);
  end else
  for y := 0 to source.sizey-1 do begin
    if y mod yblock = 0 then begin
      tselofs32(img1ptr).offset32 := longint(y)*source.bpl+source.imagestart;
      block(img1ptr,img2ptr,source.sizex,xblock);
    end
    else move2(ptr48(dest.data,tselofs32(img2ptr).offset32-dest.bpl),img2ptr,
            dest.bpl);
    inc(tselofs32(img2ptr).offset32,dest.bpl);
  end;
  blockout := errnoerror;
  blockout := errnoerror;
end;

function brightness_image(source,dest : timage;bright : byte) : word;
{ Sets the brightness of an image by multiplying with the bright value.
  The smaller "bright", the darker the image gets. Source and
  destination can be the same.                                         }
var
  brightness      : procedure(source,dest : pointer48;count : longint;bright : byte);
  y               : longint;
  img1ptr,img2ptr : pointer48;
begin
  if (source.id <> idimage)or(source.data = 0)or
     (dest.id <> idimage)or(dest.data = 0) then
  begin
    brightness_image := errnotopen;
    exit;
  end;
  if (source.bpp <> dest.bpp) then begin
    brightness_image := errfalsebpp;
    exit;
  end;
  if (source.sizex <> dest.sizex)or
     (source.sizey <> dest.sizey) then begin
    brightness_image := errwrongsize;
    exit;
  end;
  brightness_image := errfalsebpp;
  case source.bpp of
    15 : brightness := brightness_15_386;
    16 : brightness := brightness_16_386;
    24 : brightness := brightness_24;
    32 : brightness := brightness_32;
    else exit;
  end;
  img1ptr := ptr48(source.data,source.imagestart);
  img2ptr := ptr48(dest.data,dest.imagestart);
  for y := 0 to source.sizey-1 do begin
    brightness(img1ptr,img2ptr,source.bpl,bright);
    inc(tselofs32(img1ptr).offset32,source.bpl);
    inc(tselofs32(img2ptr).offset32,dest.bpl);
  end;
  brightness_image := errnoerror;
end;


function brightness_alpha(image : timage;bright : byte) : word;
{ Sets how much transparent the alphachannel should be. The more
  you get to zero, the more gets the image transparent           }
var
  brightness : procedure(data : pointer48;count : longint;bright : byte);
  y          : longint;
  imgptr     : pointer48;
begin
  if (image.id <> idimage)or(image.data = 0) then
  begin
    brightness_alpha := errnotopen;
    exit;
  end;
  brightness_alpha := errfalsebpp;
  if image.flags and imalpha = 0 then exit;
  imgptr := ptr48(image.data,image.imagestart);
  for y := 0 to image.sizey-1 do begin
    brightness_chn(imgptr,image.sizex,bright);
    inc(tselofs32(imgptr).offset32,image.bpl);
  end;
  brightness_alpha := errnoerror;
end;

function contrast_image(source,dest : timage;contrast : integer) : word;
{
 Calculates new contrast for an image. The range for contrast is
 -255..255. All other values will be clipped.
 Source and destination can be the the same image
}
var
  calc            : procedure(source,dest : pointer48;count : longint;bright : byte);
  y               : longint;
  img1ptr,img2ptr : pointer48;
begin
  if (source.id <> idimage)or(source.data = 0)or
     (dest.id <> idimage)or(dest.data = 0) then
  begin
    contrast_image := errnotopen;
    exit;
  end;
  if (source.bpp <> dest.bpp) then begin
    contrast_image := errfalsebpp;
    exit;
  end;
  if (source.sizex <> dest.sizex)or
     (source.sizey <> dest.sizey) then begin
    contrast_image := errwrongsize;
    exit;
  end;
  if (contrast < -255) then contrast := -255 else
    if (contrast > 255) then contrast := 255;

  contrast_image := errfalsebpp;
  if contrast >= 0 then
  case source.bpp of
    15 :  calc := contrastup_15_386;
    16 :  calc := contrastup_16_386;
    24 :  calc := contrastup_24_386;
    32 :  calc := contrastup_32_386;
    else exit;
  end else
  begin
    contrast := 256+contrast;
    case source.bpp of
      15 :  calc := contrastdown_15_386;
      16 :  calc := contrastdown_16_386;
      24 :  calc := contrastdown_24_386;
      32 :  calc := contrastdown_32_386;
      else exit;
    end;
  end;

  img1ptr := ptr48(source.data,source.imagestart);
  img2ptr := ptr48(dest.data,dest.imagestart);
  if (contrast = 0) then flipimage(source,dest) else
  for y := 0 to source.sizey-1 do begin
    calc(img1ptr,img2ptr,source.bpl,contrast);
    inc(tselofs32(img1ptr).offset32,source.bpl);
    inc(tselofs32(img2ptr).offset32,dest.bpl);
  end;
  contrast_image := errnoerror;
end;

function fadeout_image(image : timage;strength : longint) : word;
{ Fades out an image by decreasing the color values.
  STRENGTH can be in the range 0..255, if r,g and b should be
  decreased by the same value. It can also be defined for each
  color value. Use for that the procedure rgb_2432, which is
  located in gx_col.pas and shift its output left by 8.
  Example: fadeout_image(image,rgb_2432(2,4,8) shl 8);
  Warning: Color modes below 24 BPP need at least a strenght of
  8 per r/g/b!!
  Call this procedure and display the image thereafter. You need
  256/strength calls, until you have a totally black image.}
var
  fade   : procedure(data : pointer48;count,strength : longint);
  y      : longint;
  imgptr : pointer48;
begin
  fadeout_image := errnotopen;
  if (image.id <> idimage)or(image.data = 0) then exit;
  fadeout_image := errfalsebpp;
  if strength and $FF > 0 then strength := rgb_2432(strength,strength,strength)
   else strength := strength shr 8;
  case image.bpp of
    15 : fade := fadeout_15;
    16 : fade := fadeout_16;
    24 : fade := fadeout_24;
    32 : fade := fadeout_32;
    else exit;
  end;
  imgptr := ptr48(image.data,image.imagestart);
  if (image.bpl = image.sizex*image.pixel) then
   fade(imgptr,longint(image.sizey)*image.bpl,strength)
  else for y := 0 to image.sizey-1 do
  begin
    fade(imgptr,image.bpl,strength);
    inc(tselofs32(imgptr).offset32,image.bpl);
  end;
  fadeout_image := errnoerror;
end;

function fadewhite_image(image : timage;strength : longint) : word;
{ Works like the outfader, but fades instead of black to white. }
var
  fade   : procedure(data : pointer48;count,strength : longint);
  y      : longint;
  imgptr : pointer48;
begin
  fadewhite_image := errnotopen;
  if (image.id <> idimage)or(image.data = 0) then exit;
  fadewhite_image := errfalsebpp;
  if strength and $FF > 0 then strength := rgb_2432(strength,strength,strength)
   else strength := strength shr 8;
  case image.bpp of
    15 : fade := fadewhite_15;
    16 : fade := fadewhite_16;
    24 : fade := fadewhite_24;
    32 : fade := fadewhite_32;
    else exit;
  end;
  imgptr := ptr48(image.data,image.imagestart);
  if (image.bpl = image.sizex*image.pixel) then
   fade(imgptr,longint(image.sizey)*image.bpl,strength)
  else for y := 0 to image.sizey-1 do
  begin
    fade(imgptr,image.bpl,strength);
    inc(tselofs32(imgptr).offset32,image.bpl);
  end;
  fadewhite_image := errnoerror;
end;

function blend(source1,source2 : timage;var dest : timage;coverage : byte) : word;
{ Blends over source1 and source2. Maximum value is 255, non-MMX
  machines have only every even value a changed view. Source1,
  Source2 and dest need to have the same color resolution (24/32) bpp.
  The larger "coverage", the more you can see source2.            }
var
  err,y           : longint;
  img1ptr,img2ptr,destptr : pointer48;
begin
  blend := errfalsebpp;
  if (not source1.bpp in [24,32]) then exit;
  if source1.bpp <> source2.bpp then exit;

  blend := errempty;
  if (source1.data = 0)or(source2.data = 0) then exit;

  blend := errwrongsize;
  if (source1.sizex <> source2.sizex)or
     (source1.sizey <> source2.sizey) then exit;
  if (dest.data = 0)or(dest.bpp <> source1.bpp)or
     (dest.sizex <> source1.sizex)or
     (dest.sizey <> source1.sizey) then begin
    err := closeimage(dest);
    blend := err;
    if err <> errnoerror then exit;
    err := openimage(dest,source1.sizex,source1.sizey,source1.bpp,1,imdefault);
    blend := err;
    if err <> errnoerror then exit;
  end;
  if cpuext and cpummx = 0 then
{  for i := 0 to 511 do mem[alphatab:i] := ((i-255)*integer(coverage)) shr 7;}
    asm
      mov   es,[gfxbufsel]
      mov   cx,511
      xor   di,di
      mov   si,-255
      mov   bl,coverage
      shr   bl,1
      xor   bh,bh
      @lp:
        mov   ax,si
        mul   bx
        shr   ax,7
        mov   es:[di],al
        inc   di
        inc   si
        dec   cx
      jnz   @lp
    end;
  case coverage of
    0   : move2(ptr48(source1.data,source1.imagestart),
                ptr48(dest.data,dest.imagestart),
                longint(source1.bpl)*source1.sizey);
    255 : move2(ptr48(source2.data,source2.imagestart),
                ptr48(dest.data,dest.imagestart),
                longint(source1.bpl)*source1.sizey);
    else
    if cpuext and cpummx = 0 then begin
      if source1.bpp = 32 then
      blend_32_fast(ptr48(source1.data,source1.imagestart),
                    ptr48(source2.data,source2.imagestart),
                    ptr48(dest.data,dest.imagestart),gfxbufptr,
                    longint(source1.bpl)*source1.sizey) else
      begin
        img1ptr := ptr48(source1.data,source1.imagestart);
        img2ptr := ptr48(source2.data,source2.imagestart);
        destptr := ptr48(dest.data,dest.imagestart);
        for y := 0 to source1.sizey-1 do begin
          blend_24_fast(img1ptr,img2ptr,destptr,gfxbufptr,
                        source1.bpl);
          inc(tselofs32(img1ptr).offset32,source1.bpl);
          inc(tselofs32(img2ptr).offset32,source2.bpl);
          inc(tselofs32(destptr).offset32,dest.bpl);
        end;
      end;
    end else
      blend_32(ptr48(source1.data,source1.imagestart),
               ptr48(source2.data,source2.imagestart),
               ptr48(dest.data,dest.imagestart),
               longint(source1.bpl)*source1.sizey,coverage);

    end;
  blend := errnoerror;
end;

function doublesize_image(source : timage;var dest : timage) : word;
{ Doubles the size of a 24/32 bpp image by interpolating the needed pixels.
  Note: only with 32 bpp MMX is being used!                                 }
var
  y          : longint;
  err        : word;
  destpos    : longint;
  doublesize : procedure(source,dest : pointer48;count,bpl : longint);
begin
  if (not imageopen(dest))or(source.sizex <> dest.sizex shl 1)or
     (source.sizey <> dest.sizey shl 1) then begin
    err := openimage(dest,source.sizex shl 1,source.sizey shl 1,source.bpp,1,imdefault);
    if err <> errnoerror then
    begin
      doublesize_image := err;
      exit;
    end;
  end;
  doublesize_image := errfalsebpp;
  if source.bpp <> dest.bpp then exit;
  case source.bpp of
    24 : doublesize := doublesize_24;
    32 : doublesize := doublesize_32;
    else exit;
  end;

  destpos := dest.imagestart;
  for y := 0 to source.sizey-2 do begin
    doublesize(ptr48(source.data,source.imagestart),
               ptr48(dest.data,destpos),source.bpl-1,source.bpl);
    inc(source.imagestart,source.bpl);
    inc(destpos,dest.bpl shl 1);
  end;
  doublesize_image := errnoerror;
end;

function halfsize_image(source : timage;var dest : timage) : word;
{ Halfs the size of a 24/32 bpp image by interpolating the pixels.
  Note: only with 32 bpp MMX is being used!                       }
var
  y        : longint;
  err      : word;
  destpos  : longint;
  halfsize : procedure(source,dest : pointer48;count,bpl : longint);
begin
  halfsize_image := errfalsebpp;
  if (not source.bpp in [24,32]) then exit;
  if (not imageopen(dest))or(source.sizex shr 1 <> dest.sizex)or
     (source.sizey shr 1 <> dest.sizey) then begin
    err := openimage(dest,source.sizex shr 1,source.sizey shr 1,source.bpp,1,imdefault);
    if err <> errnoerror then
    begin
      halfsize_image := err;
      exit;
    end;
  end;
  if source.bpp <> dest.bpp then exit;
  case source.bpp of
    24 : halfsize := halfsize_24;
    32 : halfsize := halfsize_32;
    else exit;
  end;

  destpos := dest.imagestart;
  for y := 0 to source.sizey shr 1-1 do begin
    halfsize(ptr48(source.data,source.imagestart),
             ptr48(dest.data,destpos),dest.sizex,source.bpl);
    inc(source.imagestart,source.bpl shl 1);
    inc(destpos,dest.bpl);
  end;
  halfsize_image := errnoerror;
end;

function scale_image(source : timage;var dest : timage;sx,sy,destbpp,flags : longint) : word;
{ Flags are normal drxxxx-flags, but only drdefault and drbilinear apply }
var
  y,putx,old,err : longint;
  umry,wx        : longint;
  imgptr,dstptr  : pointer48;
  scale          : procedure(source,dest : pointer48;count,wx : longint);
  convertdata    : tcnvproc;
  cnvtmp         : pcnvproc;
  { Bilinear Variables}
  fx,fy,fxy,gyab,eyab,gy,ey : longint;
  topval,bottomval,line     : longint;
  biscale                   : procedure(source,dest : pointer48;sx,bpl,topval,bottomval,fx,gyab,eyab : longint);
  biscale_d                 : procedure(source,dest : pointer48;sx,bpl,topval,bottomval,fx,fxy,gyab,eyab : longint);
  downscale                 : boolean;
begin
  scale_image := errwrongsize;
  if (sx = 0)or(sy = 0) then exit;
  scale_image := errnotopen;
  if (source.id <> idimage)or(source.data = 0) then exit;
  if (flags and drbilinear <> 0) then
  begin
    if (source.sizex <= sx)and(source.sizey <= sy)or
       (source.sizex >= sx)and(source.sizey >= sy) then
    downscale := (source.sizex > sx)or(source.sizey > sy)
    else flags := flags and not drbilinear;
  end;

  if (dest.id <> idimage)or(dest.data = 0)or(dest.sizex <> sx)or
     (dest.sizey <> sy)or(dest.bpp <> destbpp) then
  begin
    err := openimage(dest,sx,sy,destbpp,1,source.flags and not imlocked);
    scale_image := err;
    if err <> errnoerror then exit;
  end;

  putx    := sx;
  imgptr  := ptr48(source.data,source.imagestart);
  dstptr  := ptr48(dest.data,dest.imagestart);
  cnvxpos := 0;

  scale_image := errfalsebpp;
  putx := putx*source.pixel;

  scale_image := errsmallbuffer;
  if gfxbufsize-1024 < putx then exit;

  if (flags and drbilinear <> 0) then begin
    if downscale then
    case source.bpp of
      15 : biscale_d := biscaledown_15;
      16 : biscale_d := biscaledown_16;
      24 : biscale_d := biscaledown_24;
      32 : biscale_d := biscaledown_32;
      else exit;
    end else
    case source.bpp of
      15 : biscale := biscale_15;
      16 : biscale := biscale_16;
      24 : biscale := biscale_24;
      32 : biscale := biscale_32;
      else exit;
    end;
    fx := (source.sizex shl 8) div sx;
    fy := (source.sizey shl 8) div sy;
    fxy := (fx*fy) shr 8;
    gy := -fy;
    ey := 0;
  end else begin
    case source.bpp of
      8     : scale := scale_8;
      15,16 : scale := scale_1516;
      24    : scale := scale_24;
      32    : scale := scale_32;
      else exit;
    end;
    if gfxbufsize-1024 < putx then exit;
    wx := (65536*source.sizex-1) div sx;
    umry   := 0;
    old    := $FFFF;
  end;

  cnvtmp := getcnvproc(source.bpp,dest.bpp,cnvimgmd);
  if cnvtmp = nil then exit;
  convertdata := tcnvproc(cnvtmp);

  if source.bpp <= 8 then begin
    if (source.flags and impalette <> 0) then if
    dest.bpp >= 24 then cnvpal := ptr48(source.data,source.palstart)
    else begin
      if dest.bpp = 16 then
       pal_32to16(ptr48(source.data,source.palstart),ptr48(gfxbufsel,gfxbufsize-1024),word(1) shl source.bpp)
       else
       pal_32to15(ptr48(source.data,source.palstart),ptr48(gfxbufsel,gfxbufsize-1024),word(1) shl source.bpp);
      cnvpal := ptr48(gfxbufsel,gfxbufsize-1024);
    end;
  end;

  if (flags and drbilinear = 0) then
  for y := 0 to sy-1 do begin
    if umry div sy <> old then begin
      scale(imgptr,gfxbufptr,putx,wx);
      if y > 0 then
       inc(tselofs32(imgptr).offset32,source.bpl*(umry div sy-old))
       else inc(tselofs32(imgptr).offset32,source.bpl);
      old := umry div sy;
    end;
    cnvypos := y;
    convertdata(gfxbufptr,dstptr,putx);
    inc(umry,source.sizey);
    inc(tselofs32(dstptr).offset32,dest.bpl);
  end else { do antialiasing }
  if downscale then
  for y := 0 to sy-1 do begin
    inc(gy,fy);
    inc(ey,fy);

    gyab := gy shr 8;
    eyab := ey shr 8;
    if (ey and $FF = 0) then dec(eyab);

    bottomval := (gyab+1) shl 8-gy;
    topval    := ey-eyab shl 8;
    biscale_d(imgptr,gfxbufptr,sx,source.bpl,topval,bottomval,fx,fxy,gyab,eyab);
    cnvypos := y;
    convertdata(gfxbufptr,dstptr,putx);
    inc(tselofs32(dstptr).offset32,dest.bpl);
  end else
  for y := 0 to sy-1 do begin
    inc(gy,fy);
    inc(ey,fy);

    gyab := gy shr 8;
    eyab := ey shr 8;
    if (ey and $FF = 0) then dec(eyab);

    line := (eyab shl 16) div fy;
    bottomval := line-y shl 8;
    topval    := (y+1) shl 8-line;
    biscale(imgptr,gfxbufptr,sx,source.bpl,topval,bottomval,fx,gyab,eyab);
    cnvypos := y;
    convertdata(gfxbufptr,dstptr,putx);
    inc(tselofs32(dstptr).offset32,dest.bpl);
  end;
  if (source.flags and imsprite <> 0)and(dest.flags and imsprite <> 0) then
  begin
    convertdata(farptr(@source.transcol),farptr(@dest.transcol),source.pixel);
  end;

  scale_image := errnoerror;
end;

function rgb2bw(source : timage;var dest : timage) : word;
var
  y               : longint;
  img1ptr,img2ptr : pointer48;
  proc_rgb2bw     : procedure(source,dest : pointer48;count : longint);
begin
  rgb2bw := errfalsebpp;
  case source.bpp of
    24 : proc_rgb2bw := rgb2bw_24;
    32 : proc_rgb2bw := rgb2bw_32;
    else exit;
  end;
  openimage(dest,source.sizex,source.sizey,8,1,impalette+imgreyscale);
  img1ptr := ptr48(source.data,source.imagestart);
  img2ptr := ptr48(dest.data,dest.imagestart);
  for y := 0 to source.sizey-1 do begin
    proc_rgb2bw(img1ptr,img2ptr,source.sizex*source.pixel);
    inc(tselofs32(img1ptr).offset32,source.bpl);
    inc(tselofs32(img2ptr).offset32,dest.bpl);
  end;
  for y := 0 to 255 do
  writemem32l(ptr48(dest.data,dest.palstart+longint(y) shl 2),y+y shl 8+longint(y) shl 16);
  rgb2bw := errnoerror;
end;

function blur_image(image : timage) : word;
var
  y    : word;
  blur : procedure(data : pointer48;bpl : longint);
begin
  blur_image := errnotopen;
  if (image.id <> idimage)or(image.data = 0) then exit;
  blur_image := errfalsebpp;
  case image.bpp of
    24 : blur := blur_24;
    32 : blur := blur_32;
    else exit;
  end;
  for y := 0 to image.sizey-2 do begin
    blur(ptr48(image.data,image.imagestart),image.bpl);
    inc(image.imagestart,image.bpl);
  end;
  blur_image := errnoerror;
end;

function scaleup_image(source : timage;var dest : timage;xfact,yfact : word) : word;
var
  i,y     : longint;
  imgptr,
  dstptr  : pointer48;
  scaleup : procedure(source,dest,table : pointer48;count,yval : longint);
begin
  scaleup_image := errnotopen;
  if (source.id <> idimage)or(source.data = 0) then exit;
  if (dest.id <> idimage)or(dest.data = 0) then
   openimage(dest,source.sizex,source.sizey,source.bpp,1,source.flags);

  scaleup_image := errwrongsize;
  if (source.sizex <> dest.sizex)or(source.sizey <> dest.sizey) then exit;
  scaleup_image := errfalsebpp;
  if (source.bpp <> dest.bpp) then exit;

  scaleup_image := errsmallbuffer;
  if source.sizex > gfxbufsize shr 2 then exit;

  case source.bpp of
    8     : scaleup := scaleup_8;
    15,16 : scaleup := scaleup_1516;
    24    : scaleup := scaleup_24;
    32    : scaleup := scaleup_32;
    else exit;
  end;

  for i := 0 to source.sizex-1 do
  writemem32l(ptr48(gfxbufsel,i shl 2),
              round(i/(source.sizex-1)*((source.sizex-1)-(2*xfact)))+xfact);
  dstptr := ptr48(dest.data,dest.imagestart);
  imgptr := ptr48(source.data,source.imagestart);
  for y := 0 to source.sizey-1 do begin
    scaleup(imgptr,dstptr,gfxbufptr,source.bpl,
            round(y/(source.sizey-1)*((source.sizey-1)-(2*yfact))+yfact)*source.sizex*source.pixel);
    inc(tselofs32(dstptr).offset32,dest.bpl);
  end;
  scaleup_image := errnoerror;
end;

function fadered_image(source,dest : timage;val : byte) : word;
var
  y    : longint;
begin
  if (source.id <> idimage)or(source.data = 0) then exit;
  for y := 0 to source.sizey-1 do begin
    fadered_32(ptr48(source.data,source.imagestart),
               ptr48(dest.data,dest.imagestart),source.bpl,255-val);
    inc(source.imagestart,source.bpl);
    inc(dest.imagestart,dest.bpl);
  end;
end;

function dithermix_image(source1,source2 : timage;var dest : timage) : word;
var
  err      : word;
  y,dstpos : longint;
  dithmix  : procedure(source1,source2,dest : pointer48;sizex,ypos : longint);
begin
  dithermix_image := errempty;
  if (source1.data = 0)or(source1.id <> idimage)or(source2.data = 0)or
     (source2.id <> idimage) then exit;

  dithermix_image := errfalsebpp;
  if source1.bpp <> source2.bpp then exit;

  case source1.bpp of
    8     : dithmix := dithmix_8;
    15,16 : dithmix := dithmix_1516;
    32    : dithmix := dithmix_32;
    else exit;
  end;

  dithermix_image := errwrongsize;
  if (source1.sizex <> source2.sizex)or
     (source1.sizey <> source2.sizey) then exit;
  if (dest.data = 0)or(dest.bpp <> source1.bpp)or
     (dest.sizex <> source1.sizex)or
     (dest.sizey <> source1.sizey) then begin
    err := closeimage(dest);
    dithermix_image := err;
    if err <> errnoerror then exit;
    err := openimage(dest,source1.sizex,source1.sizey,source1.bpp,1,imdefault);
    dithermix_image := err;
    if err <> errnoerror then exit;
  end;
  dstpos := dest.imagestart;
  for y := 0 to source1.sizey-1 do begin
    dithmix(ptr48(source1.data,source1.imagestart),
            ptr48(source2.data,source2.imagestart),
            ptr48(dest.data,dstpos),source1.sizex,y);
    inc(dstpos,dest.bpl);
    inc(source1.imagestart,source1.bpl);
    inc(source2.imagestart,source2.bpl);
  end;
end;

function mirror_image(image : timage) : word;
var
  y      : longint;
  mirror : procedure(data : pointer48;sizex : longint);
  p      : pointer48;
begin
  mirror_image := errnotopen;
  if (image.data = 0)or(image.id <> idimage) then exit;
  mirror_image := errfalsebpp;
  case image.bpp of
    8  : mirror := mirror_8;
    16 : mirror := mirror_16;
    24 : mirror := mirror_24;
    32 : mirror := mirror_32;
    else exit;
  end;
  p := ptr48(image.data,image.imagestart);
  for y := 0 to image.sizey-1 do
  begin
    mirror(p,image.sizex);
    inc(tselofs32(p).offset32,image.bpl);
  end;
  mirror_image := errnoerror;
end;


procedure switchcpuext(flags : longint);far;
begin
  if flags and cpummx <> 0 then
  begin
    fadewhite_32  := fadewhite_32_mmx;
    fadeout_32    := fadeout_32_mmx;
    brightness_32 := brightness_32_mmx;
    blur_32       := blur_32_mmx;
    halfsize_32   := halfsize_32_mmx;
    doublesize_32 := doublesize_32_mmx;
    brightness_24 := brightness_24_mmx;
  end else begin
    fadewhite_32  := fadewhite_32_386;
    fadeout_32    := fadeout_32_386;
    brightness_32 := brightness_32_386;
    blur_32       := blur_32_386;
    halfsize_32   := halfsize_32_386;
    doublesize_32 := doublesize_32_386;
    brightness_24 := brightness_24_386;
  end;
end;

begin
  registercpuswitch(@switchcpuext);
  switchcpuext(cpuext);
end.