;GrafX2 low level imaging routines
;(c) 1998-2000 by Stefan Goehler
;detailed copyright notices in grafx2.txt
;illegal copy if without grafx2.txt

;!! = procedures or parts which are untested yet or/and have bugs or aren't
;finished yet

.model large,pascal
.386p
.data

;Variables
val_red    dw ?
val_green  dw ?
val_blue   dw ?
gx         dd ?
ex         dd ?
gxab       dd ?
exab       dd ?
leftval    dd ?
rightval   dd ?
sum_blue   dw ?
sum_green  dw ?
sum_red    dw ?
sum_alpha  db ?

;Simple sprite displayment routines
public sprite_8
public sprite_1516
public sprite_24
public sprite_32

public spritemem_8_mmx
public spritemem_1516_mmx
public spritemem_32_mmx

;Transparency FX procedures
public add_15
public add_16
public add_24_386
public add_32_386
public add_32_mmx
public sub_15
public sub_16
public sub_24_386
public sub_32_386
public sub_32_mmx

public alpha_merge
public alpha_15_386
public alpha_16_386
public alpha_24_386
public alpha_32_386
public alpha_32_mmx

;Alphablending procedures
public blend_24_fast
public blend_32_fast
public blend_24_386
public blend_32_386
public blend_32_mmx

;RLE Sprite line decompression
public rle_8
public rle_1516
public rle_32

;Image scaling procedures
public scale_8
public scale_1516
public scale_24
public scale_32

public biscale_15
public biscale_16
public biscale_24
public biscale_32
public biscaledown_15
public biscaledown_16
public biscaledown_24
public biscaledown_32
public biscale_32_mmx

ends

.code
include ctmmxn.inc

;!! untested
sprite_8 proc
arg source:pword,dest:pword,count:dword,key:dword,sbpl:dword,dbpl:dword,ylines:dword
        push  ds
        lds   esi,source
        les   edi,dest
        mov   ecx,count
        mov   edx,ylines
        and   ecx,0FFFFFFFEh
        sub   sbpl,ecx
        sub   dbpl,ecx
        @ylp_s8:
          mov   ecx,count
          shr   ecx,1
          jz    @1or0
          mov   bl,byte ptr key
          @lp_s8:
            mov   ax,ds:[esi]
            cmp   al,bl
            je    @trans_s8_1
              mov   es:[edi],al
            @trans_s8_1:
            cmp   ah,bl
            je    @trans_s8_2
              mov   es:[edi+1],ah
            @trans_s8_2:

            add   edi,2
            add   esi,2
            dec   ecx
          jnz   @lp_s8
          @1or0:
          test  count,1
          jz    @end_s8
          mov   al,ds:[esi]
          cmp   al,bl
          je    @stop_s8
            mov   es:[edi],al
          @stop_s8:
          add   esi,sbpl
          add   edi,dbpl
          dec   edx
          jnz   @ylp_s8
        @end_s8:
        pop   ds
        ret
sprite_8 endp

sprite_1516 proc
arg source:pword,dest:pword,count:dword,key:dword,sbpl:dword,dbpl:dword,ylines:dword
        push  ds
        lds   esi,source
        les   edi,dest
        mov   bx,word ptr key
        mov   ax,bx
        shl   ebx,16
        mov   bx,ax
        mov   ecx,count
        mov   edx,ylines
        or    edx,edx
        jz    @end_s16
        shr   ecx,1
        jz    @end_s16
        mov   count,ecx

        @ylp_s16:
          mov   ecx,count
          push  esi
          push  edi

          @lp_s16:
            db 67h
            lodsd
            cmp   bx,ax
            je    @transp_s16
              dec   ecx
              jz    @once3_s16
              mov   edx,eax
              shr   eax,16
              cmp   ax,bx
              je    @once1_s16
              mov   es:[edi],edx
              add   edi,4
              dec   ecx
            jnz   @lp_s16
            jmp   @stop_s16
  @transp_s16:
            dec   ecx
            jz    @stop_s16
            cmp   eax,ebx
            jne   @once2_s16
            add   edi,4
            dec   ecx
          jnz   @lp_s16
          jmp   @stop_s16
  @once1_s16:
          mov   es:[edi],dx
          add   edi,4
          dec   ecx
          jnz   @lp_s16
          jmp   @stop_s16
  @once2_s16:
          shr   eax,16
          mov   es:[edi+2],ax
          add   edi,4
          dec   ecx
          jnz   @lp_s16
          jmp   @stop_s16
  @once3_s16:
          mov   es:[edi],ax
  @stop_s16:
          pop   edi
          pop   esi
          add   esi,sbpl
          add   edi,dbpl
          dec   ylines
          jnz   @ylp_s16
@end_s16:
        pop   ds
        ret
sprite_1516 endp


sprite_24 proc
arg source:pword,dest:pword,count:dword,key:dword,sbpl:dword,dbpl:dword,ylines:dword
        push  ds
        mov   ecx,3
        mov   eax,count
        sub   sbpl,eax
        sub   dbpl,eax
        cdq
        div   ecx
        or    eax,eax
        jz    @end_s24
        mov   count,eax
        mov   edx,ylines
        mov   ebx,key
        and   ebx,00FFFFFFh
        lds   esi,source
        les   edi,dest

@ylp_s24:
        mov   eax,count
        @lp_s24:
          mov   ecx,ds:[esi]
          and   ecx,00FFFFFFh
          cmp   ecx,ebx
          je    @transp_s24
            mov   es:[edi],cx
            shr   ecx,16
            mov   es:[edi+2],cl
          @transp_s24:
          add   edi,3
          add   esi,3
          dec   eax
        jnz   @lp_s24
        add   edi,dbpl
        add   esi,sbpl
        dec   edx
        jnz   @ylp_s24
@end_s24:
        pop   ds
        ret
sprite_24 endp

sprite_32 proc
arg source:pword,dest:pword,count:dword,key:dword,sbpl:dword,dbpl:dword,ylines:dword
        push  ds
        mov   ecx,count
        sub   sbpl,ecx
        sub   dbpl,ecx
        shr   ecx,2
        jz    @end_s32
        mov   edx,ylines
        mov   count,ecx
        lds   esi,source
        les   edi,dest
        mov   ebx,key
@ylp_s32:
        mov   ecx,count
        @lp_s32:
          db 67h
          lodsd
          and   eax,0FFFFFFh
          cmp   ebx,eax
          je    @transp_s32
            mov   es:[edi],eax
          @transp_s32:
          add   edi,4
          dec   ecx
        jnz   @lp_s32
        add   edi,dbpl
        add   esi,sbpl
        dec   edx
        jnz   @ylp_s32
@end_s32:
        pop   ds
        ret
sprite_32 endp

;!!untested
spritemem_8_mmx proc
arg source:pword,dest:pword,count:dword,key:dword,sbpl:dword,dbpl:dword,ylines:dword
        les    edi,dest
        lgs    esi,source
        mov    ecx,count
        mov    edx,ylines
        sub    sbpl,ecx
        sub    dbpl,ecx
        mov    ebx,key
        mov    bh,bl
        movd   mm4,ebx
        punpcklwd  mm4,mm4
        punpckldq  mm4,mm4
        mov    eax,0FFFFFFFFh
        movd   mm5,eax
        punpckldq  mm5,mm5

@ylp_sm8mx:
          mov    ecx,count
          shr    ecx,3
          jz     @b8_sm8mx

  @lp_sm8mx:
          movq    mm2,mm4
          movq    mm0,gs:[esi],2
          pcmpeqb mm2,mm0
          movq    mm1,es:[edi],2
          pand    mm1,mm2
          pxor    mm2,mm5
          pand    mm0,mm2
          por     mm1,mm0
          movq    es:[edi],mm1,2

          add     esi,8
          add     edi,8
          dec     ecx
          jnz     @lp_sm8mx
  @b8_sm8mx:
          mov    ecx,count
          and    ecx,111b
          jz     @stop_sm32mx
  @lp2_sm8mx:
          mov    al,gs:[esi]
          cmp    al,bl
          je     @np_sm8mx
            mov   es:[edi],al
  @np_sm8mx:
          inc    edi
          inc    esi
          dec    ecx
          jnz    @lp2_sm8mx
@stop_sm8mx:
        add   edi,dbpl
        add   esi,sbpl
        dec   edx
        jnz   @ylp_sm8mx
        emms

        ret
spritemem_8_mmx endp

spritemem_1516_mmx proc
arg source:pword,dest:pword,count:dword,key:dword,sbpl:dword,dbpl:dword,ylines:dword
        les    edi,dest
        lgs    esi,source
        mov    ecx,count
        movd   mm4,key
        punpcklwd  mm4,mm4
        punpckldq  mm4,mm4
        mov    eax,0FFFFFFFFh
        movd   mm5,eax
        punpckldq  mm5,mm5

        mov    edx,ylines
        sub    sbpl,ecx
        sub    dbpl,ecx
@ylp_sm16mx:
        mov    ecx,count
        shr    ecx,3
        jz     @b8_sm16mx
  @lp_sm16mx:
          movq    mm2,mm4
          movq    mm0,gs:[esi],2
          pcmpeqw mm2,mm0
          movq    mm1,es:[edi],2
          pand    mm1,mm2
          pxor    mm2,mm5
          pand    mm0,mm2
          por     mm1,mm0
          movq    es:[edi],mm1,2

          add     esi,8
          add     edi,8
          dec     ecx
          jnz     @lp_sm16mx
  @b8_sm16mx:
          mov    ecx,count
          and    ecx,110b
          jz     @stop_sm16mx
          shr    ecx,1
          mov    ebx,key
  @lp2_sm16mx:
          mov    ax,gs:[esi]
          cmp    ax,bx
          je     @np_sm16mx
            mov   es:[edi],ax
  @np_sm16mx:
          add    edi,2
          add    esi,2
          dec    ecx
          jnz    @lp2_sm16mx
  @stop_sm16mx:
        add   edi,dbpl
        add   esi,sbpl
        dec   edx
        jnz   @ylp_sm16mx

        emms
        ret
spritemem_1516_mmx endp

spritemem_32_mmx proc
arg source:pword,dest:pword,count:dword,key:dword,sbpl:dword,dbpl:dword,ylines:dword
        les    edi,dest
        lgs    esi,source
        mov    ecx,count
        sub    sbpl,ecx
        sub    dbpl,ecx
        mov    edx,ylines
        movd   mm4,key
        punpckldq  mm4,mm4
        mov    eax,0FFFFFFFFh
        movd   mm5,eax
        punpckldq  mm5,mm5
        mov    eax,0FFFFFFh
        movd   mm6,eax
        punpckldq  mm6,mm6

@ylp_sm32mx:
          mov    ecx,count
          shr    ecx,3
          jz     @b8_sm32mx

  @lp_sm32mx:
          movq    mm0,gs:[esi],2
          movq    mm2,mm4
          pand    mm0,mm6
          pcmpeqd mm2,mm0
          movq    mm1,es:[edi],2
          pand    mm1,mm2
          pxor    mm2,mm5
          pand    mm0,mm2
          por     mm1,mm0
          movq    es:[edi],mm1,2

          add     esi,8
          add     edi,8
          dec     ecx
          jnz     @lp_sm32mx
  @b8_sm32mx:
          test   count,100b
          jz     @stop_sm32mx
          mov    eax,gs:[esi]
          add    esi,4
          add    edi,4
          cmp    eax,key
          je     @stop_sm32mx
          mov    es:[edi-4],eax
  @stop_sm32mx:

        add   edi,dbpl
        add   esi,sbpl
        dec   edx
        jnz   @ylp_sm32mx

        emms
        ret
spritemem_32_mmx endp

add_15 proc
arg source:pword,dest:pword,count:dword
        push  ds
        les   edi,source
        lds   esi,dest
        shr   count,1
        jz    @end_ad15
        mov   ecx,esi
        and   ecx,10b
        jz    @iszero_ad15
          mov   bx,es:[edi]
          mov   dx,bx
          and   bx,111110000011111b
          and   dx,1111100000b
          mov   ax,ds:[esi]
          mov   cx,ax
          and   ax,111110000011111b
          and   cx,1111100000b
          add   al,bl
          cmp   al,11111b
          jna   @nob_ad15_3
            mov   al,11111b
          @nob_ad15_3:
          add   ah,bh
          cmp   ah,1111100b
          jna   @nor_ad15_3
            mov   ah,1111100b
          @nor_ad15_3:
          add   cx,dx
          cmp   cx,1111100000b
          jna   @nog_ad15_3
            mov   cx,1111100000b
          @nog_ad15_3:
          or    ax,cx
          mov   ds:[esi],ax
          add   esi,2
          add   edi,2
          dec   count
          jz    @end_ad15
        @iszero_ad15:
@rep_ad15:
        mov   bx,es:[edi]
        or    bx,bx
        jz    @once1_ad15
        mov   dx,bx
        and   bx,111110000011111b
        and   dx,1111100000b
        mov   eax,ds:[esi]
        mov   cx,ax
        and   ax,111110000011111b
        and   cx,1111100000b
        add   al,bl
        cmp   al,11111b
        jna   @nob_ad15_1
          mov   al,11111b
        @nob_ad15_1:
        add   ah,bh
        cmp   ah,1111100b
        jna   @nor_ad15_1
          mov   ah,1111100b
        @nor_ad15_1:
        add   cx,dx
        cmp   cx,1111100000b
        jna   @nog_ad15_1
          mov   cx,1111100000b
        @nog_ad15_1:
        or    ax,cx
        dec   count
        jz    @once_ad15

@cont1_ad15:
        mov   bx,es:[edi+2]
        or    bx,bx
        jz    @once2_ad15
        mov   dx,bx
        and   bx,111110000011111b
        and   dx,1111100000b
        ror   eax,16
        mov   cx,ax
        and   ax,111110000011111b
        and   cx,1111100000b
        add   al,bl
        cmp   al,11111b
        jna   @nob_ad15_2
          mov   al,11111b
        @nob_ad15_2:
        add   ah,bh
        cmp   ah,1111100b
        jna   @nor_ad15_2
          mov   ah,1111100b
        @nor_ad15_2:
        add   cx,dx
        cmp   cx,1111100000b
        jna   @nog_ad15_2
          mov   cx,1111100000b
        @nog_ad15_2:
        or    ax,cx
        rol   eax,16
        mov   ds:[esi],eax

@cont2_ad15:
        add   esi,4
        add   edi,4
        dec   count
        jnz   @rep_ad15
        jmp   @end_ad15
@once_ad15:
        mov   ds:[esi],ax
        jmp   @end_ad15
@once1_ad15:
        dec   count
        jz    @end_ad15
        cmp   word ptr es:[edi+2],0
        jz    @cont2_ad15
        mov   eax,ds:[esi]
        jmp   @cont1_ad15
@once2_ad15:
        mov   ds:[esi],ax
        jmp   @cont2_ad15
@end_ad15:
        pop   ds
        ret
add_15 endp

add_16 proc
arg source:pword,dest:pword,count:dword
        push  ds
        lds   esi,source
        les   edi,dest
        shr   count,1
        jz    @end_ad16
        test  edi,10b
        jz    @rep_ad16
          mov   bx,ds:[esi]
          or    bx,bx
          jz    @iszero_ad16
          mov   ax,es:[edi]
          mov   dx,bx
          and   bx,1111100000011111b
          and   dx,11111100000b
          mov   cx,ax
          and   ax,1111100000011111b
          and   cx,11111100000b
          add   ax,bx
          jnc   @nor_ad16_3
            mov   ah,11111000b
          @nor_ad16_3:
          cmp   al,11111b
          jna   @nob_ad16_3
            mov   al,11111b
          @nob_ad16_3:
          add   cx,dx
          cmp   cx,11111100000b
          jna   @nog_ad16_3
            mov   cx,11111100000b
          @nog_ad16_3:
          or    ax,cx
          mov   es:[edi],ax
        @iszero_ad16:
        dec   count
        jz    @end_ad16
        add   esi,2
        add   edi,2
@rep_ad16:
        mov   bx,ds:[esi]
        or    bx,bx
        jz    @once1_ad16
        mov   dx,bx
        and   bx,1111100000011111b
        and   dx,11111100000b
        mov   eax,es:[edi]
        mov   cx,ax
        and   ax,1111100000011111b
        and   cx,11111100000b
        add   ax,bx
        jnc   @nor_ad16_1
          mov   ah,11111000b
        @nor_ad16_1:
        cmp   al,11111b
        jna   @nob_ad16_1
          mov   al,11111b
        @nob_ad16_1:
        add   cx,dx
        cmp   cx,11111100000b
        jna   @nog_ad16_1
          mov   cx,11111100000b
        @nog_ad16_1:
        or    ax,cx
        dec   count
        jz    @once_ad16

        mov   bx,ds:[esi+2]
        or    bx,bx
        jz    @once2_ad16
@cont1_ad16:
        ror   eax,16

        mov   dx,bx
        and   bx,1111100000011111b
        and   dx,11111100000b
        mov   cx,ax
        and   ax,1111100000011111b
        and   cx,11111100000b
        add   ax,bx
        jnc   @nor_ad16_2
          mov   ah,11111000b
        @nor_ad16_2:
        add   cx,dx
        cmp   al,11111b
        jna   @nob_ad16_2
          mov   al,11111b
        @nob_ad16_2:
        cmp   cx,11111100000b
        jna   @nog_ad16_2
          mov   cx,11111100000b
        @nog_ad16_2:
        or    ax,cx

        rol   eax,16
        db 67h
        stosd

@cont2_ad16:
        add   esi,4
        dec   count
        jnz   @rep_ad16
        jmp   @end_ad16
@once_ad16:
        mov   es:[edi],ax
        jmp   @end_ad16
@once1_ad16:
        dec   count
        jz    @end_ad16
        add   edi,4
        mov   bx,ds:[esi+2]
        or    bx,bx
        jz    @cont2_ad16
        mov   eax,es:[edi-4]
        sub   edi,4
        jmp   @cont1_ad16
@once2_ad16:
        mov   es:[edi],ax
        add   edi,4
        add   esi,4
        dec   count
        jnz   @rep_ad16
        jmp   @end_ad16
@end_ad16:
        pop   ds
        ret
add_16 endp

add_24_386 proc
arg source:pword,dest:pword,count:dword
        les   edi,source
        push  ds
        lds   esi,dest
        mov   ecx,3
        mov   eax,count
        cdq
        div   ecx
        or    eax,eax
        jz    @end_ad24
        mov   count,eax
@rep_ad24:
        mov   ebx,es:[edi]
        test  ebx,0FFFFFFh
        jz    @zero_ad24
        mov   eax,ds:[esi]
        mov   ecx,ebx
        shr   ecx,16
        mov   edx,eax
        shr   edx,16
        add   bl,al
        jnc   @nor_ad24
          mov   bl,0FFh
        @nor_ad24:
        add   bh,ah
        jnc   @nog_ad24
          mov   bh,0FFh
        @nog_ad24:
        add   dl,cl
        jnc   @nob_ad24
          mov   dl,0FFh
        @nob_ad24:
        mov   ds:[esi],bx
        mov   ds:[esi+2],dl
@zero_ad24:
        add   esi,3
        add   edi,3
        dec   count
        jnz   @rep_ad24
@end_ad24:
        pop   ds
        ret
add_24_386 endp

add_32_386 proc
arg source:pword,dest:pword,count:dword
        push  ds
        les   edi,source
        lds   esi,dest
        shr   count,2
        jz    @end_ad32
@rep_ad32:
        mov   ebx,es:[edi]
        test  ebx,0FFFFFFh
        jz    @zero_ad32
        mov   eax,ds:[esi]
        mov   ecx,ebx
        shr   ecx,16
        mov   edx,eax
        shr   edx,16
        add   bl,al
        jnc   @nor_ad32
          mov   bl,0FFh
        @nor_ad32:
        add   bh,ah
        jnc   @nog_ad32
          mov   bh,0FFh
        @nog_ad32:
        add   dl,cl
        jnc   @nob_ad32
          mov   dl,0FFh
        @nob_ad32:
        shl   edx,16
        mov   dx,bx
        mov   ds:[esi],edx
@zero_ad32:
        add   esi,4
        add   edi,4
        dec   count
        jnz   @rep_ad32
@end_ad32:
        pop   ds
        ret
add_32_386 endp

add_32_mmx proc
arg source:pword,dest:pword,count:dword
        lgs   esi,source
        les   edi,dest
        mov   ecx,count
        mov   edx,ecx
        shr   ecx,3
        jz    @once_ad32mx
@rep_ad32mx:
        movq     mm0,gs:[esi],2
        movq     mm1,mm0
        psrlq    mm1,32
        por      mm1,mm0
        movd     eax,mm1
        and      eax,0FFFFFFh
        jz       @zero_ad32mx

        paddusb  mm0,es:[edi],2
        movq     es:[edi],mm0,2
@zero_ad32mx:
        add   esi,8
        add   edi,8
        dec   ecx
        jnz   @rep_ad32mx
@once_ad32mx:
        test  edx,4
        jz    @end_ad32mx

        movd     mm0,gs:[esi],2
        paddusb  mm0,es:[edi],2
        movd     es:[edi],mm0,2
@end_ad32mx:
        emms
        ret
add_32_mmx endp

sub_15 proc
arg source:pword,dest:pword,count:dword
        push  ds
        les   edi,source
        lds   esi,dest
        shr   count,1
        jz    @end_sb15
        mov   ecx,esi
        and   ecx,10b
        jz    @iszero_sb15
          mov   bx,es:[edi]
          mov   dx,bx
          and   bx,111110000011111b
          and   dx,1111100000b
          mov   ax,ds:[esi]
          mov   cx,ax
          and   ax,111110000011111b
          and   cx,1111100000b
          sub   al,bl
          jnc   @nob_sb15_3
            xor  al,al
          @nob_sb15_3:
          sub   ah,bh
          jnc   @nor_sb15_3
            xor  ah,ah
          @nor_sb15_3:
          sub   cx,dx
          jc   @nog_sb15_3
            or    ax,cx
          @nog_sb15_3:
          mov   ds:[esi],ax
          add   esi,2
          add   edi,2
          dec   count
          jz    @end_sb15
        @iszero_sb15:
@rep_sb15:
        mov   bx,es:[edi]
        or    bx,bx
        jz    @once1_sb15
        mov   dx,bx
        and   bx,111110000011111b
        and   dx,1111100000b
        mov   eax,ds:[esi]
        mov   cx,ax
        and   ax,111110000011111b
        and   cx,1111100000b
        sub   al,bl
        jnc   @nob_sb15_1
          xor  al,al
        @nob_sb15_1:
        sub   ah,bh
        jnc   @nor_sb15_1
          xor  ah,ah
        @nor_sb15_1:
        sub   cx,dx
        jc   @nog_sb15_1
          or    ax,cx
        @nog_sb15_1:
        dec   count
        jz    @once_sb15

@cont1_sb15:
        mov   bx,es:[edi+2]
        or    bx,bx
        jz    @once2_sb15
        mov   dx,bx
        and   bx,111110000011111b
        and   dx,1111100000b
        ror   eax,16
        mov   cx,ax
        and   ax,111110000011111b
        and   cx,1111100000b
        sub   al,bl
        jnc   @nob_sb15_2
          xor  al,al
        @nob_sb15_2:
        sub   ah,bh
        jnc   @nor_sb15_2
          xor  ah,ah
        @nor_sb15_2:
        sub   cx,dx
        jc   @nog_sb15_2
          or    ax,cx
        @nog_sb15_2:
        rol   eax,16
        mov   ds:[esi],eax

@cont2_sb15:
        add   esi,4
        add   edi,4
        dec   count
        jnz   @rep_sb15
        jmp   @end_sb15
@once_sb15:
        mov   ds:[esi],ax
        jmp   @end_sb15
@once1_sb15:
        dec   count
        jz    @end_sb15
        cmp   word ptr es:[edi+2],0
        jz    @cont2_sb15
        mov   eax,ds:[esi]
        jmp   @cont1_sb15
@once2_sb15:
        mov   ds:[esi],ax
        jmp   @cont2_sb15
@end_sb15:
        pop   ds
        ret
sub_15 endp

sub_16 proc
arg source:pword,dest:pword,count:dword
        push  ds
        les   edi,source
        lds   esi,dest
        shr   count,1
        jz    @end_sb16
        mov   ecx,esi
        and   ecx,10b
        jz    @iszero_sb16
          mov   bx,es:[edi]
          mov   dx,bx
          and   bx,1111100000011111b
          and   dx,11111100000b
          mov   ax,ds:[esi]
          mov   cx,ax
          and   ax,1111100000011111b
          and   cx,11111100000b
          sub   al,bl
          jnc   @nob_sb16_3
            xor  al,al
          @nob_sb16_3:
          sub   ah,bh
          jnc   @nor_sb16_3
            xor  ah,ah
          @nor_sb16_3:
          sub   cx,dx
          jc   @nog_sb16_3
            or    ax,cx
          @nog_sb16_3:
          mov   ds:[esi],ax
          add   esi,2
          add   edi,2
          dec   count
          jz    @end_sb16
        @iszero_sb16:
@rep_sb16:
        mov   bx,es:[edi]
        or    bx,bx
        jz    @once1_sb16
        mov   dx,bx
        and   bx,1111100000011111b
        and   dx,11111100000b
        mov   eax,ds:[esi]
        mov   cx,ax
        and   ax,1111100000011111b
        and   cx,11111100000b
        sub   al,bl
        jnc   @nob_sb16_1
          xor  al,al
        @nob_sb16_1:
        sub   ah,bh
        jnc   @nor_sb16_1
          xor  ah,ah
        @nor_sb16_1:
        sub   cx,dx
        jc   @nog_sb16_1
          or    ax,cx
        @nog_sb16_1:
        dec   count
        jz    @once_sb16

@cont1_sb16:
        mov   bx,es:[edi+2]
        or    bx,bx
        jz    @once2_sb16
        mov   dx,bx
        and   bx,1111100000011111b
        and   dx,11111100000b
        ror   eax,16
        mov   cx,ax
        and   ax,1111100000011111b
        and   cx,11111100000b
        sub   al,bl
        jnc   @nob_sb16_2
          xor  al,al
        @nob_sb16_2:
        sub   ah,bh
        jnc   @nor_sb16_2
          xor  ah,ah
        @nor_sb16_2:
        sub   cx,dx
        jc   @nog_sb16_2
          or    ax,cx
        @nog_sb16_2:
        rol   eax,16
        mov   ds:[esi],eax

@cont2_sb16:
        add   esi,4
        add   edi,4
        dec   count
        jnz   @rep_sb16
        jmp   @end_sb16
@once_sb16:
        mov   ds:[esi],ax
        jmp   @end_sb16
@once1_sb16:
        dec   count
        jz    @end_sb16
        cmp   word ptr es:[edi+2],0
        jz    @cont2_sb16
        mov   eax,ds:[esi]
        jmp   @cont1_sb16
@once2_sb16:
        mov   ds:[esi],ax
        jmp   @cont2_sb16
@end_sb16:
        pop   ds
        ret
sub_16 endp

sub_24_386 proc
arg source:pword,dest:pword,count:dword
        les   edi,source
        push  ds
        lds   esi,dest
        mov   ecx,3
        mov   eax,count
        cdq
        div   ecx
        or    eax,eax
        jz    @end_sb24
        mov   count,eax
@rep_sb24:
        mov   ebx,es:[edi]
        test  ebx,0FFFFFFh
        jz    @zero_sb24
        mov   eax,ds:[esi]
        mov   ecx,ebx
        shr   ecx,16
        mov   edx,eax
        shr   edx,16
        sub   bl,al
        jnc   @nor_sb24
          xor   bl,bl
        @nor_sb24:
        sub   bh,ah
        jnc   @nog_sb24
          xor   bh,bh
        @nog_sb24:
        sub   dl,cl
        jnc   @nob_sb24
          xor   dl,dl
        @nob_sb24:
        mov   ds:[esi],bx
        mov   ds:[esi+2],dl
@zero_sb24:
        add   esi,3
        add   edi,3
        dec   count
        jnz   @rep_sb24
@end_sb24:
        pop   ds
        ret
sub_24_386 endp

sub_32_386 proc
arg source:pword,dest:pword,count:dword
        push  ds
        les   edi,source
        lds   esi,dest
        shr   count,2
        jz    @end_sb32
@rep_sb32:
        mov   ebx,es:[edi]
        test  ebx,0FFFFFFh
        jz    @zero_sb32
        mov   eax,ds:[esi]
        mov   ecx,ebx
        shr   ecx,16
        mov   edx,eax
        shr   edx,16
        sub   bl,al
        jnc   @nor_sb32
          xor   bl,bl
        @nor_sb32:
        sub   bh,ah
        jnc   @nog_sb32
          xor   bh,bh
        @nog_sb32:
        sub   dl,cl
        jnc   @nob_sb32
          xor   dl,dl
        @nob_sb32:
        shl   edx,16
        mov   dx,bx
        mov   ds:[esi],edx
@zero_sb32:
        add   esi,4
        add   edi,4
        dec   count
        jnz   @rep_sb32
@end_sb32:
        pop   ds
        ret
sub_32_386 endp

sub_32_mmx proc
arg source:pword,dest:pword,count:dword
        lgs   esi,source
        les   edi,dest
        mov   ecx,count
        mov   edx,ecx
        shr   ecx,3
        jz    @once_sb32mx
@rep_sb32mx:

        movq     mm0,gs:[esi],2
        movq     mm1,mm0
        psrlq    mm1,32
        por      mm1,mm0
        movd     eax,mm1
        and      eax,0FFFFFFh
        jz       @zero_sb32mx

        psubusb  mm0,es:[edi],2
        movq     es:[edi],mm0,2
@zero_sb32mx:
        add   esi,8
        add   edi,8
        dec   ecx
        jnz   @rep_sb32mx
@once_sb32mx:
        test  edx,4
        jz    @end_sb32mx

        movd     mm0,gs:[esi],2
        psubusb  mm0,es:[edi],2
        movd     es:[edi],mm0,2
@end_sb32mx:
        emms
        ret
sub_32_mmx endp

alpha_merge proc
arg source:pword,channel:pword,count:dword
        les   edi,dest
        mov   ecx,count
        or    ecx,ecx
        jz    @end_am
        les   edi,source
        add   edi,3
        push  ds
        lds   esi,channel
        @lp_am:
          mov   al,ds:[esi]
          mov   es:[edi],al
          inc   esi
          add   edi,4
          dec   ecx
        jnz   @lp_am
        pop   ds
@end_am:
        ret
alpha_merge endp

alpha_15_386 proc
arg source:pword,dest:pword,count:dword
        mov   edx,count
        shr   edx,2
        jz    @end_a15
        push  ds
        les   edi,dest
        lds   esi,source
        push  ebp
        xor   ecx,ecx
        mov   ebp,edx
        @lp_a15:
          mov   cl,ds:[esi+3]
          neg   cl
          jz    @noput_a15

          mov   ebx,ds:[esi]
          mov   dx,es:[edi]


          mov   ax,dx
          shl   edx,9
          shr   dx,6
          shr   ax,2
          and   edx,0F800F8h
          mov   ah,bh
          and   ebx,0FF00FFh
          and   ax,0FFF8h


          sub   edx,ebx
          imul  edx,ecx
          shr   edx,8
          add   ebx,edx
          xor   edx,edx
          mov   dl,ah
          xor   ah,ah
          mov   bh,dl
          sub   ax,dx
          mul   cx
          add   bh,ah
          mov   edx,ebx
          shr   bh,3
          shr   edx,9
          shr   bx,3
          and   edx,07C00h
          or    bx,dx

          mov   es:[edi],bx
@noput_a15:
          add   esi,4
          add   edi,2
          dec   ebp
        jnz   @lp_a15
        pop   ebp
        pop   ds
@end_a15:
        ret
alpha_15_386 endp

alpha_16_386 proc
arg source:pword,dest:pword,count:dword
        mov   edx,count
        shr   edx,2
        jz    @end_a16
        push  ds
        les   edi,dest
        lds   esi,source
        push  ebp
        xor   ecx,ecx
        mov   ebp,edx
        @lp_a16:
          mov   cl,ds:[esi+3]
          neg   cl
          jz    @noput_a16

          mov   ebx,ds:[esi]
          mov   dx,es:[edi]


          mov   ax,dx
          shl   edx,8
          shr   dx,5
          shr   ax,3
          and   edx,0F800F8h
          mov   ah,bh
          and   ebx,0FF00FFh
          and   ax,0FFFCh


          sub   edx,ebx
          imul  edx,ecx
          shr   edx,8
          add   ebx,edx
          xor   edx,edx
          mov   dl,ah
          xor   ah,ah
          mov   bh,dl
          sub   ax,dx
          mul   cx
          add   bh,ah
          mov   edx,ebx
          shr   bh,2
          shr   edx,8
          shr   bx,3
          and   edx,0F800h
          or    bx,dx

          mov   es:[edi],bx
@noput_a16:
          add   esi,4
          add   edi,2
          dec   ebp
        jnz   @lp_a16
        pop   ebp
        pop   ds
@end_a16:
        ret
alpha_16_386 endp

alpha_24_386 proc
arg source:pword,dest:pword,count:dword
        mov   edx,count
        shr   edx,2
        jz    @end_a24
        push  ds
        les   edi,dest
        lds   esi,source
        xor   ecx,ecx
        @lp_a24:
          mov   cl,ds:[esi+3]
          neg   cl
          jz    @noput_a24
          push  edx
          mov   ebx,ds:[esi]
          mov   edx,es:[edi]

          mov   al,dh
          and   edx,0FF00FFh
          mov   ah,bh
          and   ebx,0FF00FFh


          sub   edx,ebx
          imul  edx,ecx
          shr   edx,8
          add   ebx,edx
          xor   edx,edx
          mov   dl,ah
          xor   ah,ah
          mov   bh,dl
          sub   ax,dx
          mul   cx
          add   bh,ah

          pop   edx
          mov   es:[edi],bx
          shr   ebx,16
          mov   es:[edi+2],bl
@noput_a24:
          add   esi,4
          add   edi,3

          dec   edx
        jnz   @lp_a24
        pop   ds
@end_a24:
        ret
alpha_24_386 endp

;!! not fully optimized yet
alpha_32_386 proc
arg source:pword,dest:pword,count:dword
        mov   edx,count
        shr   edx,2
        jz    @end_a32
        push  ds
        les   edi,dest
        lds   esi,source
        xor   ecx,ecx
        @lp_a32:
          mov   cl,ds:[esi+3]
          neg   cl
          jz    @noput_a32
          push  edx
          mov   ebx,ds:[esi]
          mov   edx,es:[edi]

          mov   al,dh
          and   edx,0FF00FFh
          mov   ah,bh
          and   ebx,0FF00FFh


          sub   edx,ebx
          imul  edx,ecx
          shr   edx,8
          add   ebx,edx
          xor   edx,edx
          mov   dl,ah
          xor   ah,ah
          mov   bh,dl
          sub   ax,dx
          mul   cx
          add   bh,ah

          pop   edx
          mov   es:[edi],ebx
@noput_a32:
          add   esi,4
          add   edi,4

          dec   edx
        jnz   @lp_a32
        pop   ds
@end_a32:
        ret
alpha_32_386 endp

alpha_32_mmx proc
arg source:pword,dest:pword,count:dword
        mov   ecx,count
        shr   ecx,2
        jz    @end_a32mx
        les   edi,dest
        lgs   esi,source
        xor   ebx,ebx
        xor   eax,eax
        pxor  mm2,mm2
        @lp_a32mx:
          mov   al,gs:[esi+3]
          or    al,al
          jz    @noput_a32mx

          movd       mm3,eax

          movd       mm0,gs:[esi],2
          punpcklwd  mm3,mm3
          movd       mm1,es:[edi],2
          punpckldq  mm3,mm3

          punpcklbw  mm0,mm2
          movq       mm4,mm1
          punpcklbw  mm1,mm2
          psubw      mm0,mm1
          pmullw     mm0,mm3
          psrlw      mm0,8
          packuswb   mm0,mm2
          paddb      mm0,mm4

          movd       es:[edi],mm0,2
@noput_a32mx:
          add   esi,4
          add   edi,4
          dec   ecx
        jnz   @lp_a32mx
        emms
@end_a32mx:
        ret
alpha_32_mmx endp

blend_24_fast proc
arg source1:pword,source2:pword,dest:pword,@@table:pword,count:dword
        les   edi,dest
        mov   ecx,3
        mov   eax,count
        cdq
        div   ecx
        or    eax,eax
        jz    @end_bl24f
        mov   count,eax
        push  ds
        lfs   edx,source1
        lgs   ecx,@@table
        lds   esi,source2
        xor   ch,ch
        @lp_bl24f:
          mov   eax,fs:[edx]
          add   edx,3
          mov   cl,al
          movzx ebx,byte ptr ds:[esi]
          sub   bx,cx
          add   al,gs:[bx+255]

          mov   cl,ah
          movzx ebx,byte ptr ds:[esi+1]
          sub   bx,cx
          add   ah,gs:[bx+255]
          mov   es:[edi],ax

          shr   eax,16
          mov   cl,al
          movzx ebx,byte ptr ds:[esi+2]
          add   esi,3
          sub   bx,cx
          add   al,gs:[bx+255]
          mov   es:[edi+2],al

          add   edi,3
          dec   count
        jnz   @lp_bl24f
        pop   ds
@end_bl24f:
        ret
blend_24_fast endp

blend_32_fast proc
arg source1:pword,source2:pword,dest:pword,@@table:pword,count:dword
        les   edi,dest
        shr   count,2
        jz    @end_bl32f
        push  ds
        lfs   edx,source1
        lgs   ecx,@@table
        lds   esi,source2
        xor   ch,ch
        @lp_bl32f:
          mov   eax,fs:[edx]
          add   edx,4
          mov   cl,al
          movzx ebx,byte ptr ds:[esi]
          sub   bx,cx
          add   al,gs:[bx+255]

          mov   cl,ah
          movzx ebx,byte ptr ds:[esi+1]
          sub   bx,cx
          add   ah,gs:[bx+255]
          mov   es:[edi],ax

          shr   eax,16
          mov   cl,al
          movzx ebx,byte ptr ds:[esi+2]
          add   esi,4
          sub   bx,cx
          add   al,gs:[bx+255]
          mov   es:[edi+2],al

          add   edi,4
          dec   count
        jnz   @lp_bl32f
        pop   ds
@end_bl32f:
        ret
blend_32_fast endp


blend_24_386 proc
arg source1:pword,source2:pword,dest:pword,count:dword,cover:byte
        mov   eax,count
        shr   eax,2
        jz    @end_bl24
        push  ds
        les   edi,dest
        lds   esi,source2
        xor   ecx,ecx
        mov   cl,cover
        lfs   edx,source1
        push  ebp
        neg   cl
        mov   ebp,eax
        @lp_bl24:
          push  edx
          mov   ebx,ds:[esi]
          mov   edx,fs:[edx]

          mov   al,dh
          and   edx,0FF00FFh
          mov   ah,bh
          and   ebx,0FF00FFh


          sub   edx,ebx
          imul  edx,ecx
          shr   edx,8
          add   ebx,edx
          xor   edx,edx
          mov   dl,ah
          xor   ah,ah
          mov   bh,dl
          sub   ax,dx
          mul   cx
          add   bh,ah

          mov   es:[edi],bx
          shr   ebx,16
          pop   edx
          mov   es:[edi+2],bl
          add   esi,3
          add   edx,3
          add   edi,3

          dec   ebp
        jnz   @lp_bl24
        pop   ebp
        pop   ds
@end_bl24:
        ret
blend_24_386 endp

blend_32_386 proc
arg source1:pword,source2:pword,dest:pword,count:dword,cover:byte
        mov   eax,count
        shr   eax,2
        jz    @end_bl32
        push  ds
        les   edi,dest
        lds   esi,source2
        xor   ecx,ecx
        mov   cl,cover
        lfs   edx,source1
        push  ebp
        neg   cl
        mov   ebp,eax
        @lp_bl32:
          push  edx
          mov   ebx,ds:[esi]
          mov   edx,fs:[edx]

          mov   al,dh
          and   edx,0FF00FFh
          mov   ah,bh
          and   ebx,0FF00FFh


          sub   edx,ebx
          imul  edx,ecx
          shr   edx,8
          add   ebx,edx
          xor   edx,edx
          mov   dl,ah
          xor   ah,ah
          mov   bh,dl
          sub   ax,dx
          mul   cx
          add   bh,ah

          pop   edx
          mov   es:[edi],ebx
          add   esi,4
          add   edx,4
          add   edi,4

          dec   ebp
        jnz   @lp_bl32
        pop   ebp
        pop   ds
@end_bl32:
        ret
blend_32_386 endp

blend_32_mmx proc
arg source1:pword,source2:pword,dest:pword,count:dword,cover:byte
        mov        ecx,count
        shr        ecx,3
        jz         @end_bl32mx
        movzx      eax,cover
        les        edi,dest
        xor        eax,0FFh
        lfs        edx,source1
        movd       mm3,eax
        lgs        esi,source2
        punpcklwd  mm3,mm3
        pxor       mm2,mm2
        punpckldq  mm3,mm3
        @lp_bl32mx:
          movq       mm0,fs:[edx],2
          movq       mm1,gs:[esi],2

          movq       mm5,mm0
          punpcklbw  mm0,mm2
          movq       mm4,mm1
          punpcklbw  mm1,mm2
          psubw      mm0,mm1
          pmullw     mm0,mm3
          movq       mm6,mm4
          psrlw      mm0,8

          psrlq      mm5,32
          psrlq      mm4,32
          punpcklbw  mm5,mm2
          punpcklbw  mm4,mm2
          psubw      mm5,mm4
          pmullw     mm5,mm3
          psrlw      mm5,8
          packuswb   mm0,mm5
          paddb      mm0,mm6

          movq       es:[edi],mm0,2

          add   edx,8
          add   edi,8
          add   esi,8
          dec   ecx
        jnz   @lp_bl32mx
        emms
@end_bl32mx:
        ret
blend_32_mmx endp

;!! untested
rle_8 proc
arg source : pword,dest : pword,sizex : word
           cld
           push  ds
           xor   ecx,ecx
           lds   esi,source
           les   edi,dest
           add   esi,2
           mov   dx,sizex
           dec   dx
@lp_rle8 : mov   bx,ds:[esi]
           mov   al,bl
           shr   al,6
           cmp   al,2
           je    @copy_rle8
           ja    @pp_rle8
           mov   al,bh
           and   bx,3Fh
           mov   ah,al
           mov   cx,bx
           shr   cl,2
           jz    @rep_b4_rle8
           push  ax
           shl   eax,16
           pop   ax
           db 67h
           rep   stosd
@rep_b4_rle8:
           mov   cx,bx
           and   cx,11b
           jz    @rep_zero_rle8
           mov   es:[edi],ax
           add   edi,ecx
           and   cl,1b
           jz    @rep_zero_rle8
           mov   es:[edi-1],al
@rep_zero_rle8:
           add   esi,2
           sub   dx,bx
           jnc   @lp_rle8
           jmp   @stop_rle8
@copy_rle8:and   bx,3Fh
           mov   cx,bx
           inc   esi
           db 67h
           rep   movsb
           sub   dx,bx
           jnc   @lp_rle8
           jmp   @stop_rle8
@pp_rle8:  mov   es:[edi],bl
           inc   esi
           inc   edi
           sub   dx,1
           jnc   @lp_rle8
@stop_rle8:pop   ds
           ret
rle_8 endp

rle_1516 proc
arg source : pword,dest : pword,sizex : word
           cld
           les   edi,dest
           push  ds
           lds   esi,source
           add   esi,2
           mov   dx,sizex
           dec   dx
@lp_rle16: mov   bl,ds:[esi]
;           mov   al,bl
;           shr   al,6
;           cmp   al,2
           cmp    bl,128
           jae    @copy_rle16
;           ja    @pp_rle16
           and   bx,3Fh
           mov   ax,ds:[esi+1]
           mov   cx,bx
           db  67h
           rep   stosw
           add   esi,3
           sub   dx,bx
           jnc   @lp_rle16
           jmp   @stop_rle16
@copy_rle16:
           and   bx,3Fh
           mov   cx,bx
           inc   esi
           db 67h
           rep   movsw
           sub   dx,bx
           jnc   @lp_rle16
;           jmp   @stop_rle16
;@pp_rle16: mov   es:[edi],bl
;           inc   esi
;           inc   edi
;           sub   dx,1
;           jnc   @lp_rle16
@stop_rle16:
           pop   ds
           ret
rle_1516 endp

;!! untested
rle_32 proc
arg source : pword,dest : pword,sizex : word
           cld
           les   edi,dest
           push  ds
           lds   esi,source
           add   esi,2
           mov   dx,sizex
           dec   dx
@lp_rle32: mov   ebx,ds:[esi]
;           mov   al,bl
;           shr   al,6
;           cmp   al,2
           cmp    bl,128
           jae    @copy_rle32
;           ja    @pp_rle32
           mov   eax,ebx
           and   bx,3Fh
           shr   eax,8
           mov   cx,bx
           db  67h
           rep   stosd
           add   esi,4
           sub   dx,bx
           jnc   @lp_rle32
           jmp   @stop_rle32
@copy_rle32:
           and   bx,3Fh
           mov   cx,bx
           inc   esi
           db 67h
           rep   movsd
           sub   dx,bx
           jnc   @lp_rle32
;           jmp   @stop_rle32
;@pp_rle32: mov   es:[edi],bl
;           inc   esi
;           inc   edi
;           sub   dx,1
;           jnc   @lp_rle32
@stop_rle32:
           pop   ds
           ret
rle_32 endp

scale_8 proc
arg source: pword,dest: pword,count: dword,wx: dword
           les   edi,dest
           push  ds
           lds   esi,source
           mov   ecx,count
           shr   ecx,1
           jz    @stop_sc8
           mov   dx,word ptr wx
           xor   bx,bx
           xor   eax,eax
           mov   ax,word ptr wx[2]
           push  ebp
           mov   ebp,eax
           or    ebp,ebp
           jz    @lp_sc8
@lp2_sc8:  mov   al,ds:[esi]
           add   bx,dx
           adc   esi,ebp
           mov   ah,ds:[esi]
           add   bx,dx
           adc   esi,ebp
           db 67h
           stosw
           dec   ecx
           jnz   @lp2_sc8
           pop   ebp
           jmp   @stop_sc8

@lp_sc8:   mov   al,ds:[esi]
           add   bx,dx
           jc    @carry_sc8
           mov   ah,al
           add   bx,dx
           adc   esi,ebp
           db 67h
           stosw
           dec   ecx
           jnz   @lp_sc8
           pop   ebp
           jmp   @stop_sc8
@carry_sc8:
           mov   ah,ds:[esi+1]
           inc   esi
           add   bx,dx
           adc   esi,ebp
           db 67h
           stosw
           dec   ecx
           jnz   @lp_sc8
           pop   ebp
@stop_sc8:
           test  count,1
           jz    @end_sc8
           mov   al,ds:[esi]
           mov   es:[edi],al
@end_sc8:
           pop   ds
           ret
scale_8 endp

scale_1516 proc
arg source: pword,dest: pword,count: dword,wx: dword
           les   edi,dest
           push  ds
           lds   esi,source
           mov   ecx,count
           shr   ecx,1
           jz    @end_sc16
           mov   dx,word ptr wx
           xor   bx,bx
           xor   eax,eax
           mov   ax,word ptr wx[2]
           push  ebp
           mov   ebp,eax
           shl   ebp,1
           jnz   @lpdown_sc16

           mov   ax,ds:[esi]
@lp_sc16:  add   bx,dx
           jnc   @next_sc16
           mov   ax,ds:[esi+2]
           add   esi,2
@next_sc16:
           db 67h
           stosw
           dec   ecx
           jnz   @lp_sc16
           pop   ebp
           pop   ds
           ret

@lpdown_sc16:
           mov   ax,ds:[esi]
           add   bx,dx
           jnc   @next2_sc16
           add   esi,2
@next2_sc16:
           add   esi,ebp
           db 67h
           stosw
           dec   ecx
           jnz   @lpdown_sc16
           pop   ebp

@end_sc16:
           pop   ds
           ret
scale_1516 endp

scale_24 proc
arg source: pword,dest: pword,count: dword,wx: dword
           les   edi,dest
           push  ds
           lds   esi,source
           mov   ecx,3
           mov   eax,count
           cdq
           div   ecx
           or    eax,eax
           jz    @end_sc24
           mov   ecx,eax
           mov   dx,word ptr wx
           xor   bx,bx
           xor   eax,eax
           mov   ax,word ptr wx[2]
           push  ebp
           mov   ebp,eax
           shl   ebp,1
           add   ebp,eax
           jnz   @lpdown_sc24

           mov   bp,ds:[esi]
           mov   al,ds:[esi+2]
@lp_sc24:
           add   bx,dx
           jnc   @next_sc24
             mov   bp,ds:[esi+3]
             mov   al,ds:[esi+5]
             add   esi,3
           @next_sc24:
           mov   es:[edi],bp
           mov   es:[edi+2],al
           add   edi,3
           dec   ecx
           jnz   @lp_sc24
           pop   ebp
           pop   ds
           ret

@lpdown_sc24:
           mov   eax,ds:[esi]
           add   bx,dx
           jnc   @next2_sc24
             add   esi,3
           @next2_sc24:
           add   esi,ebp
           mov   es:[edi],ax
           shr   eax,16
           mov   es:[edi+2],al
           add   edi,3
           dec   ecx
           jnz   @lpdown_sc24
           pop   ebp
@end_sc24:
           pop   ds
           ret
scale_24 endp

scale_32 proc
arg source: pword,dest: pword,count: dword,wx: dword
           les   edi,dest
           push  ds
           lds   esi,source
           mov   ecx,count
           shr   ecx,2
           jz    @end_sc32
           mov   dx,word ptr wx
           xor   bx,bx
           xor   eax,eax
           mov   ax,word ptr wx[2]
           push  ebp
           mov   ebp,eax
           shl   ebp,2
           jnz   @lpdown_sc32

           mov   eax,ds:[esi]
@lp_sc32:
           add   bx,dx
           jnc   @next_sc32
             mov   eax,ds:[esi+4]
             add   esi,4
           @next_sc32:
           db 67h
           stosd
           dec   ecx
           jnz   @lp_sc32
           pop   ebp
           pop   ds
           ret

@lpdown_sc32:
           mov   eax,ds:[esi]
           add   bx,dx
           jnc   @next2_sc32
             add   esi,4
           @next2_sc32:
           add   esi,ebp
           db 67h
           stosd
           dec   ecx
           jnz   @lpdown_sc32
           pop   ebp
@end_sc32:
           pop   ds
           ret
scale_32 endp


biscale_15 proc
arg source: pword,dest: pword,sx: dword,bpl: dword,topval: dword,bottomval: dword,fx: dword,gyab: dword,eyab: dword

           mov   eax,fx
           neg   eax
           mov   gx,eax
           mov   ex,0
           lgs   eax,dest
           les   edi,source
           xor   esi,esi

@lp_x_bs15:xor   edx,edx
           mov   val_blue,0
           mov   val_green,0
           mov   val_red,0
           mov   eax,fx
           mov   ebx,gx
           mov   ecx,ex
           add   ebx,eax
           add   ecx,eax
           mov   gx,ebx
           mov   ex,ecx
           mov   eax,ecx
           shr   ebx,8
           shr   ecx,8
           and   eax,0FFh
           jnz   @noflow_bs15
           dec   ecx

@noflow_bs15:
           mov   gxab,ebx
           mov   exab,ecx

           mov   eax,ecx
           shl   eax,16
           cdq
           div   fx
           mov   ecx,eax

           shl   esi,8
           lea   ebx,[esi+100h]
           sub   ebx,ecx
           mov   rightval,ebx

           sub   ecx,esi
           mov   leftval,ecx
           shr   esi,8

           mov   edi,gxab
           mov   eax,gyab
           mul   bpl
           add   eax,dword ptr source
           lea   edi,[edi*2+eax]

           push  esi
           mov   esi,gyab

@lp_py_bs15:
           mov   cx,word ptr gxab
           mov   dx,cx
           push  edi

@lp_px_bs15:

; Load pixel colors
           xor   eax,eax
           mov   ax,es:[edi]
           xor   ebx,ebx
           mov   bx,ax
           shl   bx,11
           mov   sum_blue,bx
           mov   bx,ax
           shl   bx,6
           and   bx,0F800h
           mov   sum_green,bx
           shl   ax,1
           and   ax,0F800h
           mov   sum_red,ax
           add   edi,2

; Left/Right part
           cmp   word ptr exab,dx
           je    @right_end_bs15

           cmp   cx,dx
           jne   @right_bs15

           mov   ebx,leftval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
           jmp   @right_end_bs15

@right_bs15:
           mov   ebx,rightval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax

@right_end_bs15:

; Top/Bottom part
           mov   ax,word ptr gyab
           cmp   ax,word ptr eyab
           je    @bottom_end_bs15

           cmp   si,word ptr gyab
           jne   @bottom_bs15

           mov   ebx,bottomval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
           jmp   @bottom_end_bs15

@bottom_bs15:
           mov   ebx,topval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax

@bottom_end_bs15:
           mov   ax,sum_blue
           add   ax,127
           add   val_blue,ax

           mov   ax,sum_green
           add   ax,127
           add   val_green,ax

           mov   ax,sum_red
           add   ax,127
           add   val_red,ax

           inc   cx
           cmp   cx,word ptr exab
           jna   @lp_px_bs15

           pop   edi
           add   edi,bpl
           inc   esi
           cmp   esi,eyab
           jna   @lp_py_bs15

           pop   esi
           mov   ax,val_red
           and   ax,0F800h
           shr   ax,1
           mov   al,byte ptr val_blue[1]
           shr   al,3
           mov   bx,val_green
           and   bx,0F800h
           shr   bx,6
           or    ax,bx
           mov   gs:[esi*2],ax

           inc   esi
           cmp   esi,sx
           jne   @lp_x_bs15
           ret
biscale_15 endp

biscale_16 proc
arg source: pword,dest: pword,sx: dword,bpl: dword,topval: dword,bottomval: dword,fx: dword,gyab: dword,eyab: dword

           mov   eax,fx
           neg   eax
           mov   gx,eax
           mov   ex,0
           lgs   eax,dest
           les   edi,source
           xor   esi,esi

@lp_x_bs16:xor   edx,edx
           mov   val_blue,0
           mov   val_green,0
           mov   val_red,0
           mov   eax,fx
           mov   ebx,gx
           mov   ecx,ex
           add   ebx,eax
           add   ecx,eax
           mov   gx,ebx
           mov   ex,ecx
           mov   eax,ecx
           shr   ebx,8
           shr   ecx,8
           and   eax,0FFh
           jnz   @noflow_bs16
           dec   ecx

@noflow_bs16:
           mov   gxab,ebx
           mov   exab,ecx

           mov   eax,ecx
           shl   eax,16
           cdq
           div   fx
           mov   ecx,eax

           shl   esi,8
           lea   ebx,[esi+100h]
           sub   ebx,ecx
           mov   rightval,ebx

           sub   ecx,esi
           mov   leftval,ecx
           shr   esi,8

           mov   edi,gxab
           mov   eax,gyab
           mul   bpl
           add   eax,dword ptr source
           lea   edi,[edi*2+eax]

           push  esi
           mov   esi,gyab

@lp_py_bs16:
           mov   cx,word ptr gxab
           mov   dx,cx
           push  edi

@lp_px_bs16:

; Load pixel colors
           xor   eax,eax
           mov   ax,es:[edi]
           xor   ebx,ebx
           mov   bx,ax
           shl   bx,11
           mov   sum_blue,bx
           mov   bx,ax
           shl   bx,5
           and   bx,0FC00h
           mov   sum_green,bx
           and   ax,0F800h
           mov   sum_red,ax
           add   edi,2

; Left/Right part
           cmp   word ptr exab,dx
           je    @right_end_bs16

           cmp   cx,dx
           jne   @right_bs16

           mov   ebx,leftval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
           jmp   @right_end_bs16

@right_bs16:
           mov   ebx,rightval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax

@right_end_bs16:

; Top/Bottom part
           mov   ax,word ptr gyab
           cmp   ax,word ptr eyab
           je    @bottom_end_bs16

           cmp   si,word ptr gyab
           jne   @bottom_bs16

           mov   ebx,bottomval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
           jmp   @bottom_end_bs16

@bottom_bs16:
           mov   ebx,topval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax

@bottom_end_bs16:
           mov   ax,sum_blue
           add   ax,127
           add   val_blue,ax

           mov   ax,sum_green
           add   ax,127
           add   val_green,ax

           mov   ax,sum_red
           add   ax,127
           add   val_red,ax

           inc   cx
           cmp   cx,word ptr exab
           jna   @lp_px_bs16

           pop   edi
           add   edi,bpl
           inc   esi
           cmp   esi,eyab
           jna   @lp_py_bs16

           pop   esi
           mov   ax,val_red
           and   ax,0F800h
           mov   al,byte ptr val_blue[1]
           shr   al,3
           mov   bx,val_green
           and   bx,0FC00h
           shr   bx,5
           or    ax,bx
           mov   gs:[esi*2],ax

           inc   esi
           cmp   esi,sx
           jne   @lp_x_bs16
           ret
biscale_16 endp

biscale_24 proc
arg source: pword,dest: pword,sx: dword,bpl: dword,topval: dword,bottomval: dword,fx: dword,gyab: dword,eyab: dword

           mov   eax,fx
           neg   eax
           mov   gx,eax
           mov   ex,0
           lgs   eax,dest
           les   edi,source
           xor   esi,esi

@lp_x_bs24:xor   edx,edx
           mov   val_blue,0
           mov   val_green,0
           mov   val_red,0
           mov   eax,fx
           mov   ebx,gx
           mov   ecx,ex
           add   ebx,eax
           add   ecx,eax
           mov   gx,ebx
           mov   ex,ecx
           mov   eax,ecx
           shr   ebx,8
           shr   ecx,8
           and   eax,0FFh
           jnz   @noflow_bs24
           dec   ecx

@noflow_bs24:
           mov   gxab,ebx
           mov   exab,ecx

           mov   eax,ecx
           shl   eax,16
           cdq
           div   fx
           mov   ecx,eax

           shl   esi,8
           lea   ebx,[esi+100h]
           sub   ebx,ecx
           mov   rightval,ebx

           sub   ecx,esi
           mov   leftval,ecx
           shr   esi,8

           mov   edi,gxab
           mov   eax,gyab
           mul   bpl
           add   eax,dword ptr source
           add   eax,edi
           lea   edi,[edi*2+eax]

           push  esi
           mov   esi,gyab

@lp_py_bs24:
           mov   cx,word ptr gxab
           mov   dx,cx
           push  edi

@lp_px_bs24:

; Load pixel colors
           mov   eax,es:[edi]
           xor   ebx,ebx
           mov   bh,al
           mov   sum_blue,bx
           mov   bh,ah
           mov   sum_green,bx
           shr   eax,16
           mov   bh,al
           mov   sum_red,bx
           add   edi,3

; Left/Right part
           cmp   word ptr exab,dx
           je    @right_end_bs24

           cmp   cx,dx
           jne   @right_bs24

           mov   ebx,leftval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
           jmp   @right_end_bs24

@right_bs24:
           mov   ebx,rightval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax

@right_end_bs24:

; Top/Bottom part
           mov   ax,word ptr gyab
           cmp   ax,word ptr eyab
           je    @bottom_end_bs24

           cmp   si,word ptr gyab
           jne   @bottom_bs24

           mov   ebx,bottomval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
           jmp   @bottom_end_bs24

@bottom_bs24:
           mov   ebx,topval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax

@bottom_end_bs24:
           mov   ax,sum_blue
           add   val_blue,ax

           mov   ax,sum_green
           add   val_green,ax

           mov   ax,sum_red
           add   val_red,ax

           inc   cx
           cmp   cx,word ptr exab
           jna   @lp_px_bs24

           pop   edi
           add   edi,bpl
           inc   esi
           cmp   esi,eyab
           jna   @lp_py_bs24

           pop   esi
           mov   ah,byte ptr val_green[1]
           mov   al,byte ptr val_blue[1]
           mov   gs:[esi*2+esi],ax

           mov   al,byte ptr val_red[1]
           mov   gs:[esi*2+esi+2],al

           inc   esi
           cmp   esi,sx
           jne   @lp_x_bs24
           ret
biscale_24 endp

biscale_32 proc
arg source: pword,dest: pword,sx: dword,bpl: dword,topval: dword,bottomval: dword,fx: dword,gyab: dword,eyab: dword

           mov   eax,fx
           neg   eax
           mov   gx,eax
           mov   ex,0
           lgs   eax,dest
           les   edi,source
           xor   esi,esi

@lp_x_bs32:xor   edx,edx
           mov   val_blue,0
           mov   val_green,0
           mov   val_red,0
           mov   eax,fx
           mov   ebx,gx
           mov   ecx,ex
           add   ebx,eax
           add   ecx,eax
           mov   gx,ebx
           mov   ex,ecx
           mov   eax,ecx
           shr   ebx,8
           shr   ecx,8
           and   eax,0FFh
           jnz   @noflow_bs32
           dec   ecx

@noflow_bs32:
           mov   gxab,ebx
           mov   exab,ecx

           mov   eax,ecx
           shl   eax,16
           cdq
           div   fx
           mov   ecx,eax

           shl   esi,8
           lea   ebx,[esi+100h]
           sub   ebx,ecx
           mov   rightval,ebx

           sub   ecx,esi
           mov   leftval,ecx
           shr   esi,8

           mov   edi,gxab
           mov   eax,gyab
           mul   bpl
           add   eax,dword ptr source
           lea   edi,[edi*4+eax]

           push  esi
           mov   esi,gyab

@lp_py_bs32:
           mov   cx,word ptr gxab
           mov   dx,cx
           push  edi

@lp_px_bs32:

; Load pixel colors
           mov   eax,es:[edi]
           xor   ebx,ebx
           mov   bh,al
           mov   sum_blue,bx
           mov   bh,ah
           mov   sum_green,bx
           shr   eax,16
           mov   bh,al
           mov   sum_red,bx
           mov   sum_alpha,ah
           add   edi,4

; Left/Right part
           cmp   word ptr exab,dx
           je    @right_end_bs32

           cmp   cx,dx
           jne   @right_bs32

           mov   ebx,leftval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
           jmp   @right_end_bs32

@right_bs32:
           mov   ebx,rightval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax

@right_end_bs32:

; Top/Bottom part
           mov   ax,word ptr gyab
           cmp   ax,word ptr eyab
           je    @bottom_end_bs32

           cmp   si,word ptr gyab
           jne   @bottom_bs32

           mov   ebx,bottomval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
           jmp   @bottom_end_bs32

@bottom_bs32:
           mov   ebx,topval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax

@bottom_end_bs32:
           mov   ax,sum_blue
           add   val_blue,ax

           mov   ax,sum_green
           add   val_green,ax

           mov   ax,sum_red
           add   val_red,ax

           inc   cx
           cmp   cx,word ptr exab
           jna   @lp_px_bs32

           pop   edi
           add   edi,bpl
           inc   esi
           cmp   esi,eyab
           jna   @lp_py_bs32

           pop   esi
           mov   al,byte ptr val_red[1]
           mov   ah,sum_alpha
           shl   eax,16
           mov   ah,byte ptr val_green[1]
           mov   al,byte ptr val_blue[1]
           mov   gs:[esi*4],eax

           inc   esi
           cmp   esi,sx
           jne   @lp_x_bs32
           ret
biscale_32 endp

biscaledown_15 proc
arg source: pword,dest: pword,sx: dword,bpl: dword,topval: dword,bottomval: dword,fx: dword,fxy: dword,gyab: dword,eyab: dword

           mov   eax,fx
           neg   eax
           mov   gx,eax
           mov   ex,0
           lgs   eax,dest
           les   edi,source
           xor   esi,esi

@lp_x_bd15:xor   edx,edx
           mov   val_blue,0
           mov   val_green,0
           mov   val_red,0
           mov   eax,fx
           mov   ebx,gx
           mov   ecx,ex
           add   ebx,eax
           add   ecx,eax
           mov   gx,ebx
           mov   ex,ecx
           mov   eax,ecx
           shr   ebx,8
           shr   ecx,8
           and   eax,0FFh
           jnz   @noflow_bd15
           dec   ecx

@noflow_bd15:
           mov   gxab,ebx
           mov   exab,ecx

           mov   edi,ebx
           mov   eax,ecx
           shl   eax,8
           mov   ebx,ex
           sub   ebx,eax
           mov   rightval,ebx

           lea   eax,[edi+1]
           shl   eax,8
           sub   eax,gx
           mov   leftval,eax

           mov   eax,gyab
           mul   bpl
           add   eax,dword ptr source
           lea   edi,[edi*2+eax]

           push  esi
           mov   esi,gyab

@lp_py_bd15:
           mov   cx,word ptr gxab
           mov   dx,cx
           push  edi

@lp_px_bd15:

; Load pixel colors
           push  ecx
           push  edx
           mov   ebx,fxy
           mov   cx,es:[edi]

           mov   ax,cx
           and   eax,01Fh
           shl   eax,19
           cdq
           div   ebx
           mov   sum_blue,ax

           mov   eax,ecx
           and   eax,03E0h
           shl   eax,14
           cdq
           div   ebx
           mov   sum_green,ax

           mov   eax,ecx
           and   eax,07C00h
           shl   eax,9
           cdq
           div   ebx
           mov   sum_red,ax

           add   edi,2
           pop   edx
           pop   ecx

; Left/Right part
           cmp   cx,dx
           jne   @right_bd15

           mov   ebx,leftval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
           jmp   @right_end_bd15

@right_bd15:
           cmp   cx,word ptr exab
           jne   @right_end_bd15

           mov   ebx,rightval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax

@right_end_bd15:

; Top/Bottom part
           cmp   si,word ptr gyab
           jne   @bottom_bd15

           mov   ebx,bottomval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
           jmp   @bottom_end_bd15

@bottom_bd15:
           cmp   si,word ptr eyab
           jne   @bottom_end_bd15

           mov   ebx,topval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax

@bottom_end_bd15:
           mov   ax,sum_blue
           add   val_blue,ax

           mov   ax,sum_green
           add   val_green,ax

           mov   ax,sum_red
           add   val_red,ax

           inc   cx
           cmp   cx,word ptr exab
           jna   @lp_px_bd15

           pop   edi
           add   edi,bpl
           inc   esi
           cmp   esi,eyab
           jna   @lp_py_bd15

           pop   esi
           mov   ax,val_red
           and   ax,0F800h
           shr   ax,1
           mov   al,byte ptr val_blue[1]
           shr   al,3
           mov   bx,val_green
           and   bx,0F800h
           shr   bx,6
           or    ax,bx
           mov   gs:[esi*2],ax

           inc   esi
           cmp   esi,sx
           jne   @lp_x_bd15
           ret
biscaledown_15 endp

biscaledown_16 proc
arg source: pword,dest: pword,sx: dword,bpl: dword,topval: dword,bottomval: dword,fx: dword,fxy: dword,gyab: dword,eyab: dword

           mov   eax,fx
           neg   eax
           mov   gx,eax
           mov   ex,0
           lgs   eax,dest
           les   edi,source
           xor   esi,esi

@lp_x_bd16:xor   edx,edx
           mov   val_blue,0
           mov   val_green,0
           mov   val_red,0
           mov   eax,fx
           mov   ebx,gx
           mov   ecx,ex
           add   ebx,eax
           add   ecx,eax
           mov   gx,ebx
           mov   ex,ecx
           mov   eax,ecx
           shr   ebx,8
           shr   ecx,8
           and   eax,0FFh
           jnz   @noflow_bd16
           dec   ecx

@noflow_bd16:
           mov   gxab,ebx
           mov   exab,ecx

           mov   edi,ebx
           mov   eax,ecx
           shl   eax,8
           mov   ebx,ex
           sub   ebx,eax
           mov   rightval,ebx

           lea   eax,[edi+1]
           shl   eax,8
           sub   eax,gx
           mov   leftval,eax

           mov   eax,gyab
           mul   bpl
           add   eax,dword ptr source
           lea   edi,[edi*2+eax]

           push  esi
           mov   esi,gyab

@lp_py_bd16:
           mov   cx,word ptr gxab
           mov   dx,cx
           push  edi

@lp_px_bd16:

; Load pixel colors
           push  ecx
           push  edx
           mov   ebx,fxy
           mov   cx,es:[edi]

           mov   ax,cx
           and   eax,01Fh
           shl   eax,19
           cdq
           div   ebx
           mov   sum_blue,ax

           mov   eax,ecx
           and   eax,07E0h
           shl   eax,13
           cdq
           div   ebx
           mov   sum_green,ax

           mov   eax,ecx
           and   eax,0F800h
           shl   eax,8
           cdq
           div   ebx
           mov   sum_red,ax

           add   edi,2
           pop   edx
           pop   ecx

; Left/Right part

           cmp   cx,dx
           jne   @right_bd16

           mov   ebx,leftval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
           jmp   @right_end_bd16

@right_bd16:
           cmp   cx,word ptr exab
           jne   @right_end_bd16

           mov   ebx,rightval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax

@right_end_bd16:

; Top/Bottom part
           cmp   si,word ptr gyab
           jne   @bottom_bd16

           mov   ebx,bottomval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
           jmp   @bottom_end_bd16

@bottom_bd16:
           cmp   si,word ptr eyab
           jne   @bottom_end_bd16

           mov   ebx,topval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax

@bottom_end_bd16:
           mov   ax,sum_blue
           add   val_blue,ax

           mov   ax,sum_green
           add   val_green,ax

           mov   ax,sum_red
           add   val_red,ax

           inc   cx
           cmp   cx,word ptr exab
           jna   @lp_px_bd16

           pop   edi
           add   edi,bpl
           inc   esi
           cmp   esi,eyab
           jna   @lp_py_bd16

           pop   esi
           mov   ax,val_red
           and   ax,0F800h
           mov   al,byte ptr val_blue[1]
           shr   al,3
           mov   bx,val_green
           and   bx,0FC00h
           shr   bx,5
           or    ax,bx
           mov   gs:[esi*2],ax

           inc   esi
           cmp   esi,sx
           jne   @lp_x_bd16
           ret
biscaledown_16 endp

biscaledown_24 proc
arg source: pword,dest: pword,sx: dword,bpl: dword,topval: dword,bottomval: dword,fx: dword,fxy: dword,gyab: dword,eyab: dword

           mov   eax,fx
           neg   eax
           mov   gx,eax
           mov   ex,0
           lgs   eax,dest
           les   edi,source
           xor   esi,esi

@lp_x_bd24:xor   edx,edx
           mov   val_blue,0
           mov   val_green,0
           mov   val_red,0
           mov   eax,fx
           mov   ebx,gx
           mov   ecx,ex
           add   ebx,eax
           add   ecx,eax
           mov   gx,ebx
           mov   ex,ecx
           mov   eax,ecx
           shr   ebx,8
           shr   ecx,8
           and   eax,0FFh
           jnz   @noflow_bd24
           dec   ecx

@noflow_bd24:
           mov   gxab,ebx
           mov   exab,ecx

           mov   edi,ebx
           mov   eax,ecx
           shl   eax,8
           mov   ebx,ex
           sub   ebx,eax
           mov   rightval,ebx

           lea   eax,[edi+1]
           shl   eax,8
           sub   eax,gx
           mov   leftval,eax

           mov   eax,gyab
           mul   bpl
           add   eax,dword ptr source
           add   eax,edi
           lea   edi,[edi*2+eax]

           push  esi
           mov   esi,gyab

@lp_py_bd24:
           mov   cx,word ptr gxab
           mov   dx,cx
           push  edi

@lp_px_bd24:

; Load pixel colors
           push  ecx
           push  edx
           mov   ebx,fxy
           mov   ecx,es:[edi]

           mov   eax,ecx
           and   eax,0FFh
           shl   eax,16
           cdq
           div   ebx
           mov   sum_blue,ax

           mov   eax,ecx
           and   eax,0FF00h
           shl   eax,8
           cdq
           div   ebx
           mov   sum_green,ax

           mov   eax,ecx
           and   eax,0FF0000h
           cdq
           div   ebx
           mov   sum_red,ax

           add   edi,3
           pop   edx
           pop   ecx

; Left/Right part

           cmp   cx,dx
           jne   @right_bd24

           mov   ebx,leftval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
           jmp   @right_end_bd24

@right_bd24:
           cmp   cx,word ptr exab
           jne   @right_end_bd24

           mov   ebx,rightval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax

@right_end_bd24:

; Top/Bottom part
           cmp   si,word ptr gyab
           jne   @bottom_bd24

           mov   ebx,bottomval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
           jmp   @bottom_end_bd24

@bottom_bd24:
           cmp   si,word ptr eyab
           jne   @bottom_end_bd24

           mov   ebx,topval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax

@bottom_end_bd24:
           mov   ax,sum_blue
           add   val_blue,ax

           mov   ax,sum_green
           add   val_green,ax

           mov   ax,sum_red
           add   val_red,ax

           inc   cx
           cmp   cx,word ptr exab
           jna   @lp_px_bd24

           pop   edi
           add   edi,bpl
           inc   esi
           cmp   esi,eyab
           jna   @lp_py_bd24

           pop   esi
           mov   ah,byte ptr val_green[1]
           mov   al,byte ptr val_blue[1]
           mov   gs:[esi*2+esi],ax

           mov   al,byte ptr val_red[1]
           mov   gs:[esi*2+esi+2],al

           inc   esi
           cmp   esi,sx
           jne   @lp_x_bd24
           ret
biscaledown_24 endp

biscaledown_32 proc
arg source: pword,dest: pword,sx: dword,bpl: dword,topval: dword,bottomval: dword,fx: dword,fxy: dword,gyab: dword,eyab: dword

           mov   eax,fx
           neg   eax
           mov   gx,eax
           mov   ex,0
           lgs   eax,dest
           les   edi,source
           xor   esi,esi

@lp_x_bd32:xor   edx,edx
           mov   val_blue,0
           mov   val_green,0
           mov   val_red,0
           mov   eax,fx
           mov   ebx,gx
           mov   ecx,ex
           add   ebx,eax
           add   ecx,eax
           mov   gx,ebx
           mov   ex,ecx
           mov   eax,ecx
           shr   ebx,8
           shr   ecx,8
           and   eax,0FFh
           jnz   @noflow_bd32
           dec   ecx

@noflow_bd32:
           mov   gxab,ebx
           mov   exab,ecx

           mov   edi,ebx
           mov   eax,ecx
           shl   eax,8
           mov   ebx,ex
           sub   ebx,eax
           mov   rightval,ebx

           lea   eax,[edi+1]
           shl   eax,8
           sub   eax,gx
           mov   leftval,eax

           mov   eax,gyab
           mul   bpl
           add   eax,dword ptr source
           lea   edi,[edi*4+eax]

           push  esi
           mov   esi,gyab

@lp_py_bd32:
           mov   cx,word ptr gxab
           mov   dx,cx
           push  edi

@lp_px_bd32:

; Load pixel colors
           push  ecx
           push  edx
           mov   ebx,fxy
           mov   ecx,es:[edi]

           mov   eax,ecx
           and   eax,0FFh
           shl   eax,16
           cdq
           div   ebx
           mov   sum_blue,ax

           mov   eax,ecx
           and   eax,0FF00h
           shl   eax,8
           cdq
           div   ebx
           mov   sum_green,ax

           mov   eax,ecx
           and   eax,0FF0000h
           cdq
           div   ebx
           mov   sum_red,ax

           shr   ecx,16
           mov   sum_alpha,ch

           add   edi,4
           pop   edx
           pop   ecx

; Left/Right part

           cmp   cx,dx
           jne   @right_bd32

           mov   ebx,leftval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
           jmp   @right_end_bd32

@right_bd32:
           cmp   cx,word ptr exab
           jne   @right_end_bd32

           mov   ebx,rightval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax

@right_end_bd32:

; Top/Bottom part
           cmp   si,word ptr gyab
           jne   @bottom_bd32

           mov   ebx,bottomval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
           jmp   @bottom_end_bd32

@bottom_bd32:
           cmp   si,word ptr eyab
           jne   @bottom_end_bd32

           mov   ebx,topval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax

@bottom_end_bd32:
           mov   ax,sum_blue
           add   val_blue,ax

           mov   ax,sum_green
           add   val_green,ax

           mov   ax,sum_red
           add   val_red,ax

           inc   cx
           cmp   cx,word ptr exab
           jna   @lp_px_bd32

           pop   edi
           add   edi,bpl
           inc   esi
           cmp   esi,eyab
           jna   @lp_py_bd32

           pop   esi
           mov   al,byte ptr val_red[1]
           mov   ah,sum_alpha
           shl   eax,16
           mov   ah,byte ptr val_green[1]
           mov   al,byte ptr val_blue[1]
           mov   gs:[esi*4],eax

           inc   esi
           cmp   esi,sx
           jne   @lp_x_bd32
           ret
biscaledown_32 endp

biscale_32_mmx proc
arg source: pword,dest: pword,sx: dword,bpl: dword,topval: dword,bottomval: dword,fx: dword,gyab: dword,eyab: dword

           mov   eax,fx
           neg   eax
           mov   gx,eax
           mov   ex,0
           lgs   eax,dest
           les   edi,source
           xor   esi,esi

@lp_x_mx:  xor   edx,edx
           mov   val_blue,0
           mov   val_green,0
           mov   val_red,0
           mov   eax,fx
           mov   ebx,gx
           mov   ecx,ex
           add   ebx,eax
           add   ecx,eax
           mov   gx,ebx
           mov   ex,ecx
           mov   eax,ecx
           shr   ebx,8
           shr   ecx,8
           and   eax,0FFh
           jnz   @noflow_mx
           dec   ecx

@noflow_mx:mov   gxab,ebx
           mov   exab,ecx

           mov   eax,exab
           shl   eax,16
           cdq
           div   fx
           mov   ecx,eax

           shl   esi,8
           lea   ebx,[esi+100h]
           sub   ebx,ecx
           mov   rightval,ebx

           sub   ecx,esi
           mov   leftval,ecx
           shr   esi,8

           mov   edi,gxab
           mov   eax,gyab
           mul   bpl
           add   eax,dword ptr source
           lea   edi,[edi*4+eax]

           push  esi
           mov   esi,gyab

@lp_py_mx: mov   cx,word ptr gxab
           mov   dx,cx
           push  edi

@lp_px_mx:

; Load pixel colors
           mov   eax,es:[edi]
           xor   ebx,ebx
           mov   bh,al
           mov   sum_blue,bx
           mov   bh,ah
           mov   sum_green,bx
           shr   eax,16
           mov   bh,al
           mov   sum_red,bx
           add   edi,4

; Left/Right part
           cmp   word ptr exab,dx
           je    @right_end_mx

           cmp   cx,dx
           jne   @right_mx

           mov   ebx,leftval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
           jmp   @right_end_mx

@right_mx: mov   ebx,rightval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
@right_end_mx:

; Top/Bottom part
           mov   ax,word ptr gyab
           cmp   ax,word ptr eyab
           je    @bottom_end_mx

           cmp   si,word ptr gyab
           jne   @bottom_mx

           mov    ebx,bottomval
           shl    ebx,8
           movd   mm0,ebx
;           movq   mm1,mm0
;           psllq  mm1,16
           por    mm0,mm1
           mov    ax,sum_green
           shl    eax,16
           mov    ax,sum_blue
           movd   mm1,eax
           xor    eax,eax
           pmulhw mm1,mm0

           movd   eax,mm1
;           mov    sum_blue,ax
;           shr    eax,16
;           mov    sum_green,ax

           xor   eax,eax

           mov   ax,sum_blue
           mul   ebx
;           shr   eax,16
;           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,16
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,16
           mov   sum_red,ax


           jmp   @bottom_end_mx

@bottom_mx:mov   ebx,topval

           mov   ax,sum_blue
           mul   ebx
           shr   eax,8
           mov   sum_blue,ax

           mov   ax,sum_green
           mul   ebx
           shr   eax,8
           mov   sum_green,ax

           mov   ax,sum_red
           mul   ebx
           shr   eax,8
           mov   sum_red,ax
@bottom_end_mx:

           mov   ax,sum_blue
           add   val_blue,ax

           mov   ax,sum_green
           add   val_green,ax

           mov   ax,sum_red
           add   val_red,ax

           inc   cx
           cmp   cx,word ptr exab
           jna   @lp_px_mx

           pop   edi
           add   edi,bpl
           inc   esi
           cmp   esi,eyab
           jna   @lp_py_mx

           pop   esi
           mov   ax,0
           mov   al,byte ptr val_red[1]
           shl   eax,16
           mov   ah,byte ptr val_green[1]
           mov   al,byte ptr val_blue[1]
           mov   gs:[esi*4],eax

           inc   esi
           cmp   esi,sx
           jne   @lp_x_mx

           emms
           ret
biscale_32_mmx endp

ends
end
