{$A+,B-,F+,G+,N+,P+,Q-,R-,T-,V+,X+}
{****************************************************************************
 * GX 2 image routines - copyright (c) 1998-2000 by Stefan Goehler          *
 * License agreement in gx2.txt - illegal copy without this file!           *
 * Complete package and new version always available here:                  *
 * http://sourcenet.home.pages.de                                           *
 ****************************************************************************}
{
 Things to improve :
 -alphamapping (15/16 bits) not optimal (only 16 bit aligned)
 -doublesize_32, part x+1;y+1
 -dith4x4_32to1x not optimal (16 bit aligned yet)
 -rgb2bw has got probs with such code:
 uses grafx2,gx_glob,pnglib,crt,gx_image;
 var
  screen : tgrafx;
  image1,image2 : timage;
 begin
  screen.initgfx(640,480,32,mdauto);
  loadpng('images\fade1.png',image1);
  rgb2bw(image1,image2);
  screen.draw(0,0,image1,imdefault);
  readkey;
  screen.close;
 end.
 -buggy clipping of images < 8 bpp - produces GPF
 Procedure shortcuts:
 gen = generic
 cnv = convert
 rle = run lenght encoding
}
{$IFNDEF DPMI}
  !Real mode not supported!
  This unit is fully 32 bit oriented, so forget about real mode.
  You need BP7 to use protected mode. If you have it, please
  switch at compiler/platform to PM (start bp.exe!)
{$ENDIF}
unit gx_image;

interface
uses gx_glob,newfrontier,gx_col;

const
  rle_jump = $00;
  rle_rep  = $40;
  rle_copy = $80;
  rle_pix  = $C0;

  comp_smallest = 3;
  comp_small    = 2;
  comp_fast     = 1;
  comp_fastest  = 0;

  procedure   dr_bnk_gen(x,y : longint;image : timage;flags : longint;var mode : tmode);
  procedure   dr_bnk_cnv(x,y : longint;image : timage;flags : longint;var mode : tmode);
{  procedure   dr_bnk_rle(x,y : longint;image : timage;flags : longint;var mode : tmode);}
  procedure   dr_lin_gen(x,y : longint;image : timage;flags : longint;var mode : tmode);
  procedure   dr_lin_cnv(x,y : longint;image : timage;flags : longint;var mode : tmode);
{  procedure   dr_lin_rle(x,y : longint;image : timage;flags : longint;var mode : tmode);}

  procedure   gt_bnk_gen(x1,y1,x2,y2 : longint;image : timage;var mode : tmode);
  procedure   gt_lin_gen(x1,y1,x2,y2 : longint;image : timage;var mode : tmode);

  procedure   scale_bnk_gen(image : timage;px,py,sx,sy,flags : longint;var mode : tmode);
  procedure   scale_lin_gen(image : timage;px,py,sx,sy,flags : longint;var mode : tmode);

  { Linked procedures - don't touch them if you have no clue about them! }
  procedure   add_15(source,dest : pointer48;count : longint);
  procedure   add_16(source,dest : pointer48;count : longint);
  procedure   add_24_386(source,dest : pointer48;count : longint);
  procedure   add_32_386(source,dest : pointer48;count : longint);
  procedure   add_32_mmx(source,dest : pointer48;count : longint);
  procedure   sub_15(source,dest : pointer48;count : longint);
  procedure   sub_16(source,dest : pointer48;count : longint);
  procedure   sub_24_386(source,dest : pointer48;count : longint);
  procedure   sub_32_386(source,dest : pointer48;count : longint);
  procedure   sub_32_mmx(source,dest : pointer48;count : longint);
  procedure   sprite_8(source,dest : pointer48;count,key,sbpl,dpbl,ylines : longint);
  procedure   sprite_1516(source,dest : pointer48;count,key,sbpl,dpbl,ylines : longint);
  procedure   sprite_24(source,dest : pointer48;count,key,sbpl,dpbl,ylines : longint);
  procedure   sprite_32(source,dest : pointer48;count,key,sbpl,dpbl,ylines : longint);
  procedure   spritemem_8_mmx(source,dest : pointer48;count,key,sbpl,dpbl,ylines : longint);
  procedure   spritemem_1516_mmx(source,dest : pointer48;count,key,sbpl,dpbl,ylines : longint);
  procedure   spritemem_32_mmx(source,dest : pointer48;count,key,sbpl,dpbl,ylines : longint);
  procedure   alpha_merge(source,channel : pointer48;count : longint);
  procedure   alpha_15_386(source,dest : pointer48;count : longint);
  procedure   alpha_16_386(source,dest : pointer48;count : longint);
  procedure   alpha_24_386(source,dest : pointer48;count : longint);
  procedure   alpha_32_386(source,dest : pointer48;count : longint);
  procedure   alpha_32_mmx(source,dest : pointer48;count : longint);
  procedure   blend_24_fast(source1,source2,dest,table : pointer48;count : longint);
  procedure   blend_32_fast(source1,source2,dest,table : pointer48;count : longint);
  procedure   blend_32_386(source1,source2,dest : pointer48;count : longint;cover : byte);
  procedure   blend_24_386(source1,source2,dest : pointer48;count : longint;cover : byte);
  procedure   blend_32_mmx(source1,source2,dest : pointer48;count : longint;cover : byte);
  procedure   rle_8(source,dest : pointer48;sizex : word);
  procedure   rle_1516(source,dest : pointer48;sizex : word);
  procedure   rle_32(source,dest : pointer48;sizex : word);
  procedure   scale_8(source,dest : pointer48;count,wx: longint);
  procedure   scale_1516(source,dest : pointer48;count,wx: longint);
  procedure   scale_24(source,dest : pointer48;count,wx: longint);
  procedure   scale_32(source,dest : pointer48;count,wx: longint);
  procedure   biscale_15(source,dest : pointer48;sx,bpl,topval,bottomval,fx,gyab,eyab : longint);
  procedure   biscale_16(source,dest : pointer48;sx,bpl,topval,bottomval,fx,gyab,eyab : longint);
  procedure   biscale_24(source,dest : pointer48;sx,bpl,topval,bottomval,fx,gyab,eyab : longint);
  procedure   biscale_32(source,dest : pointer48;sx,bpl,topval,bottomval,fx,gyab,eyab : longint);
  procedure   biscaledown_15(source,dest : pointer48;sx,bpl,topval,bottomval,fx,fxy,gyab,eyab : longint);
  procedure   biscaledown_16(source,dest : pointer48;sx,bpl,topval,bottomval,fx,fxy,gyab,eyab : longint);
  procedure   biscaledown_24(source,dest : pointer48;sx,bpl,topval,bottomval,fx,fxy,gyab,eyab : longint);
  procedure   biscaledown_32(source,dest : pointer48;sx,bpl,topval,bottomval,fx,fxy,gyab,eyab : longint);
  procedure   biscale_32_mmx(source,dest : pointer48;sx,bpl,topval,bottomval,fx,gyab,eyab : longint);

  procedure   doublesize_24_386(source,dest : pointer48;count,bpl : longint);
  procedure   doublesize_32_386(source,dest : pointer48;count,bpl : longint);
  procedure   doublesize_32_mmx(source,dest : pointer48;count,bpl : longint);
  procedure   halfsize_24_386(source,dest : pointer48;count,bpl : longint);
  procedure   halfsize_32_386(source,dest : pointer48;count,bpl : longint);
  procedure   halfsize_32_mmx(source,dest : pointer48;count,bpl : longint);
const
  add_24 : procedure(source,dest : pointer48;count : longint) = add_24_386;
  sub_24 : procedure(source,dest : pointer48;count : longint) = sub_24_386;
  add_32 : procedure(source,dest : pointer48;count : longint) = add_32_386;
  sub_32 : procedure(source,dest : pointer48;count : longint) = sub_32_386;
  alpha_15 : procedure(source,dest : pointer48;count : longint) = alpha_15_386;
  alpha_16 : procedure(source,dest : pointer48;count : longint) = alpha_16_386;
  alpha_24 : procedure(source,dest : pointer48;count : longint) = alpha_24_386;
  alpha_32 : procedure(source,dest : pointer48;count : longint) = alpha_32_386;
  blend_32         : procedure(source1,source2,dest : pointer48;count : longint;cover : byte) = blend_32_386;
  doublesize_24 : procedure(source,dest : pointer48;count,bpl : longint) = doublesize_24_386;
  doublesize_32 : procedure(source,dest : pointer48;count,bpl : longint) = doublesize_32_386;
  halfsize_24   : procedure(source,dest : pointer48;count,bpl : longint) = halfsize_24_386;
  halfsize_32   : procedure(source,dest : pointer48;count,bpl : longint) = halfsize_32_386;
  spritemem_8    : procedure(source,dest : pointer48;count,key,sbpl,dpbl,ylines : longint) = sprite_8;
  spritemem_1516 : procedure(source,dest : pointer48;count,key,sbpl,dpbl,ylines : longint) = sprite_1516;
  spritemem_32   : procedure(source,dest : pointer48;count,key,sbpl,dpbl,ylines : longint) = sprite_32;

{  function    compressimage(var image : timage;comptype : word) : word;}
  function    alphamerge(var image : timage;channel : timage) : word;
  function    checkvalid_size(var image : timage;sizex,sizey : integer) : boolean;
  function    prepareimage_cnv(var image : timage;sizex,sizey,bpp,gbpp,numofimages,flags,cnvmode : longint) : pcnvproc;

implementation
uses grafx2;

{$L GX_IMAGE}
procedure sprite_8;external;
procedure sprite_1516;external;
procedure sprite_24;external;
procedure sprite_32;external;
procedure spritemem_8_mmx;external;
procedure spritemem_1516_mmx;external;
procedure spritemem_32_mmx;external;
procedure add_15;external;
procedure add_16;external;
procedure add_24_386;external;
procedure add_32_386;external;
procedure add_32_mmx;external;
procedure sub_15;external;
procedure sub_16;external;
procedure sub_24_386;external;
procedure sub_32_386;external;
procedure sub_32_mmx;external;
procedure alpha_merge;external;
procedure alpha_15_386;external;
procedure alpha_16_386;external;
procedure alpha_24_386;external;
procedure alpha_32_386;external;
procedure alpha_32_mmx;external;
procedure blend_24_fast;external;
procedure blend_32_fast;external;
procedure blend_24_386;external;
procedure blend_32_386;external;
procedure blend_32_mmx;external;
procedure rle_8;external;
procedure rle_1516;external;
procedure rle_32;external;
procedure scale_8;external;
procedure scale_1516;external;
procedure scale_24;external;
procedure scale_32;external;
procedure biscale_15;external;
procedure biscale_16;external;
procedure biscale_24;external;
procedure biscale_32;external;
procedure biscaledown_15;external;
procedure biscaledown_16;external;
procedure biscaledown_24;external;
procedure biscaledown_32;external;
procedure biscale_32_mmx;external;
{$L GX_INTPL}
procedure doublesize_24_386;external;
procedure doublesize_32_386;external;
procedure doublesize_32_mmx;external;
procedure halfsize_24_386;external;
procedure halfsize_32_386;external;
procedure halfsize_32_mmx;external;

var
  movesprite : procedure(source,dest : pointer48;count,key,sbpl,dpbl,ylines : longint);


procedure dr_bnk_gen(x,y : longint;image : timage;flags : longint;var mode : tmode);
var
  sizey,i,mempos,overlap,putmaxx : word;
  imgpos                         : longint;
  x2,y2                          : integer;
  draw                           : procedure(input,output : pointer48;count : longint);
begin
  sizey := image.sizey;
  inc(x,mode.actviewport.x1);
  inc(y,mode.actviewport.y1);
  x2     := x+image.sizex-1;
  y2     := y+image.sizey-1;
  imgpos := image.imagestart;

  if (y > mode.actviewport.y2) or (y2 < mode.actviewport.y1) then exit;
  if (x > mode.actviewport.x2) or (x2 < mode.actviewport.x1) then exit;
  if x  < mode.actviewport.x1 then begin
    inc(imgpos,(mode.actviewport.x1-x)*image.pixel);
    x := mode.actviewport.x1;
  end;
  if x2 > mode.actviewport.x2 then x2 := mode.actviewport.x2;
  if y  < mode.actviewport.y1 then begin
    inc(imgpos,image.bpl*(mode.actviewport.y1-y));
    y := mode.actviewport.y1;
  end;
  if y2 > mode.actviewport.y2 then y2 := mode.actviewport.y2;

  putmaxx := succ(x2-x)*mode.pixel;
  if putmaxx = 0 then exit;
  mempos  := mode.calcofs(x,y+mode.pageadd,mode);
  if (image.flags and imsprite = 0) then begin
    case flags and (drand+drxor+dror) of
      drdefault : draw := move2screen;
      drxor     : draw := xor2screen;
      drand     : draw := and2screen;
      dror      : draw := or2screen;
      else exit;
    end;
    for i := y to y2 do begin
      if mempos < mempos+putmaxx then begin
        draw(ptr48(image.data,imgpos),ptr48(mode.writeptr,mempos),putmaxx);
        asm
          les   di,mode
          mov   ax,es:[di].tmode.bpl.word
          add   mempos,ax
          jnc   @next
            call   incbank
          @next:
        end;
      end else begin
        overlap := -mempos;
        draw(ptr48(image.data,imgpos),ptr48(mode.writeptr,mempos),overlap);
        incbank;
        draw(ptr48(image.data,imgpos+overlap),ptr48(mode.writeptr,0),putmaxx-overlap);
        inc(mempos,mode.bpl);
      end;
      inc(imgpos,image.bpl);
    end;
  end else begin
    if image.bpp <> mode.bpp then exit;
    case mode.bpp of
      8      : movesprite := sprite_8;
      15,16  : movesprite := sprite_1516;
      24     : movesprite := sprite_24;
      32     : movesprite := sprite_32;
      else exit;
    end;
    for i := y to y2 do begin
      if mempos < mempos+putmaxx then begin
        movesprite(ptr48(image.data,imgpos),ptr48(mode.writeptr,mempos),putmaxx,image.transcol,0,0,1);
        asm
          les   di,mode
          mov   ax,es:[di].tmode.bpl.word
          add   mempos,ax
          jnc   @next
            call   incbank
          @next:
        end;
      end else begin
        overlap := -mempos;
        movesprite(ptr48(image.data,imgpos),ptr48(mode.writeptr,mempos),overlap,image.transcol,0,0,1);
        incbank;
        movesprite(ptr48(image.data,imgpos+overlap),ptr48(mode.writeptr,0),putmaxx-overlap,image.transcol,0,0,1);
        inc(mempos,mode.bpl);
      end;
      inc(imgpos,image.bpl);
    end;
  end;
end;

procedure dr_bnk_cnv(x,y : longint;image : timage;flags : longint;var mode : tmode);
var
  sizey,i,mempos,overlap,putmaxx,datax : word;
  imgpos                               : longint;
  x2,y2                                : integer;
  convertdata                          : tcnvproc;
  cnvtmp                               : pcnvproc;
begin
  if (flags and (drsub or dradd) <> 0) then begin
    if image.bpp <> mode.bpp then exit;
    if (flags and dradd <> 0) then
    case mode.bpp of
      15 : cnvtmp := @add_15;
      16 : cnvtmp := @add_16;
      24 : cnvtmp := @add_24;
      32 : cnvtmp := @add_32;
      else exit;
    end
    else case mode.bpp of
      15 : cnvtmp := @sub_15;
      16 : cnvtmp := @sub_16;
      24 : cnvtmp := @sub_24;
      32 : cnvtmp := @sub_32;
      else exit;
    end;
  end else if (image.flags and imalpha <> 0) then begin
    case mode.bpp of
      15 : cnvtmp := @alpha_15;
      16 : cnvtmp := @alpha_16;
      32 : cnvtmp := @alpha_32;
      else exit;
    end;
  end else begin
    cnvtmp := getcnvproc(image.bpp,mode.bpp,cnvdrwmd+(flags and drdither));
    if cnvtmp = nil then exit;
  end;
  convertdata := tcnvproc(cnvtmp);
  if image.bpp <= 8 then begin
    if (image.flags and impalette <> 0) then if
    mode.bpp >= 24 then cnvpal := ptr48(image.data,image.palstart)
    else begin
      if mode.bpp = 16 then
       pal_32to16(ptr48(image.data,image.palstart),gfxbufptr,word(1) shl image.bpp)
       else
       pal_32to15(ptr48(image.data,image.palstart),gfxbufptr,word(1) shl image.bpp);
      cnvpal := gfxbufptr;
    end;
  end;
  sizey := image.sizey;
  inc(x,mode.actviewport.x1);
  inc(y,mode.actviewport.y1);
  x2     := x+image.sizex-1;
  y2     := y+image.sizey-1;
  imgpos := image.imagestart;

  if (y > mode.actviewport.y2) or (y2 < mode.actviewport.y1) then exit;
  if (x > mode.actviewport.x2) or (x2 < mode.actviewport.x1) then exit;
  if x  < mode.actviewport.x1 then begin
    inc(imgpos,(mode.actviewport.x1-x)*image.pixel);
    x := mode.actviewport.x1;
  end;
  if x2 > mode.actviewport.x2 then x2 := mode.actviewport.x2;
  if y  < mode.actviewport.y1 then begin
    inc(imgpos,image.bpl*(mode.actviewport.y1-y));
    y := mode.actviewport.y1;
  end;
  if y2 > mode.actviewport.y2 then y2 := mode.actviewport.y2;

  putmaxx := succ(x2-x)*mode.pixel;
  if putmaxx = 0 then exit;
  datax   := succ(x2-x)*image.pixel;

  mempos   := mode.calcofs(x,y+mode.pageadd,mode);
  cnvxpos := x;
  for i := y to y2 do begin
    cnvypos := i;
    if mempos < mempos+putmaxx then begin
      convertdata(ptr48(image.data,imgpos),ptr48(mode.writeptr,mempos),datax);
      asm
        les   di,mode
        mov   ax,es:[di].tmode.bpl.word
        add   mempos,ax
        jnc   @next
          call   incbank
        @next:
      end;
    end else begin
      overlap := ((0-mempos)*image.pixel) div mode.pixel;
      if overlap > 0 then
      convertdata(ptr48(image.data,imgpos),ptr48(mode.writeptr,mempos),overlap);
      incbank;
      cnvxpos := x+(datax-overlap) div mode.pixel;
      if datax-overlap > 0 then
      convertdata(ptr48(image.data,imgpos+overlap),ptr48(mode.writeptr,0),datax-overlap);
      inc(mempos,mode.bpl);
      cnvxpos := x;
    end;
    inc(imgpos,image.bpl);
  end;
end;

procedure dr_bnk_rle(x,y : integer;image : timage;flags : longint;var mode : tmode);
var
  i,putmaxx     : word;
  imgpos,scrpos : longint;
  x2,y2         : integer;
  derle         : procedure(source,dest : pointer48;sizex : word);
begin
  case image.bpp of
    8     : derle := rle_8;
    15,16 : derle := rle_1516;
    32    : derle := rle_32;
    else exit;
  end;
  inc(x,mode.actviewport.x1);
  inc(y,mode.actviewport.y1);
  x2     := x+image.sizex-1;
  y2     := y+image.sizey-1;
  imgpos := image.imagestart;

{  if (y > mode.actviewport.y2) or (y2 < mode.actviewport.y1) then exit;
  if (x > mode.actviewport.x2) or (x2 < mode.actviewport.x1) then exit;
  if x  < mode.actviewport.x1 then begin
    inc(imgpos,(mode.actviewport.x1-x)*image.pixel);
    x := mode.actviewport.x1;
  end;
  if x2 > mode.actviewport.x2 then x2 := mode.actviewport.x2;
  if y  < mode.actviewport.y1 then begin
    inc(imgpos,image.bpl*(mode.actviewport.y1-y));
    y := mode.actviewport.y1;
  end;
  if y2 > mode.actviewport.y2 then y2 := mode.actviewport.y2;}

  putmaxx := succ(x2-x);
  if putmaxx = 0 then exit;
  scrpos  := mode.calcofs(x,y+mode.pageadd,mode);
  if image.flags and imsprite = 0 then
  for i := y to y2 do begin
    derle(ptr48(image.data,imgpos),gfxbufptr,putmaxx);
    move2screen(gfxbufptr,ptr48(mode.writeptr,scrpos),putmaxx*2);
    inc(imgpos,readmem32w(ptr48(image.data,imgpos)));
    inc(scrpos,mode.bpl);
  end else
  for i := y to y2 do begin
    derle(ptr48(image.data,imgpos),ptr48(mode.writeptr,scrpos),putmaxx);
    inc(imgpos,readmem32w(ptr48(image.data,imgpos)));
    inc(scrpos,mode.bpl);
  end;
end;

procedure dr_lin_gen(x,y : longint;image : timage;flags : longint;var mode : tmode);
var
  i,putmaxx     : word;
  imgptr,scrptr : pointer48;
  x2,y2         : longint;
  draw          : procedure(input,output : pointer48;count : longint);
begin
  inc(x,mode.actviewport.x1);
  inc(y,mode.actviewport.y1);
  x2     := x+image.sizex-1;
  y2     := y+image.sizey-1;
  imgptr := ptr48(image.data,image.imagestart);

  if (y > mode.actviewport.y2) or (y2 < mode.actviewport.y1) then exit;
  if (x > mode.actviewport.x2) or (x2 < mode.actviewport.x1) then exit;
  if x  < mode.actviewport.x1 then begin
    inc(tselofs32(imgptr).offset32,(mode.actviewport.x1-x)*image.pixel);
    x := mode.actviewport.x1;
  end;
  if x2 > mode.actviewport.x2 then x2 := mode.actviewport.x2;
  if y  < mode.actviewport.y1 then begin
    inc(tselofs32(imgptr).offset32,image.bpl*(mode.actviewport.y1-y));
    y := mode.actviewport.y1;
  end;
  if y2 > mode.actviewport.y2 then y2 := mode.actviewport.y2;

  putmaxx := succ(x2-x)*mode.pixel;
  if putmaxx = 0 then exit;
  scrptr  := ptr48(mode.writeptr,mode.calcofs(x,y,mode)+mode.displayofs);
  if (image.flags and imsprite = 0) then begin
    case flags and (drand+drxor+dror) of
      drdefault : begin
                    movemul2screen(imgptr,scrptr,putmaxx,image.bpl,mode.bpl,
                                   y2-y+1);
                    exit;
                  end;
      drxor     : draw := xor2screen;
      drand     : draw := and2screen;
      dror      : draw := or2screen;
      else exit;
    end;
    for i := y to y2 do begin
      draw(imgptr,scrptr,putmaxx);
      inc(tselofs32(imgptr).offset32,image.bpl);
      inc(tselofs32(scrptr).offset32,mode.bpl);
    end;
  end else begin
    if image.bpp <> mode.bpp then exit;
    if (mode.device and dvmemory <> 0) then
    case mode.bpp of
      8      : movesprite := spritemem_8;
      15,16  : movesprite := spritemem_1516;
      24     : movesprite := sprite_24;
      32     : movesprite := spritemem_32;
      else exit;
    end else
    case mode.bpp of
      8      : movesprite := sprite_8;
      15,16  : movesprite := sprite_1516;
      24     : movesprite := sprite_24;
      32     : movesprite := sprite_32;
      else exit;
    end;
{    for i := y to y2 do begin
      movesprite(imgptr,scrptr,putmaxx,image.transcol,0,0,1);
      inc(tselofs32(imgptr).offset32,image.bpl);
      inc(tselofs32(scrptr).offset32,mode.bpl);
    end;}
    movesprite(imgptr,scrptr,putmaxx,image.transcol,image.bpl,mode.bpl,y2-y+1);
  end;
end;

procedure dr_lin_cnv(x,y : longint;image : timage;flags : longint;var mode : tmode);
var
  i,putmaxx     : word;
  imgpos,scrpos : longint;
  x2,y2         : integer;
  convertdata   : tcnvproc;
  cnvtmp        : pcnvproc;
begin
  if (flags and (drsub or dradd) <> 0) then begin
    if image.bpp <> mode.bpp then exit;
    if (flags and dradd <> 0) then
    case mode.bpp of
      15 : cnvtmp := @add_15;
      16 : cnvtmp := @add_16;
      24 : cnvtmp := @add_24;
      32 : cnvtmp := @add_32;
      else exit;
    end
    else case mode.bpp of
      15 : cnvtmp := @sub_15;
      16 : cnvtmp := @sub_16;
      24 : cnvtmp := @sub_24;
      32 : cnvtmp := @sub_32;
      else exit;
    end;
  end else if (image.flags and imalpha <> 0) then begin
    case mode.bpp of
      15 : cnvtmp := @alpha_15;
      16 : cnvtmp := @alpha_16;
      24 : cnvtmp := @alpha_24;
      32 : cnvtmp := @alpha_32;
      else exit;
    end;
  end else begin
    cnvtmp := getcnvproc(image.bpp,mode.bpp,cnvdrwmd+(flags and drdither));
    if cnvtmp = nil then exit;
  end;
  convertdata := tcnvproc(cnvtmp);
  if image.bpp <= 8 then begin
    if (image.flags and impalette <> 0) then if
    mode.bpp >= 24 then cnvpal := ptr48(image.data,image.palstart)
    else begin
      if mode.bpp = 16 then
       pal_32to16(ptr48(image.data,image.palstart),gfxbufptr,word(1) shl image.bpp)
       else
       pal_32to15(ptr48(image.data,image.palstart),gfxbufptr,word(1) shl image.bpp);
      cnvpal := gfxbufptr;
    end;
  end;
  inc(x,mode.actviewport.x1);
  inc(y,mode.actviewport.y1);
  x2     := x+image.sizex-1;
  y2     := y+image.sizey-1;
  imgpos := image.imagestart;

  if (y > mode.actviewport.y2) or (y2 < mode.actviewport.y1) then exit;
  if (x > mode.actviewport.x2) or (x2 < mode.actviewport.x1) then exit;
  if x  < mode.actviewport.x1 then begin
    inc(imgpos,(mode.actviewport.x1-x)*image.pixel);
    x := mode.actviewport.x1;
  end;
  if x2 > mode.actviewport.x2 then x2 := mode.actviewport.x2;
  if y  < mode.actviewport.y1 then begin
    inc(imgpos,image.bpl*(mode.actviewport.y1-y));
    y := mode.actviewport.y1;
  end;
  if y2 > mode.actviewport.y2 then y2 := mode.actviewport.y2;

  putmaxx := succ(x2-x)*image.pixel;
  if putmaxx = 0 then exit;
  scrpos  := mode.calcofs(x,y,mode)+mode.displayofs;
  cnvxpos := x;
  for i := y to y2 do begin
    cnvypos := i;
    convertdata(ptr48(image.data,imgpos),ptr48(mode.writeptr,scrpos),putmaxx);
    inc(imgpos,image.bpl);
    inc(scrpos,mode.bpl);
  end;
end;

procedure dr_lin_rle(x,y : longint;image : timage;flags : longint;var mode : tmode);
var
  i,putmaxx     : word;
  imgpos,scrpos : longint;
  x2,y2         : integer;
  derle         : procedure(source,dest : pointer48;sizex : word);
begin
  case image.bpp of
    8     : derle := rle_8;
    15,16 : derle := rle_1516;
    32    : derle := rle_32;
    else exit;
  end;
  inc(x,mode.actviewport.x1);
  inc(y,mode.actviewport.y1);
  x2     := x+image.sizex-1;
  y2     := y+image.sizey-1;
  imgpos := image.imagestart;

{  if (y > mode.actviewport.y2) or (y2 < mode.actviewport.y1) then exit;
  if (x > mode.actviewport.x2) or (x2 < mode.actviewport.x1) then exit;
  if x  < mode.actviewport.x1 then begin
    inc(imgpos,(mode.actviewport.x1-x)*image.pixel);
    x := mode.actviewport.x1;
  end;
  if x2 > mode.actviewport.x2 then x2 := mode.actviewport.x2;
  if y  < mode.actviewport.y1 then begin
    inc(imgpos,image.bpl*(mode.actviewport.y1-y));
    y := mode.actviewport.y1;
  end;
  if y2 > mode.actviewport.y2 then y2 := mode.actviewport.y2;}

  putmaxx := succ(x2-x);
  if putmaxx = 0 then exit;
  scrpos  := mode.calcofs(x,y,mode)+mode.displayofs;
  if image.flags and imsprite = 0 then
  for i := y to y2 do begin
    derle(ptr48(image.data,imgpos),gfxbufptr,putmaxx);
    move2screen(gfxbufptr,ptr48(mode.writeptr,scrpos),putmaxx*2);
    inc(imgpos,readmem32w(ptr48(image.data,imgpos)));
    inc(scrpos,mode.bpl);
  end else
  for i := y to y2 do begin
    derle(ptr48(image.data,imgpos),ptr48(mode.writeptr,scrpos),putmaxx);
    inc(imgpos,readmem32w(ptr48(image.data,imgpos)));
    inc(scrpos,mode.bpl);
  end;
end;

procedure gt_bnk_gen(x1,y1,x2,y2 : longint;image : timage;var mode : tmode);
var
  sizex,sizey,i,i2,i3,oli2,getmaxx : word;
  imgpos                           : longint;
  switched                         : boolean;
  moveblock : procedure(input,output : pointer48;count : longint);
begin
  if y1 > y2 then swapint(y1,y2);
  if x1 > x2 then swapint(x1,x2);

  sizex := x2-x1+1;
  sizey := y2-y1;
  inc(x1,mode.actviewport.x1);
  inc(y1,mode.actviewport.y1);
  inc(x2,mode.actviewport.x1);
  inc(y2,mode.actviewport.y1);
  imgpos := 0;

  if (y1 > mode.actviewport.y2)or(y2 < mode.actviewport.y1) then exit;
  if (x1 > mode.actviewport.x2)or(x2 < mode.actviewport.x1) then exit;
  if x1 < mode.actviewport.x1 then begin
    inc(imgpos,mode.actviewport.x1-x1);
    x1      := mode.actviewport.x1;
  end;
  if x2 > mode.actviewport.x2 then x2 := mode.actviewport.x2;
  if y1 < mode.actviewport.y1 then begin
    inc(imgpos,sizex*(mode.actviewport.y1-y1));
    y1 := mode.actviewport.y1;
  end;
  if y2 > mode.actviewport.y2 then y2 := mode.actviewport.y2;

  getmaxx := (x2-x1+1)*mode.pixel;
  if getmaxx = 0 then exit;
  sizey := y2-y1;
  i2 := mode.calcofs(x1,y1+mode.pageadd,mode);
  imgpos := imgpos*mode.pixel+image.imagestart;

  sizex := sizex*mode.pixel;
  if sizex < 128 then moveblock := movefromscreen_386 else
   moveblock := movefromscreen;

  oli2 := i2;
  switched := false;
  for i := y1 to y1+sizey do begin
    if i2 < i2+getmaxx then begin
      if (oli2 > i2)and(not switched) then incbank;
      moveblock(ptr48(mode.readptr,i2),ptr48(image.data,imgpos),getmaxx);
      switched := false;
    end
    else begin
      i3 := 0-i2;
      moveblock(ptr48(mode.readptr,i2),ptr48(image.data,imgpos),i3);
      incbank;
      switched := true;
      moveblock(ptr48(mode.readptr,0),ptr48(image.data,imgpos+i3),getmaxx-i3);
    end;
    inc(imgpos,image.bpl);
    oli2 := i2;
    inc(i2,mode.bpl);
  end;
end;

procedure gt_lin_gen(x1,y1,x2,y2 : longint;image : timage;var mode : tmode);
var
  sizex,sizey,i,i3,getmaxx : word;
  imgptr,scrptr            : pointer48;
  moveblock                : procedure(input,output : pointer48;count : longint);
begin
  if y1 > y2 then swapint(y1,y2);
  if x1 > x2 then swapint(x1,x2);

  sizex := x2-x1+1;
  sizey := y2-y1;
  inc(x1,mode.actviewport.x1);
  inc(y1,mode.actviewport.y1);
  inc(x2,mode.actviewport.x1);
  inc(y2,mode.actviewport.y1);
  imgptr := ptr48(image.data,image.imagestart);

  if (y1 > mode.actviewport.y2)or(y2 < mode.actviewport.y1) then exit;
  if (x1 > mode.actviewport.x2)or(x2 < mode.actviewport.x1) then exit;
  if x1 < mode.actviewport.x1 then begin
    inc(tselofs32(imgptr).offset32,(mode.actviewport.x1-x1)*mode.pixel);
    x1      := mode.actviewport.x1;
  end;
  if x2 > mode.actviewport.x2 then x2 := mode.actviewport.x2;
  if y1 < mode.actviewport.y1 then begin
    inc(tselofs32(imgptr).offset32,(sizex*(mode.actviewport.y1-y1))*mode.pixel);
    y1 := mode.actviewport.y1;
  end;
  if y2 > mode.actviewport.y2 then y2 := mode.actviewport.y2;

  getmaxx := (x2-x1+1)*mode.pixel;
  if getmaxx = 0 then exit;
  sizey := y2-y1;
  scrptr := ptr48(mode.writeptr,mode.calcofs(x1,y1,mode)+mode.displayofs);

  sizex := sizex*mode.pixel;
  if sizex < 128 then moveblock := movefromscreen_386 else
   moveblock := movefromscreen;
  for i := y1 to y1+sizey do begin
    moveblock(scrptr,imgptr,getmaxx);
    inc(tselofs32(imgptr).offset32,image.bpl);
    inc(tselofs32(scrptr).offset32,mode.bpl);
  end;
end;

function compressimage(var image : timage;comptype : word) : word;
{ Experimental }
var
  x,y,i,j       : word;
  wc            : word;
  dest          : timage;
  imgpos,dstpos : longint;
  value         : word;
begin
  case comptype of
    comp_smallest : value := 2;
    comp_small    : value := 3;
    comp_fast     : value := 4;
    comp_fastest  : value := 5;
    else value := 4;
  end;
  if image.bpp <> 16 then begin
    compressimage := errfalsebpp;
    exit;
  end;
  if image.flags and imalpha <> 0 then begin
    compressimage := errfalseformat;
    exit;
  end;
  if maxavail32 < (image.size+image.size shr 1) then begin
    compressimage := errnomem;
    exit;
  end;
  dest := image;
  dest.size := image.size+image.size shr 1;
  getmem32(dest.data,dest.size);
  if image.imagestart > 0 then
    move2(ptr48(image.data,0),ptr48(dest.data,0),image.imagestart);

  imgpos := image.imagestart;
  dstpos := imgpos;

  for y := 0 to image.sizey-1 do begin
    x  := 0;
    wc := 2;
    while x < image.sizex do
    begin
      i := 0;
      while (x+i < image.sizex)and
            (readmem32w(ptr48(image.data,imgpos+((x+i) shl 1))) =
             readmem32w(ptr48(image.data,imgpos+((x+i+1) shl 1))))
             and(i < 63) do inc(i);
      if i > 0 then
      begin
        writemem32b(ptr48(dest.data,dstpos+wc),i or rle_rep);
        writemem32w(ptr48(dest.data,dstpos+wc+1),
        readmem32w(ptr48(image.data,imgpos+(x shl 1))));
        inc(x,i);
        inc(wc,3);
      end
      else begin
        i := 0;
        while (x+i < image.sizex)and(i < 63) do begin
          j := 0;
          if readmem32w(ptr48(image.data,imgpos+(x+i) shl 1))
          <> readmem32w(ptr48(image.data,imgpos+(x+i+1) shl 1)) then
          inc(i)
          else while (x+i+j < image.sizex)and
                     (readmem32w(ptr48(image.data,imgpos+(x+i+j) shl 1)) =
                      readmem32w(ptr48(image.data,imgpos+(x+i+j+1) shl 1)))and
                     (j < value)and(i+j < 63) do inc(j);
          if j >= value then break else inc(i,j);
        end;
        if (i > 0) then begin
          writemem32b(ptr48(dest.data,dstpos+wc),i or rle_copy);
          move2(ptr48(image.data,imgpos+x shl 1),
                ptr48(dest.data,dstpos+wc+1),i shl 1);
          inc(x,i);
          inc(wc,i shl 1+1);
        end;
      end;
    end;
    {Write linecount}
    writemem32w(ptr48(dest.data,dstpos),wc);
    inc(imgpos,image.bpl);
    inc(dstpos,wc);
  end;
  dstpos := dstpos and not 3+8;
  freemem32(image.data);
  dest.size  := dstpos;
  dest.flags := dest.flags or imrle;
  image      := dest;
  getmem32(image.data,image.size);
  move2(ptr48(dest.data,0),ptr48(image.data,0),image.size);
  compressimage := errnoerror;
  freemem32(dest.data);
end;

function alphamerge(var image : timage;channel : timage) : word;
{ Merges a 32 bpp image and an 8 bit alphachannel into the 32 bpp
  image. Sets the 32 bpp image to an image with alphachannel.     }
var
  i,y             : integer;
  img1pos,img2pos : longint;
begin
  alphamerge := errfalsebpp;
  if (image.bpp <> 32)or(channel.bpp <> 8) then exit;
  alphamerge := errempty;
  if (image.data = 0)or(channel.data = 0) then exit;
  alphamerge := errwrongsize;
  if (image.sizex <> channel.sizex)or
     (image.sizey <> channel.sizey) then exit;
  img1pos := image.imagestart;
  img2pos := channel.imagestart;
  for y := 0 to image.sizey-1 do begin
    alpha_merge(ptr48(image.data,img1pos),
                ptr48(channel.data,img2pos),
                image.sizex);
    inc(img1pos,image.bpl);
    inc(img2pos,channel.bpl);
  end;
  image.flags := image.flags or imalpha;
  alphamerge := errnoerror;
end;

function checkvalid_size(var image : timage;sizex,sizey : integer) : boolean;
{ Returns true if image is valid and has the same sizex:sizey }
begin
  checkvalid_size := false;
  if (image.id <> idimage)or(image.data = 0) then exit;
  if (image.sizex < sizex)or(image.sizey < sizey) then exit;
  if (image.flags and (imrle or immulti) <> 0) then exit;
  checkvalid_size := true;
end;

function prepareimage_cnv(var image : timage;sizex,sizey,bpp,gbpp,numofimages,flags,cnvmode : longint) : pcnvproc;
{ For imageloaders - checks sizex:sizey, if imagesize <> sourcesize, then
  it opens a new image. Sets conversion procedure.
  Flags: see ldXXXX constants in gx_glob                                  }
var
  err,usebpp : word;
label
  noreopen;

begin
  prepareimage_cnv := nil;
  if (image.sizex <> sizex)or(image.sizey <> sizey)or
     (image.id <> idimage)or(image.data = 0)or
     ((image.bpp <= 8)and(image.flags or impalette = 0)) then
  begin
    if (flags and ldauto <> 0) then begin
      usebpp := bpp;
      if ((bpp <= 8)and(image.flags or impalette = 0)) then else
      if (image.id = idimage)and(image.data <> 0)and(image.bpp = bpp)and
      (image.sizex = sizex)and(image.sizey = sizey) then
      goto noreopen;
    end else if (flags and ldalpha <> 0) then begin
      if (flags and ldhasalpha <> 0) then usebpp := 32 else
       usebpp := gbpp;
      if ((usebpp <= 8)and(image.flags or impalette = 0)) then else
      if (image.id = idimage)and(image.data <> 0)and(image.bpp = usebpp)and
      (image.sizex = sizex)and(image.sizey = sizey) then
      goto noreopen;
    end else begin { lddefault }
      usebpp := gbpp;
      if ((gbpp <= 8)and(image.flags or impalette = 0)) then else
      if (image.id = idimage)and(image.data <> 0)and(image.bpp = gbpp)and
      (image.sizex = sizex)and(image.sizey = sizey) then
      goto noreopen;
    end;
    if openimage(image,sizex,sizey,usebpp,numofimages,impalette or (flags and imallpal)) <> errnoerror then exit;
    cnvpal := ptr48(image.data,image.palstart);
  end;
  noreopen:
  if (usebpp > 8)and(bpp = 8)or(image.bpp = 8)and
  (image.flags and impalette = 0) then cnvpal := gfxbufptr;
  prepareimage_cnv := getcnvproc(bpp,image.bpp,cnvmode+(flags and lddither));
end;

(*function copy_image(source,dest : timage) : word;
{ Copies one image into another. Both images need to have the same
  size, bpp is not relevant.                                       }
var
  y    : integer;
  err  : word;
begin
  copy_image := errgenerror;
  if not checkvalid_size(dest,source.sizex,source.sizey) then exit;
  copy_image := errfalsebpp;
  err := setconvert(source.bpp,dest.bpp);
  if err <> errnoerror then begin
    copy_image := err;
    exit;
  end;
  if source.bpp <= 8 then begin
     cnvpal := ptr48(gfxbuf,0);
     case dest.bpp of
       32,24 : cnvpal := ptr48(source.data,source.palstart);
       16    : pal_32to16(ptr48(source.data,source.palstart),ptr48(gfxbuf,0),word(1) shl source.bpp);
       15    : pal_32to15(ptr48(source.data,source.palstart),ptr48(gfxbuf,0),word(1) shl source.bpp);
    end;
  end;
  for y := 0 to source.sizey-1 do begin
    proc_conv(ptr48(source.data,source.imagestart),
              ptr48(dest.data,dest.imagestart),source.bpl);
    inc(source.imagestart,source.bpl);
    inc(dest.imagestart,dest.bpl);
  end;
  copy_image := errnoerror;
end;*)


procedure scale_bnk_gen(image : timage;px,py,sx,sy,flags : longint;var mode : tmode);
var
  y           : longint;
  putx,old    : word;
  sizey,scrpos,overlap,datax : word;
  umry,wx,x2,y2 : longint;
  imgpos        : longint;
  scale         : procedure(source,dest : pointer48;count,wx : longint);
  convertdata   : tcnvproc;
  cnvtmp        : pcnvproc;
  origy         : longint;
  { Bilinear Variables}
  fx,fy,fxy,gyab,eyab,gy,ey : longint;
  topval,bottomval,line     : longint;
  biscale                   : procedure(source,dest : pointer48;sx,bpl,topval,bottomval,fx,gyab,eyab : longint);
  biscale_d                 : procedure(source,dest : pointer48;sx,bpl,topval,bottomval,fx,fxy,gyab,eyab : longint);
  downscale                 : boolean;

begin
  if (sx = 0)or(sy = 0) then exit;
  if (image.id <> idimage)or(image.data = 0) then exit;
  if (flags and drbilinear <> 0) then
  begin
    if (image.sizex <= sx)and(image.sizey <= sy)or
       (image.sizex >= sx)and(image.sizey >= sy) then
      downscale := (image.sizex > sx)or(image.sizey > sy)
      else flags := flags and not drbilinear;
  end;

  inc(px,mode.actviewport.x1);
  inc(py,mode.actviewport.y1);
  x2     := px+sx-1;
  y2     := py+sy-1;
  origy  := py;

  imgpos := image.imagestart;

  if (py > mode.actviewport.y2) or (y2 < mode.actviewport.y1) then exit;
  if (px > mode.actviewport.x2) or (x2 < mode.actviewport.x1) then exit;
  if px  < mode.actviewport.x1 then begin
    inc(imgpos,image.pixel*((mode.actviewport.x1-px)*image.sizex div sx));
    px := mode.actviewport.x1;
  end;
  if x2 > mode.actviewport.x2 then x2 := mode.actviewport.x2;
  if py  < mode.actviewport.y1 then begin
    inc(imgpos,image.bpl*((mode.actviewport.y1-py)*image.sizey div sy));
    py := mode.actviewport.y1;
  end;
  if y2 > mode.actviewport.y2 then y2 := mode.actviewport.y2;

  putx  := x2-px+1;
  if putx = 0 then exit;
  scrpos  := mode.calcofs(px,py+mode.pageadd,mode);
  cnvxpos := px;

  if px+sx+mode.actviewport.x1 > mode.actviewport.x2 then putx := mode.maxx+1-px;

  datax := putx*image.pixel;
  putx  := putx*mode.pixel;

  if gfxbufsize-1024 < putx then exit;
  if (flags and drbilinear <> 0) then begin
    if downscale then
    case image.bpp of
      15 : biscale_d := biscaledown_15;
      16 : biscale_d := biscaledown_16;
      24 : biscale_d := biscaledown_24;
      32 : biscale_d := biscaledown_32;
      else exit;
    end else
    case image.bpp of
      15 : biscale := biscale_15;
      16 : biscale := biscale_16;
      24 : biscale := biscale_24;
      32 : biscale := biscale_32;
      else exit;
    end;
    fx := (image.sizex shl 8) div sx;
    fy := (image.sizey shl 8) div sy;
    fxy := (fx*fy) shr 8;
    gy := -fy+py*fy;
    ey := py*fy;
  end else begin
    case image.bpp of
      8     : scale := scale_8;
      15,16 : scale := scale_1516;
      24    : scale := scale_24;
      32    : scale := scale_32;
      else exit;
    end;
    if gfxbufsize-1024 < putx then exit;
    wx := (65536*image.sizex-1) div sx;
    umry   := (py-origy)*image.sizey;
    old    := $FFFF;
  end;

  if image.flags and imsprite = 0 then begin
    if (flags and (drsub or dradd) <> 0) then begin
      if image.bpp <> mode.bpp then exit;
      if (flags and dradd <> 0) then
      case mode.bpp of
        15 : cnvtmp := @add_15;
        16 : cnvtmp := @add_16;
        24 : cnvtmp := @add_24;
        32 : cnvtmp := @add_32;
        else exit;
      end
      else case mode.bpp of
        15 : cnvtmp := @sub_15;
        16 : cnvtmp := @sub_16;
        24 : cnvtmp := @sub_24;
        32 : cnvtmp := @sub_32;
        else exit;
      end;
    end else if (image.flags and imalpha <> 0) then begin
      case mode.bpp of
        15 : cnvtmp := @alpha_15;
        16 : cnvtmp := @alpha_16;
        24 : cnvtmp := @alpha_24;
        32 : cnvtmp := @alpha_32;
        else exit;
      end;
    end else begin
      cnvtmp := getcnvproc(image.bpp,mode.bpp,cnvdrwmd);
      if cnvtmp = nil then exit;
    end;
    convertdata := tcnvproc(cnvtmp);
    if image.bpp <= 8 then begin
      if (image.flags and impalette <> 0) then if
      mode.bpp >= 24 then cnvpal := ptr48(image.data,image.palstart)
      else begin
        if mode.bpp = 16 then
         pal_32to16(ptr48(image.data,image.palstart),ptr48(gfxbufsel,gfxbufsize-1024),word(1) shl image.bpp)
         else
         pal_32to15(ptr48(image.data,image.palstart),ptr48(gfxbufsel,gfxbufsize-1024),word(1) shl image.bpp);
        cnvpal := ptr48(gfxbufsel,gfxbufsize-1024);
      end;
    end;

    if (flags and drbilinear = 0) then
    for y := py to y2 do begin
      if umry div sy <> old then begin
        scale(ptr48(image.data,imgpos),gfxbufptr,datax,wx);
        if y > py then
         inc(imgpos,image.bpl*(umry div sy-old))
         else inc(imgpos,image.bpl);
        old := umry div sy;
      end;
      cnvypos := y;
      if scrpos < scrpos+putx then begin
        convertdata(gfxbufptr,ptr48(mode.writeptr,scrpos),datax);
        asm
          les   di,mode
          mov   ax,es:[di].tmode.bpl.word
          add   scrpos,ax
          jnc   @next
            call   incbank
          @next:
        end;
      end else begin
        overlap := ((0-scrpos)*image.pixel) div mode.pixel;
        if overlap > 0 then
        convertdata(gfxbufptr,ptr48(mode.writeptr,scrpos),overlap);
        incbank;
        cnvxpos := px+(datax-overlap) div mode.pixel;
        if datax-overlap > 0 then
        convertdata(ptr48(gfxbufsel,overlap),ptr48(mode.writeptr,0),datax-overlap);
        inc(scrpos,mode.bpl);
        cnvxpos := px;
      end;
      inc(umry,image.sizey);
    end else { do bilinear scaling }
    if downscale then
    for y := py to y2 do begin
      inc(gy,fy);
      inc(ey,fy);

      gyab := gy shr 8;
      eyab := ey shr 8;
      if (ey and $FF = 0) then dec(eyab);

      bottomval := (gyab+1) shl 8-gy;
      topval    := ey-eyab shl 8;
      biscale_d(ptr48(image.data,image.imagestart),gfxbufptr,
                datax div image.pixel,image.bpl,topval,bottomval,fx,fxy,gyab,eyab);
      cnvypos := y;
      if scrpos < scrpos+putx then begin
        convertdata(gfxbufptr,ptr48(mode.writeptr,scrpos),datax);
        asm
          les   di,mode
          mov   ax,es:[di].tmode.bpl.word
          add   scrpos,ax
          jnc   @next
            call   incbank
          @next:
        end;
      end else begin
        overlap := ((0-scrpos)*image.pixel) div mode.pixel;
        if overlap > 0 then
        convertdata(gfxbufptr,ptr48(mode.writeptr,scrpos),overlap);
        incbank;
        cnvxpos := px+(datax-overlap) div mode.pixel;
        if datax-overlap > 0 then
        convertdata(ptr48(gfxbufsel,overlap),ptr48(mode.writeptr,0),datax-overlap);
        inc(scrpos,mode.bpl);
        cnvxpos := px;
      end;
    end else
    for y := py to y2 do begin
      inc(gy,fy);
      inc(ey,fy);

      gyab := gy shr 8;
      eyab := ey shr 8;
      if (ey and $FF = 0) then dec(eyab);

      line := (eyab shl 16) div fy;
      bottomval := line-y shl 8;
      topval    := (y+1) shl 8-line;
      biscale(ptr48(image.data,image.imagestart),gfxbufptr,datax div image.pixel,image.bpl,topval,bottomval,fx,gyab,eyab);
      cnvypos := y;
      if scrpos < scrpos+putx then begin
        convertdata(gfxbufptr,ptr48(mode.writeptr,scrpos),datax);
        asm
          les   di,mode
          mov   ax,es:[di].tmode.bpl.word
          add   scrpos,ax
          jnc   @next
            call   incbank
          @next:
        end;
      end else begin
        overlap := ((0-scrpos)*image.pixel) div mode.pixel;
        if overlap > 0 then
        convertdata(gfxbufptr,ptr48(mode.writeptr,scrpos),overlap);
        incbank;
        cnvxpos := px+(datax-overlap) div mode.pixel;
        if datax-overlap > 0 then
        convertdata(ptr48(gfxbufsel,overlap),ptr48(mode.writeptr,0),datax-overlap);
        inc(scrpos,mode.bpl);
        cnvxpos := px;
      end;
    end;
  end else {... we have a sprite}
  begin
    if image.bpp <> mode.bpp then exit;
    case mode.bpp of
      8      : movesprite := sprite_8;
      15,16  : movesprite := sprite_1516;
      24     : movesprite := sprite_24;
      32     : movesprite := sprite_32;
      else exit;
    end;
    if (flags and drbilinear = 0) then
    for y := py to y2 do begin
      if umry div sy <> old then begin
        scale(ptr48(image.data,imgpos),gfxbufptr,putx,wx);
        if y > py then
         inc(imgpos,image.bpl*(umry div sy-old))
         else inc(imgpos,image.bpl);
        old := umry div sy;
      end;
      if scrpos < scrpos+putx then begin
        movesprite(gfxbufptr,ptr48(mode.writeptr,scrpos),putx,image.transcol,0,0,1);
        asm
          les   di,mode
          mov   ax,es:[di].tmode.bpl.word
          add   scrpos,ax
          jnc   @next
            call   incbank
          @next:
        end;
      end else begin
        overlap := 0-scrpos;
        movesprite(gfxbufptr,ptr48(mode.writeptr,scrpos),overlap,image.transcol,0,0,1);
        incbank;
        movesprite(ptr48(gfxbufsel,overlap),ptr48(mode.writeptr,0),putx-overlap,image.transcol,0,0,1);
        inc(scrpos,mode.bpl);
      end;
      inc(umry,image.sizey);
    end else
    if downscale then
    for y := py to y2 do begin
      inc(gy,fy);
      inc(ey,fy);

      gyab := gy shr 8;
      eyab := ey shr 8;
      if (ey and $FF = 0) then dec(eyab);

      bottomval := (gyab+1) shl 8-gy;
      topval    := ey-eyab shl 8;
      biscale_d(ptr48(image.data,image.imagestart),gfxbufptr,
                datax div image.pixel,image.bpl,topval,bottomval,fx,fxy,gyab,eyab);
      if scrpos < scrpos+putx then begin
        movesprite(gfxbufptr,ptr48(mode.writeptr,scrpos),putx,image.transcol,0,0,1);
        asm
          les   di,mode
          mov   ax,es:[di].tmode.bpl.word
          add   scrpos,ax
          jnc   @next
            call   incbank
          @next:
        end;
      end else begin
        overlap := 0-scrpos;
        movesprite(gfxbufptr,ptr48(mode.writeptr,scrpos),overlap,image.transcol,0,0,1);
        incbank;
        movesprite(ptr48(gfxbufsel,overlap),ptr48(mode.writeptr,0),putx-overlap,image.transcol,0,0,1);
        inc(scrpos,mode.bpl);
      end;
    end else
    for y := py to y2 do begin
      inc(gy,fy);
      inc(ey,fy);

      gyab := gy shr 8;
      eyab := ey shr 8;
      if (ey and $FF = 0) then dec(eyab);

      line := (eyab shl 16) div fy;
      bottomval := line-y shl 8;
      topval    := (y+1) shl 8-line;
      biscale(ptr48(image.data,image.imagestart),gfxbufptr,datax div image.pixel,image.bpl,topval,bottomval,fx,gyab,eyab);
      if scrpos < scrpos+putx then begin
        movesprite(gfxbufptr,ptr48(mode.writeptr,scrpos),putx,image.transcol,0,0,1);
        asm
          les   di,mode
          mov   ax,es:[di].tmode.bpl.word
          add   scrpos,ax
          jnc   @next
            call   incbank
          @next:
        end;
      end else begin
        overlap := 0-scrpos;
        movesprite(gfxbufptr,ptr48(mode.writeptr,scrpos),overlap,image.transcol,0,0,1);
        incbank;
        movesprite(ptr48(gfxbufsel,overlap),ptr48(mode.writeptr,0),putx-overlap,image.transcol,0,0,1);
        inc(scrpos,mode.bpl);
      end;
    end;
  end;
end;

procedure scale_lin_gen(image : timage;px,py,sx,sy,flags : longint;var mode : tmode);
var
  y,putx,old    : longint;
  umry,wx,x2,y2 : longint;
  imgptr,scrptr : pointer48;
  scale         : procedure(source,dest : pointer48;count,wx : longint);
  convertdata   : tcnvproc;
  cnvtmp        : pcnvproc;
  origy         : longint;
  { Bilinear Variables}
  fx,fy,fxy,gyab,eyab,gy,ey : longint;
  topval,bottomval,line     : longint;
  biscale                   : procedure(source,dest : pointer48;sx,bpl,topval,bottomval,fx,gyab,eyab : longint);
  biscale_d                 : procedure(source,dest : pointer48;sx,bpl,topval,bottomval,fx,fxy,gyab,eyab : longint);
  downscale                 : boolean;
begin
  if (sx = 0)or(sy = 0) then exit;
  if (image.id <> idimage)or(image.data = 0) then exit;
  if (flags and drbilinear <> 0) then
  begin
    if (image.sizex <= sx)and(image.sizey <= sy)or
       (image.sizex >= sx)and(image.sizey >= sy) then
    downscale := (image.sizex > sx)or(image.sizey > sy)
    else flags := flags and not drbilinear;
  end;

  inc(px,mode.actviewport.x1);
  inc(py,mode.actviewport.y1);
  x2     := px+sx-1;
  y2     := py+sy-1;
  origy  := py;

  imgptr := ptr48(image.data,image.imagestart);

  if (py > mode.actviewport.y2) or (y2 < mode.actviewport.y1) then exit;
  if (px > mode.actviewport.x2) or (x2 < mode.actviewport.x1) then exit;
  if px  < mode.actviewport.x1 then begin
    inc(tselofs32(imgptr).offset32,image.pixel*((mode.actviewport.x1-px)*image.sizex div sx));
    px := mode.actviewport.x1;
  end;
  if x2 > mode.actviewport.x2 then x2 := mode.actviewport.x2;
  if py  < mode.actviewport.y1 then begin
    inc(tselofs32(imgptr).offset32,image.bpl*((mode.actviewport.y1-py)*image.sizey div sy));
    py := mode.actviewport.y1;
  end;
  if y2 > mode.actviewport.y2 then y2 := mode.actviewport.y2;

  putx  := x2-px+1;
  if putx = 0 then exit;
  scrptr  := ptr48(mode.writeptr,mode.calcofs(px,py,mode)+mode.displayofs);
  cnvxpos := px;

  if px+sx+mode.actviewport.x1 > mode.actviewport.x2 then putx := mode.maxx+1-px;

  putx := putx*image.pixel;

  if gfxbufsize-1024 < putx then exit;
  if (flags and drbilinear <> 0) then begin
    if downscale then
    case image.bpp of
      15 : biscale_d := biscaledown_15;
      16 : biscale_d := biscaledown_16;
      24 : biscale_d := biscaledown_24;
      32 : biscale_d := biscaledown_32;
      else exit;
    end else
    case image.bpp of
      15 : biscale := biscale_15;
      16 : biscale := biscale_16;
      24 : biscale := biscale_24;
      32 : biscale := biscale_32;
      else exit;
    end;
    fx := (image.sizex shl 8) div sx;
    fy := (image.sizey shl 8) div sy;
    fxy := (fx*fy) shr 8;
    gy := -fy+py*fy;
    ey := py*fy;
  end else begin
    case image.bpp of
      8     : scale := scale_8;
      15,16 : scale := scale_1516;
      24    : scale := scale_24;
      32    : scale := scale_32;
      else exit;
    end;
    if gfxbufsize-1024 < putx then exit;
    wx := (65536*image.sizex-1) div sx;
    umry   := (py-origy)*image.sizey;
    old    := $FFFF;
  end;

  if (image.flags and imsprite = 0) then begin
    if (flags and (drsub+dradd+drand+drxor+dror) <> 0) then begin
      if image.bpp <> mode.bpp then exit;
      case flags and (drsub+dradd+drand+drxor+dror) of
        drdefault : cnvtmp := @move2screen;
        dradd     :
          case mode.bpp of
            15 : cnvtmp := @add_15;
            16 : cnvtmp := @add_16;
            24 : cnvtmp := @add_24;
            32 : cnvtmp := @add_32;
            else exit;
          end;
        drsub     :
          case mode.bpp of
            15 : cnvtmp := @sub_15;
            16 : cnvtmp := @sub_16;
            24 : cnvtmp := @sub_24;
            32 : cnvtmp := @sub_32;
            else exit;
          end;
        drxor     : cnvtmp := @xor2screen;
        drand     : cnvtmp := @and2screen;
        dror      : cnvtmp := @or2screen;
        else exit;
      end;
    end else if (image.flags and imalpha <> 0) then begin
      case mode.bpp of
        15 : cnvtmp := @alpha_15;
        16 : cnvtmp := @alpha_16;
        24 : cnvtmp := @alpha_24;
        32 : cnvtmp := @alpha_32;
        else exit;
      end;
    end else begin
      cnvtmp := getcnvproc(image.bpp,mode.bpp,cnvdrwmd+(flags and drdither));
      if cnvtmp = nil then exit;
    end;
    convertdata := tcnvproc(cnvtmp);
    if image.bpp <= 8 then begin
      if (image.flags and impalette <> 0) then if
      mode.bpp >= 24 then cnvpal := ptr48(image.data,image.palstart)
      else begin
        if mode.bpp = 16 then
         pal_32to16(ptr48(image.data,image.palstart),ptr48(gfxbufsel,gfxbufsize-1024),word(1) shl image.bpp)
         else
         pal_32to15(ptr48(image.data,image.palstart),ptr48(gfxbufsel,gfxbufsize-1024),word(1) shl image.bpp);
        cnvpal := ptr48(gfxbufsel,gfxbufsize-1024);
      end;
    end;

    if (flags and drbilinear = 0) then
    for y := py to y2 do begin
      if umry div sy <> old then begin
        scale(imgptr,gfxbufptr,putx,wx);
        if y > py then
         inc(tselofs32(imgptr).offset32,image.bpl*(umry div sy-old))
         else inc(tselofs32(imgptr).offset32,image.bpl);
        old := umry div sy;
      end;
      cnvypos := y;
      convertdata(gfxbufptr,scrptr,putx);
      inc(umry,image.sizey);
      inc(tselofs32(scrptr).offset32,mode.bpl);
    end else { do bilinear scaling }
    begin
      if downscale then
      for y := py to y2 do begin
        inc(gy,fy);
        inc(ey,fy);

        gyab := gy shr 8;
        eyab := ey shr 8;
        if (ey and $FF = 0) then dec(eyab);

        bottomval := (gyab+1) shl 8-gy;
        topval    := ey-eyab shl 8;
        biscale_d(imgptr,gfxbufptr,putx div image.pixel,image.bpl,topval,bottomval,fx,fxy,gyab,eyab);
        cnvypos := y;
        convertdata(gfxbufptr,scrptr,putx);
        inc(tselofs32(scrptr).offset32,mode.bpl);
      end else
      for y := py to y2 do begin
        inc(gy,fy);
        inc(ey,fy);

        gyab := gy shr 8;
        eyab := ey shr 8;
        if (ey and $FF = 0) then dec(eyab);

        line := (eyab shl 16) div fy;
        bottomval := line-y shl 8;
        topval    := (y+1) shl 8-line;
        biscale(imgptr,gfxbufptr,putx div image.pixel,image.bpl,topval,bottomval,fx,gyab,eyab);
        cnvypos := y;
        convertdata(gfxbufptr,scrptr,putx);
        inc(tselofs32(scrptr).offset32,mode.bpl);
      end;
    end;
  end else {... we have a sprite}
  begin
    if image.bpp <> mode.bpp then exit;
    if (mode.device and dvmemory <> 0) then
    case mode.bpp of
      8      : movesprite := spritemem_8;
      15,16  : movesprite := spritemem_1516;
      24     : movesprite := sprite_24;
      32     : movesprite := spritemem_32;
      else exit;
    end else
    case mode.bpp of
      8      : movesprite := sprite_8;
      15,16  : movesprite := sprite_1516;
      24     : movesprite := sprite_24;
      32     : movesprite := sprite_32;
      else exit;
    end;
    if (flags and drbilinear = 0) then
    for y := py to y2 do begin
      if umry div sy <> old then begin
        scale(imgptr,gfxbufptr,putx,wx);
        if y > py then
         inc(tselofs32(imgptr).offset32,image.bpl*(umry div sy-old))
         else inc(tselofs32(imgptr).offset32,image.bpl);
        old := umry div sy;
      end;
      movesprite(gfxbufptr,scrptr,putx,image.transcol,0,0,1);
      inc(umry,image.sizey);
      inc(tselofs32(scrptr).offset32,mode.bpl);
    end else { do bilinear scaling }
      if downscale then
      for y := py to y2 do begin
        inc(gy,fy);
        inc(ey,fy);

        gyab := gy shr 8;
        eyab := ey shr 8;
        if (ey and $FF = 0) then dec(eyab);

        bottomval := (gyab+1) shl 8-gy;
        topval    := ey-eyab shl 8;
        biscale_d(imgptr,gfxbufptr,putx div image.pixel,image.bpl,topval,bottomval,fx,fxy,gyab,eyab);
        movesprite(gfxbufptr,scrptr,putx,image.transcol,0,0,1);
        inc(tselofs32(scrptr).offset32,mode.bpl);
      end else
      for y := py to y2 do begin
        inc(gy,fy);
        inc(ey,fy);

        gyab := gy shr 8;
        eyab := ey shr 8;
        if (ey and $FF = 0) then dec(eyab);

        line := (eyab shl 16) div fy;
        bottomval := line-y shl 8;
        topval    := (y+1) shl 8-line;
        biscale(imgptr,gfxbufptr,putx div image.pixel,image.bpl,topval,bottomval,fx,gyab,eyab);
        movesprite(gfxbufptr,scrptr,putx,image.transcol,0,0,1);
        inc(tselofs32(scrptr).offset32,mode.bpl);
      end;
  end;
end;


procedure switchcpuext(flags : longint);far;
begin
  if flags and cpummx <> 0 then begin
    add_32           := add_32_mmx;
    sub_32           := sub_32_mmx;
    alpha_32         := alpha_32_mmx;
    blend_32         := blend_32_mmx;
    doublesize_32    := doublesize_32_mmx;
    halfsize_32      := halfsize_32_mmx;
    spritemem_8      := spritemem_8_mmx;
    spritemem_1516   := spritemem_1516_mmx;
    spritemem_32     := spritemem_32_mmx;
  end else begin
    add_32           := add_32_386;
    sub_32           := sub_32_386;
    alpha_32         := alpha_32_386;
    blend_32         := blend_32_386;
    doublesize_32    := doublesize_32_386;
    halfsize_32      := halfsize_32_386;
    spritemem_8      := sprite_8;
    spritemem_1516   := sprite_1516;
    spritemem_32     := sprite_32;
  end;
end;

begin
  registercpuswitch(@switchcpuext);
  switchcpuext(cpuext);
end.

